/* Application.c generated by valac 0.56.15, the Vala compiler
 * generated from Application.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_APPLICATION_0_PROPERTY,
	HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_SCHEME_FACTORY_PROPERTY,
	HE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* he_application_properties[HE_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _he_color_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_color_rgb_color_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeApplicationPrivate {
	HeDesktop* desktop;
	HeStyleManager* style_manager;
	HeColorRGBColor* _default_accent_color;
	gboolean _override_accent_color;
	HeSchemeFactory* _scheme_factory;
};

static gint HeApplication_private_offset;
static gpointer he_application_parent_class = NULL;

static void he_application_update_style_manager (HeApplication* self);
static void he_application_init_app_styles (HeApplication* self);
VALA_EXTERN void he_misc_init_css_provider_from_file (GtkCssProvider* provider,
                                          GFile* file);
static void he_application_real_startup (GApplication* base);
static void _he_application_update_style_manager_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void he_application_finalize (GObject * obj);
static GType he_application_get_type_once (void);
static void _vala_he_application_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_application_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
he_application_get_instance_private (HeApplication* self)
{
	return G_STRUCT_MEMBER_P (self, HeApplication_private_offset);
}

HeColorRGBColor*
he_application_get_default_accent_color (HeApplication* self)
{
	HeColorRGBColor* result;
	HeColorRGBColor* _tmp0_;
#line 32 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../lib/Models/Application.vala"
	_tmp0_ = self->priv->_default_accent_color;
#line 32 "../lib/Models/Application.vala"
	result = _tmp0_;
#line 32 "../lib/Models/Application.vala"
	return result;
#line 104 "Application.c"
}

static gpointer
_he_color_rgb_color_dup0 (gpointer self)
{
#line 33 "../lib/Models/Application.vala"
	return self ? he_color_rgb_color_dup (self) : NULL;
#line 112 "Application.c"
}

void
he_application_set_default_accent_color (HeApplication* self,
                                         HeColorRGBColor* value)
{
	HeColorRGBColor* _tmp0_;
#line 33 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/Models/Application.vala"
	_tmp0_ = _he_color_rgb_color_dup0 (value);
#line 33 "../lib/Models/Application.vala"
	_he_color_rgb_color_free0 (self->priv->_default_accent_color);
#line 33 "../lib/Models/Application.vala"
	self->priv->_default_accent_color = _tmp0_;
#line 33 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 33 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY]);
#line 132 "Application.c"
}

gboolean
he_application_get_override_accent_color (HeApplication* self)
{
	gboolean result;
#line 41 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../lib/Models/Application.vala"
	result = self->priv->_override_accent_color;
#line 41 "../lib/Models/Application.vala"
	return result;
#line 145 "Application.c"
}

void
he_application_set_override_accent_color (HeApplication* self,
                                          gboolean value)
{
#line 42 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 42 "../lib/Models/Application.vala"
	self->priv->_override_accent_color = value;
#line 42 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 42 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY]);
#line 160 "Application.c"
}

HeSchemeFactory*
he_application_get_scheme_factory (HeApplication* self)
{
	HeSchemeFactory* result;
	HeSchemeFactory* _tmp0_;
#line 51 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../lib/Models/Application.vala"
	_tmp0_ = self->priv->_scheme_factory;
#line 51 "../lib/Models/Application.vala"
	result = _tmp0_;
#line 51 "../lib/Models/Application.vala"
	return result;
#line 176 "Application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../lib/Models/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 184 "Application.c"
}

void
he_application_set_scheme_factory (HeApplication* self,
                                   HeSchemeFactory* value)
{
	HeSchemeFactory* _tmp0_;
#line 52 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 52 "../lib/Models/Application.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 52 "../lib/Models/Application.vala"
	_g_object_unref0 (self->priv->_scheme_factory);
#line 52 "../lib/Models/Application.vala"
	self->priv->_scheme_factory = _tmp0_;
#line 52 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 52 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_SCHEME_FACTORY_PROPERTY]);
#line 204 "Application.c"
}

static void
he_application_update_style_manager (HeApplication* self)
{
	gboolean _tmp0_ = FALSE;
	HeColorRGBColor* _tmp1_;
	HeColorRGBColor* _tmp2_;
	HeSchemeFactory* _tmp21_;
	HeSchemeFactory* _tmp22_;
	HeStyleManager* _tmp39_;
	HeDesktop* _tmp40_;
	HeDesktopColorScheme _tmp41_;
	HeDesktopColorScheme _tmp42_;
	HeStyleManager* _tmp43_;
	HeDesktop* _tmp44_;
	HeDesktopContrastScheme _tmp45_;
	HeDesktopContrastScheme _tmp46_;
	HeStyleManager* _tmp47_;
	HeDesktop* _tmp48_;
	gdouble _tmp49_;
	gdouble _tmp50_;
	HeStyleManager* _tmp51_;
	HeDesktop* _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_;
	HeStyleManager* _tmp55_;
#line 55 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 56 "../lib/Models/Application.vala"
	_tmp1_ = he_application_get_default_accent_color (self);
#line 56 "../lib/Models/Application.vala"
	_tmp2_ = _tmp1_;
#line 56 "../lib/Models/Application.vala"
	if (_tmp2_ != NULL) {
#line 240 "Application.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 56 "../lib/Models/Application.vala"
		_tmp3_ = he_application_get_override_accent_color (self);
#line 56 "../lib/Models/Application.vala"
		_tmp4_ = _tmp3_;
#line 56 "../lib/Models/Application.vala"
		_tmp0_ = _tmp4_;
#line 249 "Application.c"
	} else {
#line 56 "../lib/Models/Application.vala"
		_tmp0_ = FALSE;
#line 253 "Application.c"
	}
#line 56 "../lib/Models/Application.vala"
	if (_tmp0_) {
#line 257 "Application.c"
		HeStyleManager* _tmp5_;
		HeColorRGBColor* _tmp6_;
		HeColorRGBColor* _tmp7_;
		HeColorRGBColor* _tmp8_;
#line 57 "../lib/Models/Application.vala"
		_tmp5_ = self->priv->style_manager;
#line 57 "../lib/Models/Application.vala"
		_tmp6_ = he_application_get_default_accent_color (self);
#line 57 "../lib/Models/Application.vala"
		_tmp7_ = _tmp6_;
#line 57 "../lib/Models/Application.vala"
		_tmp8_ = _he_color_rgb_color_dup0 (_tmp7_);
#line 57 "../lib/Models/Application.vala"
		_he_color_rgb_color_free0 (_tmp5_->accent_color);
#line 57 "../lib/Models/Application.vala"
		_tmp5_->accent_color = _tmp8_;
#line 274 "Application.c"
	} else {
		HeDesktop* _tmp9_;
		HeColorRGBColor* _tmp10_;
		HeColorRGBColor* _tmp11_;
#line 58 "../lib/Models/Application.vala"
		_tmp9_ = self->priv->desktop;
#line 58 "../lib/Models/Application.vala"
		_tmp10_ = he_desktop_get_accent_color (_tmp9_);
#line 58 "../lib/Models/Application.vala"
		_tmp11_ = _tmp10_;
#line 58 "../lib/Models/Application.vala"
		if (_tmp11_ != NULL) {
#line 287 "Application.c"
			HeStyleManager* _tmp12_;
			HeDesktop* _tmp13_;
			HeColorRGBColor* _tmp14_;
			HeColorRGBColor* _tmp15_;
			HeColorRGBColor* _tmp16_;
#line 59 "../lib/Models/Application.vala"
			_tmp12_ = self->priv->style_manager;
#line 59 "../lib/Models/Application.vala"
			_tmp13_ = self->priv->desktop;
#line 59 "../lib/Models/Application.vala"
			_tmp14_ = he_desktop_get_accent_color (_tmp13_);
#line 59 "../lib/Models/Application.vala"
			_tmp15_ = _tmp14_;
#line 59 "../lib/Models/Application.vala"
			_tmp16_ = _he_color_rgb_color_dup0 (_tmp15_);
#line 59 "../lib/Models/Application.vala"
			_he_color_rgb_color_free0 (_tmp12_->accent_color);
#line 59 "../lib/Models/Application.vala"
			_tmp12_->accent_color = _tmp16_;
#line 307 "Application.c"
		} else {
			HeStyleManager* _tmp17_;
			HeColorRGBColor* _tmp18_;
			HeColorRGBColor* _tmp19_;
			HeColorRGBColor* _tmp20_;
#line 61 "../lib/Models/Application.vala"
			_tmp17_ = self->priv->style_manager;
#line 61 "../lib/Models/Application.vala"
			_tmp18_ = he_application_get_default_accent_color (self);
#line 61 "../lib/Models/Application.vala"
			_tmp19_ = _tmp18_;
#line 61 "../lib/Models/Application.vala"
			_tmp20_ = _he_color_rgb_color_dup0 (_tmp19_);
#line 61 "../lib/Models/Application.vala"
			_he_color_rgb_color_free0 (_tmp17_->accent_color);
#line 61 "../lib/Models/Application.vala"
			_tmp17_->accent_color = _tmp20_;
#line 325 "Application.c"
		}
	}
#line 64 "../lib/Models/Application.vala"
	_tmp21_ = he_application_get_scheme_factory (self);
#line 64 "../lib/Models/Application.vala"
	_tmp22_ = _tmp21_;
#line 64 "../lib/Models/Application.vala"
	if (_tmp22_ != NULL) {
#line 334 "Application.c"
		HeStyleManager* _tmp23_;
		HeSchemeFactory* _tmp24_;
		HeSchemeFactory* _tmp25_;
		HeSchemeFactory* _tmp26_;
#line 65 "../lib/Models/Application.vala"
		_tmp23_ = self->priv->style_manager;
#line 65 "../lib/Models/Application.vala"
		_tmp24_ = he_application_get_scheme_factory (self);
#line 65 "../lib/Models/Application.vala"
		_tmp25_ = _tmp24_;
#line 65 "../lib/Models/Application.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 65 "../lib/Models/Application.vala"
		_g_object_unref0 (_tmp23_->scheme_factory);
#line 65 "../lib/Models/Application.vala"
		_tmp23_->scheme_factory = _tmp26_;
#line 351 "Application.c"
	} else {
		gboolean _tmp27_ = FALSE;
		HeSchemeFactory* _tmp28_;
		HeSchemeFactory* _tmp29_;
#line 66 "../lib/Models/Application.vala"
		_tmp28_ = he_application_get_scheme_factory (self);
#line 66 "../lib/Models/Application.vala"
		_tmp29_ = _tmp28_;
#line 66 "../lib/Models/Application.vala"
		if (_tmp29_ != NULL) {
#line 362 "Application.c"
			gboolean _tmp30_;
			gboolean _tmp31_;
#line 66 "../lib/Models/Application.vala"
			_tmp30_ = he_application_get_override_accent_color (self);
#line 66 "../lib/Models/Application.vala"
			_tmp31_ = _tmp30_;
#line 66 "../lib/Models/Application.vala"
			_tmp27_ = _tmp31_;
#line 371 "Application.c"
		} else {
#line 66 "../lib/Models/Application.vala"
			_tmp27_ = FALSE;
#line 375 "Application.c"
		}
#line 66 "../lib/Models/Application.vala"
		if (_tmp27_) {
#line 379 "Application.c"
			HeStyleManager* _tmp32_;
			HeContentScheme* _tmp33_;
#line 67 "../lib/Models/Application.vala"
			_tmp32_ = self->priv->style_manager;
#line 67 "../lib/Models/Application.vala"
			_tmp33_ = he_content_scheme_new ();
#line 67 "../lib/Models/Application.vala"
			_g_object_unref0 (_tmp32_->scheme_factory);
#line 67 "../lib/Models/Application.vala"
			_tmp32_->scheme_factory = (HeSchemeFactory*) _tmp33_;
#line 390 "Application.c"
		} else {
			HeStyleManager* _tmp34_;
			HeDesktop* _tmp35_;
			HeDesktopEnsorScheme _tmp36_;
			HeDesktopEnsorScheme _tmp37_;
			HeSchemeFactory* _tmp38_;
#line 69 "../lib/Models/Application.vala"
			_tmp34_ = self->priv->style_manager;
#line 69 "../lib/Models/Application.vala"
			_tmp35_ = self->priv->desktop;
#line 69 "../lib/Models/Application.vala"
			_tmp36_ = he_desktop_get_ensor_scheme (_tmp35_);
#line 69 "../lib/Models/Application.vala"
			_tmp37_ = _tmp36_;
#line 69 "../lib/Models/Application.vala"
			_tmp38_ = he_desktop_ensor_scheme_to_factory (_tmp37_);
#line 69 "../lib/Models/Application.vala"
			_g_object_unref0 (_tmp34_->scheme_factory);
#line 69 "../lib/Models/Application.vala"
			_tmp34_->scheme_factory = _tmp38_;
#line 411 "Application.c"
		}
	}
#line 72 "../lib/Models/Application.vala"
	_tmp39_ = self->priv->style_manager;
#line 72 "../lib/Models/Application.vala"
	_tmp40_ = self->priv->desktop;
#line 72 "../lib/Models/Application.vala"
	_tmp41_ = he_desktop_get_prefers_color_scheme (_tmp40_);
#line 72 "../lib/Models/Application.vala"
	_tmp42_ = _tmp41_;
#line 72 "../lib/Models/Application.vala"
	_tmp39_->is_dark = _tmp42_ == HE_DESKTOP_COLOR_SCHEME_DARK;
#line 73 "../lib/Models/Application.vala"
	_tmp43_ = self->priv->style_manager;
#line 73 "../lib/Models/Application.vala"
	_tmp44_ = self->priv->desktop;
#line 73 "../lib/Models/Application.vala"
	_tmp45_ = he_desktop_get_contrast (_tmp44_);
#line 73 "../lib/Models/Application.vala"
	_tmp46_ = _tmp45_;
#line 73 "../lib/Models/Application.vala"
	_tmp43_->is_contrast = _tmp46_ == HE_DESKTOP_CONTRAST_SCHEME_HIGH;
#line 74 "../lib/Models/Application.vala"
	_tmp47_ = self->priv->style_manager;
#line 74 "../lib/Models/Application.vala"
	_tmp48_ = self->priv->desktop;
#line 74 "../lib/Models/Application.vala"
	_tmp49_ = he_desktop_get_font_weight (_tmp48_);
#line 74 "../lib/Models/Application.vala"
	_tmp50_ = _tmp49_;
#line 74 "../lib/Models/Application.vala"
	_tmp47_->font_weight = _tmp50_;
#line 75 "../lib/Models/Application.vala"
	_tmp51_ = self->priv->style_manager;
#line 75 "../lib/Models/Application.vala"
	_tmp52_ = self->priv->desktop;
#line 75 "../lib/Models/Application.vala"
	_tmp53_ = he_desktop_get_roundness (_tmp52_);
#line 75 "../lib/Models/Application.vala"
	_tmp54_ = _tmp53_;
#line 75 "../lib/Models/Application.vala"
	_tmp51_->roundness = _tmp54_;
#line 77 "../lib/Models/Application.vala"
	_tmp55_ = self->priv->style_manager;
#line 77 "../lib/Models/Application.vala"
	he_style_manager_update (_tmp55_);
#line 458 "Application.c"
}

static void
he_application_init_app_styles (HeApplication* self)
{
	gchar* base_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* base_uri = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* base_file = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	HeStyleManager* _tmp7_;
	GtkCssProvider* _tmp8_;
	GtkCssProvider* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	HeStyleManager* _tmp13_;
	GtkCssProvider* _tmp14_;
	GtkCssProvider* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
#line 80 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 81 "../lib/Models/Application.vala"
	_tmp0_ = g_application_get_resource_base_path ((GApplication*) self);
#line 81 "../lib/Models/Application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 81 "../lib/Models/Application.vala"
	base_path = _tmp1_;
#line 82 "../lib/Models/Application.vala"
	_tmp2_ = base_path;
#line 82 "../lib/Models/Application.vala"
	if (_tmp2_ == NULL) {
#line 83 "../lib/Models/Application.vala"
		_g_free0 (base_path);
#line 83 "../lib/Models/Application.vala"
		return;
#line 502 "Application.c"
	}
#line 86 "../lib/Models/Application.vala"
	_tmp3_ = base_path;
#line 86 "../lib/Models/Application.vala"
	_tmp4_ = g_strconcat ("resource://", _tmp3_, NULL);
#line 86 "../lib/Models/Application.vala"
	base_uri = _tmp4_;
#line 87 "../lib/Models/Application.vala"
	_tmp5_ = base_uri;
#line 87 "../lib/Models/Application.vala"
	_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 87 "../lib/Models/Application.vala"
	base_file = _tmp6_;
#line 89 "../lib/Models/Application.vala"
	_tmp7_ = self->priv->style_manager;
#line 89 "../lib/Models/Application.vala"
	_tmp8_ = he_style_manager_get_user_base (_tmp7_);
#line 89 "../lib/Models/Application.vala"
	_tmp9_ = _tmp8_;
#line 89 "../lib/Models/Application.vala"
	_tmp10_ = base_file;
#line 89 "../lib/Models/Application.vala"
	_tmp11_ = g_file_get_child (_tmp10_, "style.css");
#line 89 "../lib/Models/Application.vala"
	_tmp12_ = _tmp11_;
#line 89 "../lib/Models/Application.vala"
	he_misc_init_css_provider_from_file (_tmp9_, _tmp12_);
#line 89 "../lib/Models/Application.vala"
	_g_object_unref0 (_tmp12_);
#line 90 "../lib/Models/Application.vala"
	_tmp13_ = self->priv->style_manager;
#line 90 "../lib/Models/Application.vala"
	_tmp14_ = he_style_manager_get_user_dark (_tmp13_);
#line 90 "../lib/Models/Application.vala"
	_tmp15_ = _tmp14_;
#line 90 "../lib/Models/Application.vala"
	_tmp16_ = base_file;
#line 90 "../lib/Models/Application.vala"
	_tmp17_ = g_file_get_child (_tmp16_, "style-dark.css");
#line 90 "../lib/Models/Application.vala"
	_tmp18_ = _tmp17_;
#line 90 "../lib/Models/Application.vala"
	he_misc_init_css_provider_from_file (_tmp15_, _tmp18_);
#line 90 "../lib/Models/Application.vala"
	_g_object_unref0 (_tmp18_);
#line 80 "../lib/Models/Application.vala"
	_g_object_unref0 (base_file);
#line 80 "../lib/Models/Application.vala"
	_g_free0 (base_uri);
#line 80 "../lib/Models/Application.vala"
	_g_free0 (base_path);
#line 554 "Application.c"
}

static void
_he_application_update_style_manager_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 99 "../lib/Models/Application.vala"
	he_application_update_style_manager ((HeApplication*) self);
#line 564 "Application.c"
}

static void
he_application_real_startup (GApplication* base)
{
	HeApplication * self;
	HeDesktop* _tmp0_;
	HeDesktop* _tmp1_;
	HeDesktop* _tmp2_;
	HeDesktop* _tmp3_;
	HeDesktop* _tmp4_;
	HeDesktop* _tmp5_;
	HeStyleManager* _tmp6_;
#line 93 "../lib/Models/Application.vala"
	self = (HeApplication*) base;
#line 94 "../lib/Models/Application.vala"
	he_init ();
#line 96 "../lib/Models/Application.vala"
	he_application_init_app_styles (self);
#line 97 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 99 "../lib/Models/Application.vala"
	_tmp0_ = self->priv->desktop;
#line 99 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::accent-color", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 100 "../lib/Models/Application.vala"
	_tmp1_ = self->priv->desktop;
#line 100 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::ensor-scheme", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 101 "../lib/Models/Application.vala"
	_tmp2_ = self->priv->desktop;
#line 101 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::font-weight", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 102 "../lib/Models/Application.vala"
	_tmp3_ = self->priv->desktop;
#line 102 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::prefers-color-scheme", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 103 "../lib/Models/Application.vala"
	_tmp4_ = self->priv->desktop;
#line 103 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::contrast", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 104 "../lib/Models/Application.vala"
	_tmp5_ = self->priv->desktop;
#line 104 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::roundness", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 106 "../lib/Models/Application.vala"
	_tmp6_ = self->priv->style_manager;
#line 106 "../lib/Models/Application.vala"
	he_style_manager_register (_tmp6_);
#line 107 "../lib/Models/Application.vala"
	G_APPLICATION_CLASS (he_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 616 "Application.c"
}

/**
   * Creates a new application.
   *
   * @param application_id The application ID in reverse domain name notation
   * @param flags The application flags, as defined in GIO.ApplicationFlags
   */
HeApplication*
he_application_construct (GType object_type,
                          const gchar* application_id,
                          GApplicationFlags flags)
{
	HeApplication * self = NULL;
#line 116 "../lib/Models/Application.vala"
	self = (HeApplication*) g_object_new (object_type, NULL);
#line 117 "../lib/Models/Application.vala"
	g_application_set_application_id ((GApplication*) self, application_id);
#line 118 "../lib/Models/Application.vala"
	g_application_set_flags ((GApplication*) self, flags);
#line 116 "../lib/Models/Application.vala"
	return self;
#line 639 "Application.c"
}

HeApplication*
he_application_new (const gchar* application_id,
                    GApplicationFlags flags)
{
#line 116 "../lib/Models/Application.vala"
	return he_application_construct (HE_TYPE_APPLICATION, application_id, flags);
#line 648 "Application.c"
}

static void
he_application_class_init (HeApplicationClass * klass,
                           gpointer klass_data)
{
#line 23 "../lib/Models/Application.vala"
	he_application_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Models/Application.vala"
	g_type_class_adjust_private_offset (klass, &HeApplication_private_offset);
#line 23 "../lib/Models/Application.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) he_application_real_startup;
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_application_get_property;
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_application_set_property;
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = he_application_finalize;
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("default-accent-color", "default-accent-color", "default-accent-color", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY] = g_param_spec_boolean ("override-accent-color", "override-accent-color", "override-accent-color", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_SCHEME_FACTORY_PROPERTY, he_application_properties[HE_APPLICATION_SCHEME_FACTORY_PROPERTY] = g_param_spec_object ("scheme-factory", "scheme-factory", "scheme-factory", HE_TYPE_SCHEME_FACTORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 673 "Application.c"
}

static void
he_application_instance_init (HeApplication * self,
                              gpointer klass)
{
	HeDesktop* _tmp0_;
	HeStyleManager* _tmp1_;
#line 23 "../lib/Models/Application.vala"
	self->priv = he_application_get_instance_private (self);
#line 24 "../lib/Models/Application.vala"
	_tmp0_ = he_desktop_new ();
#line 24 "../lib/Models/Application.vala"
	self->priv->desktop = _tmp0_;
#line 25 "../lib/Models/Application.vala"
	_tmp1_ = he_style_manager_new ();
#line 25 "../lib/Models/Application.vala"
	self->priv->style_manager = _tmp1_;
#line 30 "../lib/Models/Application.vala"
	self->priv->_default_accent_color = NULL;
#line 39 "../lib/Models/Application.vala"
	self->priv->_override_accent_color = FALSE;
#line 49 "../lib/Models/Application.vala"
	self->priv->_scheme_factory = NULL;
#line 698 "Application.c"
}

static void
he_application_finalize (GObject * obj)
{
	HeApplication * self;
#line 23 "../lib/Models/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION, HeApplication);
#line 24 "../lib/Models/Application.vala"
	_g_object_unref0 (self->priv->desktop);
#line 25 "../lib/Models/Application.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 30 "../lib/Models/Application.vala"
	_he_color_rgb_color_free0 (self->priv->_default_accent_color);
#line 49 "../lib/Models/Application.vala"
	_g_object_unref0 (self->priv->_scheme_factory);
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (he_application_parent_class)->finalize (obj);
#line 717 "Application.c"
}

/**
* An application.
*/
static GType
he_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeApplication), 0, (GInstanceInitFunc) he_application_instance_init, NULL };
	GType he_application_type_id;
	he_application_type_id = g_type_register_static (gtk_application_get_type (), "HeApplication", &g_define_type_info, 0);
	HeApplication_private_offset = g_type_add_instance_private (he_application_type_id, sizeof (HeApplicationPrivate));
	return he_application_type_id;
}

GType
he_application_get_type (void)
{
	static volatile gsize he_application_type_id__once = 0;
	if (g_once_init_enter (&he_application_type_id__once)) {
		GType he_application_type_id;
		he_application_type_id = he_application_get_type_once ();
		g_once_init_leave (&he_application_type_id__once, he_application_type_id);
	}
	return he_application_type_id__once;
}

static void
_vala_he_application_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
#line 23 "../lib/Models/Application.vala"
	switch (property_id) {
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
#line 757 "Application.c"
		{
			HeColorRGBColor* boxed;
#line 23 "../lib/Models/Application.vala"
			boxed = he_application_get_default_accent_color (self);
#line 23 "../lib/Models/Application.vala"
			g_value_set_boxed (value, boxed);
#line 764 "Application.c"
		}
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_boolean (value, he_application_get_override_accent_color (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_SCHEME_FACTORY_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_object (value, he_application_get_scheme_factory (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 780 "Application.c"
		default:
#line 23 "../lib/Models/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Models/Application.vala"
		break;
#line 786 "Application.c"
	}
}

static void
_vala_he_application_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
#line 23 "../lib/Models/Application.vala"
	switch (property_id) {
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_default_accent_color (self, g_value_get_boxed (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_override_accent_color (self, g_value_get_boolean (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_SCHEME_FACTORY_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_scheme_factory (self, g_value_get_object (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 818 "Application.c"
		default:
#line 23 "../lib/Models/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Models/Application.vala"
		break;
#line 824 "Application.c"
	}
}

