/* StyleManager.c generated by valac 0.56.15, the Vala compiler
 * generated from StyleManager.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM GTK_STYLE_PROVIDER_PRIORITY_THEME
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT GTK_STYLE_PROVIDER_PRIORITY_SETTINGS
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE GTK_STYLE_PROVIDER_PRIORITY_APPLICATION
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 1)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_STYLE_MANAGER_0_PROPERTY,
	HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY,
	HE_STYLE_MANAGER_USER_BASE_PROPERTY,
	HE_STYLE_MANAGER_USER_DARK_PROPERTY,
	HE_STYLE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* he_style_manager_properties[HE_STYLE_MANAGER_NUM_PROPERTIES];
#define _he_color_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_color_rgb_color_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeStyleManagerPrivate {
	gboolean _is_registered;
	GtkCssProvider* light;
	GtkCssProvider* dark;
	GtkCssProvider* accent;
	GtkCssProvider* _user_base;
	GtkCssProvider* _user_dark;
};

static gint HeStyleManager_private_offset;
static gpointer he_style_manager_parent_class = NULL;

static void he_style_manager_set_is_registered (HeStyleManager* self,
                                         gboolean value);
VALA_EXTERN void he_misc_init_css_provider_from_string (GtkCssProvider* provider,
                                            const gchar* css);
VALA_EXTERN void he_misc_toggle_style_provider (GtkStyleProvider* provider,
                                    gboolean enabled,
                                    gint priority);
static void he_style_manager_finalize (GObject * obj);
static GType he_style_manager_get_type_once (void);
static void _vala_he_style_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_he_style_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

VALA_EXTERN const HeColorRGBColor HE_COLOR_DEFAULT_DARK_ACCENT;
VALA_EXTERN const HeColorRGBColor HE_COLOR_DEFAULT_LIGHT_ACCENT;

static inline gpointer
he_style_manager_get_instance_private (HeStyleManager* self)
{
	return G_STRUCT_MEMBER_P (self, HeStyleManager_private_offset);
}

gboolean
he_style_manager_get_is_registered (HeStyleManager* self)
{
	gboolean result;
#line 58 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../lib/Models/StyleManager.vala"
	result = self->priv->_is_registered;
#line 58 "../lib/Models/StyleManager.vala"
	return result;
#line 107 "StyleManager.c"
}

static void
he_style_manager_set_is_registered (HeStyleManager* self,
                                    gboolean value)
{
	gboolean old_value;
#line 58 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 58 "../lib/Models/StyleManager.vala"
	old_value = he_style_manager_get_is_registered (self);
#line 58 "../lib/Models/StyleManager.vala"
	if (old_value != value) {
#line 58 "../lib/Models/StyleManager.vala"
		self->priv->_is_registered = value;
#line 58 "../lib/Models/StyleManager.vala"
		g_object_notify_by_pspec ((GObject *) self, he_style_manager_properties[HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY]);
#line 125 "StyleManager.c"
	}
}

GtkCssProvider*
he_style_manager_get_user_base (HeStyleManager* self)
{
	GtkCssProvider* result;
	GtkCssProvider* _tmp0_;
#line 72 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->_user_base;
#line 72 "../lib/Models/StyleManager.vala"
	result = _tmp0_;
#line 72 "../lib/Models/StyleManager.vala"
	return result;
#line 142 "StyleManager.c"
}

GtkCssProvider*
he_style_manager_get_user_dark (HeStyleManager* self)
{
	GtkCssProvider* result;
	GtkCssProvider* _tmp0_;
#line 76 "../lib/Models/StyleManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->_user_dark;
#line 76 "../lib/Models/StyleManager.vala"
	result = _tmp0_;
#line 76 "../lib/Models/StyleManager.vala"
	return result;
#line 158 "StyleManager.c"
}

/**
  * Runs all the necessary updates to apply the current style. If is_registered is false, this will do nothing.
  */
static gpointer
_he_color_rgb_color_dup0 (gpointer self)
{
#line 85 "../lib/Models/StyleManager.vala"
	return self ? he_color_rgb_color_dup (self) : NULL;
#line 169 "StyleManager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 182 "StyleManager.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 213 "StyleManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 416 "../lib/Models/StyleManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 221 "StyleManager.c"
}

void
he_style_manager_update (HeStyleManager* self)
{
	gboolean _tmp0_;
	HeColorRGBColor* _tmp1_ = NULL;
	HeColorRGBColor* _tmp2_;
	HeColorRGBColor* rgb_color = NULL;
	HeColorRGBColor* _tmp5_;
	gdouble base_weight = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble base_roundness = 0.0;
	HeColorCAM16Color cam16_color = {0};
	HeColorRGBColor* _tmp7_;
	HeColorRGBColor _tmp8_;
	HeColorXYZColor _tmp9_ = {0};
	HeColorCAM16Color _tmp10_ = {0};
	HeScheme chosen_scheme = {0};
	HeSchemeFactory* _tmp11_;
	HeColorCAM16Color _tmp12_;
	HeScheme _tmp13_ = {0};
	HeColorHCTColor _tmp14_ = {0};
	HeColorHCTColor error_hct = {0};
	gchar* error_hex = NULL;
	HeColorHCTColor _tmp29_;
	HeColorHCTColor _tmp30_;
	HeColorHCTColor _tmp31_;
	gchar* _tmp32_;
	HeColorHCTColor _tmp33_ = {0};
	HeColorHCTColor on_error_hct = {0};
	gchar* on_error_hex = NULL;
	HeColorHCTColor _tmp44_;
	HeColorHCTColor _tmp45_;
	HeColorHCTColor _tmp46_;
	gchar* _tmp47_;
	HeColorHCTColor _tmp48_ = {0};
	HeColorHCTColor error_container_hct = {0};
	gchar* error_container_hex = NULL;
	HeColorHCTColor _tmp63_;
	HeColorHCTColor _tmp64_;
	HeColorHCTColor _tmp65_;
	gchar* _tmp66_;
	HeColorHCTColor _tmp67_ = {0};
	HeColorHCTColor on_error_container_hct = {0};
	gchar* on_error_container_hex = NULL;
	HeColorHCTColor _tmp78_;
	HeColorHCTColor _tmp79_;
	HeColorHCTColor _tmp80_;
	gchar* _tmp81_;
	HeColorHCTColor _tmp82_ = {0};
	HeColorHCTColor meson_red_hct = {0};
	gchar* meson_red_hex = NULL;
	HeColorHCTColor _tmp97_;
	HeColorHCTColor _tmp98_;
	HeColorHCTColor _tmp99_;
	gchar* _tmp100_;
	HeColorHCTColor _tmp101_ = {0};
	HeColorHCTColor lepton_orange_hct = {0};
	gchar* lepton_orange_hex = NULL;
	HeColorHCTColor _tmp116_;
	HeColorHCTColor _tmp117_;
	HeColorHCTColor _tmp118_;
	gchar* _tmp119_;
	HeColorHCTColor _tmp120_ = {0};
	HeColorHCTColor electron_yellow_hct = {0};
	gchar* electron_yellow_hex = NULL;
	HeColorHCTColor _tmp135_;
	HeColorHCTColor _tmp136_;
	HeColorHCTColor _tmp137_;
	gchar* _tmp138_;
	HeColorHCTColor _tmp139_ = {0};
	HeColorHCTColor muon_green_hct = {0};
	gchar* muon_green_hex = NULL;
	HeColorHCTColor _tmp154_;
	HeColorHCTColor _tmp155_;
	HeColorHCTColor _tmp156_;
	gchar* _tmp157_;
	HeColorHCTColor _tmp158_ = {0};
	HeColorHCTColor baryon_mint_hct = {0};
	gchar* baryon_mint_hex = NULL;
	HeColorHCTColor _tmp173_;
	HeColorHCTColor _tmp174_;
	HeColorHCTColor _tmp175_;
	gchar* _tmp176_;
	HeColorHCTColor _tmp177_ = {0};
	HeColorHCTColor proton_blue_hct = {0};
	gchar* proton_blue_hex = NULL;
	HeColorHCTColor _tmp192_;
	HeColorHCTColor _tmp193_;
	HeColorHCTColor _tmp194_;
	gchar* _tmp195_;
	HeColorHCTColor _tmp196_ = {0};
	HeColorHCTColor photon_indigo_hct = {0};
	gchar* photon_indigo_hex = NULL;
	HeColorHCTColor _tmp211_;
	HeColorHCTColor _tmp212_;
	HeColorHCTColor _tmp213_;
	gchar* _tmp214_;
	HeColorHCTColor _tmp215_ = {0};
	HeColorHCTColor tau_purple_hct = {0};
	gchar* tau_purple_hex = NULL;
	HeColorHCTColor _tmp230_;
	HeColorHCTColor _tmp231_;
	HeColorHCTColor _tmp232_;
	gchar* _tmp233_;
	HeColorHCTColor _tmp234_ = {0};
	HeColorHCTColor fermion_pink_hct = {0};
	gchar* fermion_pink_hex = NULL;
	HeColorHCTColor _tmp249_;
	HeColorHCTColor _tmp250_;
	HeColorHCTColor _tmp251_;
	gchar* _tmp252_;
	HeColorHCTColor _tmp253_ = {0};
	HeColorHCTColor gluon_brown_hct = {0};
	gchar* gluon_brown_hex = NULL;
	HeColorHCTColor _tmp268_;
	HeColorHCTColor _tmp269_;
	HeColorHCTColor _tmp270_;
	gchar* _tmp271_;
	gchar* css = NULL;
	gchar* _tmp272_;
	HeScheme _tmp273_;
	const gchar* _tmp274_;
	const gchar* _tmp275_;
	HeScheme _tmp276_;
	const gchar* _tmp277_;
	const gchar* _tmp278_;
	HeScheme _tmp279_;
	const gchar* _tmp280_;
	const gchar* _tmp281_;
	HeScheme _tmp282_;
	const gchar* _tmp283_;
	const gchar* _tmp284_;
	HeScheme _tmp285_;
	const gchar* _tmp286_;
	const gchar* _tmp287_;
	HeScheme _tmp288_;
	const gchar* _tmp289_;
	const gchar* _tmp290_;
	HeScheme _tmp291_;
	const gchar* _tmp292_;
	const gchar* _tmp293_;
	HeScheme _tmp294_;
	const gchar* _tmp295_;
	const gchar* _tmp296_;
	HeScheme _tmp297_;
	const gchar* _tmp298_;
	const gchar* _tmp299_;
	HeScheme _tmp300_;
	const gchar* _tmp301_;
	const gchar* _tmp302_;
	HeScheme _tmp303_;
	const gchar* _tmp304_;
	const gchar* _tmp305_;
	HeScheme _tmp306_;
	const gchar* _tmp307_;
	const gchar* _tmp308_;
	HeScheme _tmp309_;
	const gchar* _tmp310_;
	const gchar* _tmp311_;
	HeScheme _tmp312_;
	const gchar* _tmp313_;
	const gchar* _tmp314_;
	HeScheme _tmp315_;
	const gchar* _tmp316_;
	const gchar* _tmp317_;
	HeScheme _tmp318_;
	const gchar* _tmp319_;
	const gchar* _tmp320_;
	HeScheme _tmp321_;
	const gchar* _tmp322_;
	const gchar* _tmp323_;
	HeScheme _tmp324_;
	const gchar* _tmp325_;
	const gchar* _tmp326_;
	HeScheme _tmp327_;
	const gchar* _tmp328_;
	const gchar* _tmp329_;
	HeScheme _tmp330_;
	const gchar* _tmp331_;
	const gchar* _tmp332_;
	HeScheme _tmp333_;
	const gchar* _tmp334_;
	const gchar* _tmp335_;
	HeScheme _tmp336_;
	const gchar* _tmp337_;
	const gchar* _tmp338_;
	HeScheme _tmp339_;
	const gchar* _tmp340_;
	const gchar* _tmp341_;
	HeScheme _tmp342_;
	const gchar* _tmp343_;
	const gchar* _tmp344_;
	gchar* _tmp345_;
	const gchar* _tmp346_;
	const gchar* _tmp347_;
	const gchar* _tmp348_;
	const gchar* _tmp349_;
	const gchar* _tmp350_;
	const gchar* _tmp351_;
	const gchar* _tmp352_;
	const gchar* _tmp353_;
	const gchar* _tmp354_;
	const gchar* _tmp355_;
	const gchar* _tmp356_;
	const gchar* _tmp357_;
	const gchar* _tmp358_;
	HeScheme _tmp359_;
	const gchar* _tmp360_;
	const gchar* _tmp361_;
	HeScheme _tmp362_;
	const gchar* _tmp363_;
	const gchar* _tmp364_;
	HeScheme _tmp365_;
	const gchar* _tmp366_;
	const gchar* _tmp367_;
	HeScheme _tmp368_;
	const gchar* _tmp369_;
	const gchar* _tmp370_;
	HeScheme _tmp371_;
	const gchar* _tmp372_;
	const gchar* _tmp373_;
	HeScheme _tmp374_;
	const gchar* _tmp375_;
	const gchar* _tmp376_;
	const gchar* _tmp377_;
	const gchar* _tmp378_;
	const gchar* _tmp379_;
	const gchar* _tmp380_;
	const gchar* _tmp381_;
	const gchar* _tmp382_;
	const gchar* _tmp383_;
	const gchar* _tmp384_;
	const gchar* _tmp385_;
	const gchar* _tmp386_;
	const gchar* _tmp387_;
	const gchar* _tmp388_;
	HeScheme _tmp389_;
	const gchar* _tmp390_;
	const gchar* _tmp391_;
	HeScheme _tmp392_;
	const gchar* _tmp393_;
	const gchar* _tmp394_;
	HeScheme _tmp395_;
	const gchar* _tmp396_;
	const gchar* _tmp397_;
	HeScheme _tmp398_;
	const gchar* _tmp399_;
	const gchar* _tmp400_;
	HeScheme _tmp401_;
	const gchar* _tmp402_;
	const gchar* _tmp403_;
	HeScheme _tmp404_;
	const gchar* _tmp405_;
	const gchar* _tmp406_;
	HeScheme _tmp407_;
	const gchar* _tmp408_;
	const gchar* _tmp409_;
	HeScheme _tmp410_;
	const gchar* _tmp411_;
	const gchar* _tmp412_;
	HeScheme _tmp413_;
	const gchar* _tmp414_;
	const gchar* _tmp415_;
	HeScheme _tmp416_;
	const gchar* _tmp417_;
	const gchar* _tmp418_;
	HeScheme _tmp419_;
	const gchar* _tmp420_;
	const gchar* _tmp421_;
	HeScheme _tmp422_;
	const gchar* _tmp423_;
	const gchar* _tmp424_;
	HeScheme _tmp425_;
	const gchar* _tmp426_;
	const gchar* _tmp427_;
	gchar* _tmp428_;
	gchar* _tmp429_;
	gchar* _tmp430_;
	const gchar* _tmp431_;
	const gchar* _tmp432_;
	const gchar* _tmp433_;
	const gchar* _tmp434_;
	const gchar* _tmp435_;
	const gchar* _tmp436_;
	const gchar* _tmp437_;
	const gchar* _tmp438_;
	const gchar* _tmp439_;
	const gchar* _tmp440_;
	const gchar* _tmp441_;
	const gchar* _tmp442_;
	const gchar* _tmp443_;
	const gchar* _tmp444_;
	const gchar* _tmp445_;
	const gchar* _tmp446_;
	const gchar* _tmp447_;
	const gchar* _tmp448_;
	const gchar* _tmp449_;
	const gchar* _tmp450_;
	const gchar* _tmp451_;
	gchar* _tmp452_;
	gchar* _tmp453_;
	gchar* _tmp454_;
	gdouble light_weight = 0.0;
	gdouble heavy_weight = 0.0;
	const gchar* _tmp455_;
	gchar* _tmp456_;
	gchar* _tmp457_;
	gchar* _tmp458_;
	gchar* _tmp459_;
	gchar* _tmp460_;
	gchar* _tmp461_;
	gchar* _tmp462_;
	gchar* _tmp463_;
	gchar* _tmp464_;
	gchar* small_roundness = NULL;
	gchar* _tmp465_;
	gchar* _tmp466_;
	gchar* _tmp467_;
	gchar* _tmp468_;
	gchar* medium_roundness = NULL;
	gchar* _tmp469_;
	gchar* _tmp470_;
	gchar* _tmp471_;
	gchar* _tmp472_;
	gchar* large_roundness = NULL;
	gchar* _tmp473_;
	gchar* _tmp474_;
	gchar* _tmp475_;
	gchar* _tmp476_;
	gchar* x_large_roundness = NULL;
	gchar* _tmp477_;
	gchar* _tmp478_;
	gchar* _tmp479_;
	gchar* _tmp480_;
	gchar* circle_roundness = NULL;
	gchar* _tmp481_;
	gchar* _tmp482_;
	gchar* _tmp483_;
	gchar* _tmp484_;
	const gchar* _tmp485_;
	const gchar* _tmp486_;
	const gchar* _tmp487_;
	const gchar* _tmp488_;
	const gchar* _tmp489_;
	const gchar* _tmp490_;
	const gchar* _tmp491_;
	const gchar* _tmp492_;
	const gchar* _tmp493_;
	const gchar* _tmp494_;
	const gchar* _tmp495_;
	const gchar* _tmp496_;
	const gchar* _tmp497_;
	const gchar* _tmp498_;
	const gchar* _tmp499_;
	const gchar* _tmp500_;
	const gchar* _tmp501_;
	const gchar* _tmp502_;
	const gchar* _tmp503_;
	const gchar* _tmp504_;
	const gchar* _tmp505_;
	const gchar* _tmp506_;
	const gchar* _tmp507_;
	const gchar* _tmp508_;
	const gchar* _tmp509_;
	const gchar* _tmp510_;
	const gchar* _tmp511_;
	const gchar* _tmp512_;
	const gchar* _tmp513_;
	const gchar* _tmp514_;
	const gchar* _tmp515_;
	const gchar* _tmp516_;
	const gchar* _tmp517_;
	const gchar* _tmp518_;
	const gchar* _tmp519_;
	const gchar* _tmp520_;
	const gchar* _tmp521_;
	const gchar* _tmp522_;
	const gchar* _tmp523_;
	const gchar* _tmp524_;
	const gchar* _tmp525_;
	const gchar* _tmp526_;
	const gchar* _tmp527_;
	const gchar* _tmp528_;
	const gchar* _tmp529_;
	const gchar* _tmp530_;
	const gchar* _tmp531_;
	const gchar* _tmp532_;
	const gchar* _tmp533_;
	const gchar* _tmp534_;
	const gchar* _tmp535_;
	const gchar* _tmp536_;
	const gchar* _tmp537_;
	const gchar* _tmp538_;
	const gchar* _tmp539_;
	const gchar* _tmp540_;
	const gchar* _tmp541_;
	const gchar* _tmp542_;
	const gchar* _tmp543_;
	const gchar* _tmp544_;
	const gchar* _tmp545_;
	const gchar* _tmp546_;
	const gchar* _tmp547_;
	const gchar* _tmp548_;
	const gchar* _tmp549_;
	const gchar* _tmp550_;
	const gchar* _tmp551_;
	const gchar* _tmp552_;
	const gchar* _tmp553_;
	const gchar* _tmp554_;
	const gchar* _tmp555_;
	const gchar* _tmp556_;
	const gchar* _tmp557_;
	const gchar* _tmp558_;
	const gchar* _tmp559_;
	const gchar* _tmp560_;
	const gchar* _tmp561_;
	const gchar* _tmp562_;
	const gchar* _tmp563_;
	gchar* _tmp564_;
	gchar* _tmp565_;
	gchar* _tmp566_;
	GtkCssProvider* _tmp567_;
	const gchar* _tmp568_;
	GtkCssProvider* _tmp569_;
	GtkCssProvider* _tmp570_;
	GtkCssProvider* _tmp571_;
	GtkSettings* settings = NULL;
	GtkSettings* _tmp572_;
	GtkSettings* _tmp573_;
	GtkSettings* _tmp574_;
#line 81 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 82 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->_is_registered;
#line 82 "../lib/Models/StyleManager.vala"
	if (!_tmp0_) {
#line 83 "../lib/Models/StyleManager.vala"
		return;
#line 662 "StyleManager.c"
	}
#line 85 "../lib/Models/StyleManager.vala"
	_tmp2_ = self->accent_color;
#line 85 "../lib/Models/StyleManager.vala"
	if (_tmp2_ != NULL) {
#line 668 "StyleManager.c"
		HeColorRGBColor* _tmp3_;
#line 85 "../lib/Models/StyleManager.vala"
		_tmp3_ = self->accent_color;
#line 85 "../lib/Models/StyleManager.vala"
		_tmp1_ = _tmp3_;
#line 674 "StyleManager.c"
	} else {
		HeColorRGBColor _tmp4_ = {0};
#line 85 "../lib/Models/StyleManager.vala"
		if (self->is_dark) {
#line 85 "../lib/Models/StyleManager.vala"
			_tmp4_ = HE_COLOR_DEFAULT_DARK_ACCENT;
#line 681 "StyleManager.c"
		} else {
#line 85 "../lib/Models/StyleManager.vala"
			_tmp4_ = HE_COLOR_DEFAULT_LIGHT_ACCENT;
#line 685 "StyleManager.c"
		}
#line 85 "../lib/Models/StyleManager.vala"
		_tmp1_ = &_tmp4_;
#line 689 "StyleManager.c"
	}
#line 85 "../lib/Models/StyleManager.vala"
	_tmp5_ = _he_color_rgb_color_dup0 (_tmp1_);
#line 85 "../lib/Models/StyleManager.vala"
	rgb_color = _tmp5_;
#line 86 "../lib/Models/StyleManager.vala"
	base_weight = 400 * self->font_weight;
#line 87 "../lib/Models/StyleManager.vala"
	if (self->roundness != ((gdouble) 0)) {
#line 87 "../lib/Models/StyleManager.vala"
		_tmp6_ = 4 * self->roundness;
#line 701 "StyleManager.c"
	} else {
#line 87 "../lib/Models/StyleManager.vala"
		_tmp6_ = (gdouble) 0;
#line 705 "StyleManager.c"
	}
#line 87 "../lib/Models/StyleManager.vala"
	base_roundness = _tmp6_;
#line 88 "../lib/Models/StyleManager.vala"
	_tmp7_ = rgb_color;
#line 88 "../lib/Models/StyleManager.vala"
	_tmp8_ = *_tmp7_;
#line 88 "../lib/Models/StyleManager.vala"
	he_color_rgb_to_xyz (&_tmp8_, &_tmp9_);
#line 88 "../lib/Models/StyleManager.vala"
	he_color_xyz_to_cam16 (&_tmp9_, &_tmp10_);
#line 88 "../lib/Models/StyleManager.vala"
	cam16_color = _tmp10_;
#line 89 "../lib/Models/StyleManager.vala"
	_tmp11_ = self->scheme_factory;
#line 89 "../lib/Models/StyleManager.vala"
	_tmp12_ = cam16_color;
#line 89 "../lib/Models/StyleManager.vala"
	he_scheme_factory_generate (_tmp11_, &_tmp12_, self->is_dark, self->is_contrast, &_tmp13_);
#line 89 "../lib/Models/StyleManager.vala"
	chosen_scheme = _tmp13_;
#line 92 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 729 "StyleManager.c"
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		HeColorHCTColor _tmp17_ = {0};
		HeColorCAM16Color _tmp18_;
		HeColorCAM16Color _tmp19_;
		HeColorHCTColor _tmp20_ = {0};
		HeColorHCTColor _tmp21_ = {0};
#line 93 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 93 "../lib/Models/StyleManager.vala"
			_tmp15_ = 90.0;
#line 741 "StyleManager.c"
		} else {
#line 93 "../lib/Models/StyleManager.vala"
			_tmp15_ = 80.0;
#line 745 "StyleManager.c"
		}
#line 93 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 93 "../lib/Models/StyleManager.vala"
			_tmp16_ = 90.0;
#line 751 "StyleManager.c"
		} else {
#line 93 "../lib/Models/StyleManager.vala"
			_tmp16_ = 80.0;
#line 755 "StyleManager.c"
		}
#line 93 "../lib/Models/StyleManager.vala"
		he_color_from_params (20.0, 25.0, _tmp15_, &_tmp17_);
#line 93 "../lib/Models/StyleManager.vala"
		_tmp18_ = cam16_color;
#line 93 "../lib/Models/StyleManager.vala"
		_tmp19_ = cam16_color;
#line 93 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp18_.h, _tmp19_.c, _tmp16_, &_tmp20_);
#line 93 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp17_, &_tmp20_, &_tmp21_);
#line 93 "../lib/Models/StyleManager.vala"
		_tmp14_ = _tmp21_;
#line 769 "StyleManager.c"
	} else {
		gdouble _tmp22_ = 0.0;
		gdouble _tmp23_ = 0.0;
		HeColorHCTColor _tmp24_ = {0};
		HeColorCAM16Color _tmp25_;
		HeColorCAM16Color _tmp26_;
		HeColorHCTColor _tmp27_ = {0};
		HeColorHCTColor _tmp28_ = {0};
#line 94 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 94 "../lib/Models/StyleManager.vala"
			_tmp22_ = 20.0;
#line 782 "StyleManager.c"
		} else {
#line 94 "../lib/Models/StyleManager.vala"
			_tmp22_ = 40.0;
#line 786 "StyleManager.c"
		}
#line 94 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 94 "../lib/Models/StyleManager.vala"
			_tmp23_ = 20.0;
#line 792 "StyleManager.c"
		} else {
#line 94 "../lib/Models/StyleManager.vala"
			_tmp23_ = 40.0;
#line 796 "StyleManager.c"
		}
#line 94 "../lib/Models/StyleManager.vala"
		he_color_from_params (25.0, 75.0, _tmp22_, &_tmp24_);
#line 94 "../lib/Models/StyleManager.vala"
		_tmp25_ = cam16_color;
#line 94 "../lib/Models/StyleManager.vala"
		_tmp26_ = cam16_color;
#line 94 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp25_.h, _tmp26_.c, _tmp23_, &_tmp27_);
#line 94 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp24_, &_tmp27_, &_tmp28_);
#line 94 "../lib/Models/StyleManager.vala"
		_tmp14_ = _tmp28_;
#line 810 "StyleManager.c"
	}
#line 92 "../lib/Models/StyleManager.vala"
	error_hct = _tmp14_;
#line 95 "../lib/Models/StyleManager.vala"
	_tmp29_ = error_hct;
#line 95 "../lib/Models/StyleManager.vala"
	_tmp30_ = error_hct;
#line 95 "../lib/Models/StyleManager.vala"
	_tmp31_ = error_hct;
#line 95 "../lib/Models/StyleManager.vala"
	_tmp32_ = he_color_hct_to_hex (_tmp29_.h, _tmp30_.c, _tmp31_.t);
#line 95 "../lib/Models/StyleManager.vala"
	error_hex = _tmp32_;
#line 97 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 826 "StyleManager.c"
		HeColorHCTColor _tmp34_ = {0};
		HeColorCAM16Color _tmp35_;
		HeColorCAM16Color _tmp36_;
		HeColorHCTColor _tmp37_ = {0};
		HeColorHCTColor _tmp38_ = {0};
#line 98 "../lib/Models/StyleManager.vala"
		he_color_from_params (25.0, 50.0, 20.0, &_tmp34_);
#line 98 "../lib/Models/StyleManager.vala"
		_tmp35_ = cam16_color;
#line 98 "../lib/Models/StyleManager.vala"
		_tmp36_ = cam16_color;
#line 98 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp35_.h, _tmp36_.c, 20.0, &_tmp37_);
#line 98 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp34_, &_tmp37_, &_tmp38_);
#line 98 "../lib/Models/StyleManager.vala"
		_tmp33_ = _tmp38_;
#line 844 "StyleManager.c"
	} else {
		HeColorHCTColor _tmp39_ = {0};
		HeColorCAM16Color _tmp40_;
		HeColorCAM16Color _tmp41_;
		HeColorHCTColor _tmp42_ = {0};
		HeColorHCTColor _tmp43_ = {0};
#line 99 "../lib/Models/StyleManager.vala"
		he_color_from_params (0.0, 0.0, 100.0, &_tmp39_);
#line 99 "../lib/Models/StyleManager.vala"
		_tmp40_ = cam16_color;
#line 99 "../lib/Models/StyleManager.vala"
		_tmp41_ = cam16_color;
#line 99 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp40_.h, _tmp41_.c, 100.0, &_tmp42_);
#line 99 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp39_, &_tmp42_, &_tmp43_);
#line 99 "../lib/Models/StyleManager.vala"
		_tmp33_ = _tmp43_;
#line 863 "StyleManager.c"
	}
#line 97 "../lib/Models/StyleManager.vala"
	on_error_hct = _tmp33_;
#line 100 "../lib/Models/StyleManager.vala"
	_tmp44_ = on_error_hct;
#line 100 "../lib/Models/StyleManager.vala"
	_tmp45_ = on_error_hct;
#line 100 "../lib/Models/StyleManager.vala"
	_tmp46_ = on_error_hct;
#line 100 "../lib/Models/StyleManager.vala"
	_tmp47_ = he_color_hct_to_hex (_tmp44_.h, _tmp45_.c, _tmp46_.t);
#line 100 "../lib/Models/StyleManager.vala"
	on_error_hex = _tmp47_;
#line 102 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 879 "StyleManager.c"
		gdouble _tmp49_ = 0.0;
		gdouble _tmp50_ = 0.0;
		HeColorHCTColor _tmp51_ = {0};
		HeColorCAM16Color _tmp52_;
		HeColorCAM16Color _tmp53_;
		HeColorHCTColor _tmp54_ = {0};
		HeColorHCTColor _tmp55_ = {0};
#line 103 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 103 "../lib/Models/StyleManager.vala"
			_tmp49_ = 40.0;
#line 891 "StyleManager.c"
		} else {
#line 103 "../lib/Models/StyleManager.vala"
			_tmp49_ = 30.0;
#line 895 "StyleManager.c"
		}
#line 103 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 103 "../lib/Models/StyleManager.vala"
			_tmp50_ = 90.0;
#line 901 "StyleManager.c"
		} else {
#line 103 "../lib/Models/StyleManager.vala"
			_tmp50_ = 80.0;
#line 905 "StyleManager.c"
		}
#line 103 "../lib/Models/StyleManager.vala"
		he_color_from_params (25.0, 35.0, _tmp49_, &_tmp51_);
#line 103 "../lib/Models/StyleManager.vala"
		_tmp52_ = cam16_color;
#line 103 "../lib/Models/StyleManager.vala"
		_tmp53_ = cam16_color;
#line 103 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp52_.h, _tmp53_.c, _tmp50_, &_tmp54_);
#line 103 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp51_, &_tmp54_, &_tmp55_);
#line 103 "../lib/Models/StyleManager.vala"
		_tmp48_ = _tmp55_;
#line 919 "StyleManager.c"
	} else {
		gdouble _tmp56_ = 0.0;
		gdouble _tmp57_ = 0.0;
		HeColorHCTColor _tmp58_ = {0};
		HeColorCAM16Color _tmp59_;
		HeColorCAM16Color _tmp60_;
		HeColorHCTColor _tmp61_ = {0};
		HeColorHCTColor _tmp62_ = {0};
#line 104 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 104 "../lib/Models/StyleManager.vala"
			_tmp56_ = 70.0;
#line 932 "StyleManager.c"
		} else {
#line 104 "../lib/Models/StyleManager.vala"
			_tmp56_ = 90.0;
#line 936 "StyleManager.c"
		}
#line 104 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 104 "../lib/Models/StyleManager.vala"
			_tmp57_ = 20.0;
#line 942 "StyleManager.c"
		} else {
#line 104 "../lib/Models/StyleManager.vala"
			_tmp57_ = 40.0;
#line 946 "StyleManager.c"
		}
#line 104 "../lib/Models/StyleManager.vala"
		he_color_from_params (20.0, 10.0, _tmp56_, &_tmp58_);
#line 104 "../lib/Models/StyleManager.vala"
		_tmp59_ = cam16_color;
#line 104 "../lib/Models/StyleManager.vala"
		_tmp60_ = cam16_color;
#line 104 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp59_.h, _tmp60_.c, _tmp57_, &_tmp61_);
#line 104 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp58_, &_tmp61_, &_tmp62_);
#line 104 "../lib/Models/StyleManager.vala"
		_tmp48_ = _tmp62_;
#line 960 "StyleManager.c"
	}
#line 102 "../lib/Models/StyleManager.vala"
	error_container_hct = _tmp48_;
#line 105 "../lib/Models/StyleManager.vala"
	_tmp63_ = error_container_hct;
#line 105 "../lib/Models/StyleManager.vala"
	_tmp64_ = error_container_hct;
#line 105 "../lib/Models/StyleManager.vala"
	_tmp65_ = error_container_hct;
#line 105 "../lib/Models/StyleManager.vala"
	_tmp66_ = he_color_hct_to_hex (_tmp63_.h, _tmp64_.c, _tmp65_.t);
#line 105 "../lib/Models/StyleManager.vala"
	error_container_hex = _tmp66_;
#line 107 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 976 "StyleManager.c"
		HeColorHCTColor _tmp68_ = {0};
		HeColorCAM16Color _tmp69_;
		HeColorCAM16Color _tmp70_;
		HeColorHCTColor _tmp71_ = {0};
		HeColorHCTColor _tmp72_ = {0};
#line 108 "../lib/Models/StyleManager.vala"
		he_color_from_params (20.0, 10.0, 90.0, &_tmp68_);
#line 108 "../lib/Models/StyleManager.vala"
		_tmp69_ = cam16_color;
#line 108 "../lib/Models/StyleManager.vala"
		_tmp70_ = cam16_color;
#line 108 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp69_.h, _tmp70_.c, 90.0, &_tmp71_);
#line 108 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp68_, &_tmp71_, &_tmp72_);
#line 108 "../lib/Models/StyleManager.vala"
		_tmp67_ = _tmp72_;
#line 994 "StyleManager.c"
	} else {
		HeColorHCTColor _tmp73_ = {0};
		HeColorCAM16Color _tmp74_;
		HeColorCAM16Color _tmp75_;
		HeColorHCTColor _tmp76_ = {0};
		HeColorHCTColor _tmp77_ = {0};
#line 109 "../lib/Models/StyleManager.vala"
		he_color_from_params (25.0, 65.0, 30.0, &_tmp73_);
#line 109 "../lib/Models/StyleManager.vala"
		_tmp74_ = cam16_color;
#line 109 "../lib/Models/StyleManager.vala"
		_tmp75_ = cam16_color;
#line 109 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp74_.h, _tmp75_.c, 10.0, &_tmp76_);
#line 109 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp73_, &_tmp76_, &_tmp77_);
#line 109 "../lib/Models/StyleManager.vala"
		_tmp67_ = _tmp77_;
#line 1013 "StyleManager.c"
	}
#line 107 "../lib/Models/StyleManager.vala"
	on_error_container_hct = _tmp67_;
#line 110 "../lib/Models/StyleManager.vala"
	_tmp78_ = on_error_container_hct;
#line 110 "../lib/Models/StyleManager.vala"
	_tmp79_ = on_error_container_hct;
#line 110 "../lib/Models/StyleManager.vala"
	_tmp80_ = on_error_container_hct;
#line 110 "../lib/Models/StyleManager.vala"
	_tmp81_ = he_color_hct_to_hex (_tmp78_.h, _tmp79_.c, _tmp80_.t);
#line 110 "../lib/Models/StyleManager.vala"
	on_error_container_hex = _tmp81_;
#line 112 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1029 "StyleManager.c"
		gdouble _tmp83_ = 0.0;
		gdouble _tmp84_ = 0.0;
		HeColorHCTColor _tmp85_ = {0};
		HeColorCAM16Color _tmp86_;
		HeColorCAM16Color _tmp87_;
		HeColorHCTColor _tmp88_ = {0};
		HeColorHCTColor _tmp89_ = {0};
#line 113 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 113 "../lib/Models/StyleManager.vala"
			_tmp83_ = 90.0;
#line 1041 "StyleManager.c"
		} else {
#line 113 "../lib/Models/StyleManager.vala"
			_tmp83_ = 80.0;
#line 1045 "StyleManager.c"
		}
#line 113 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 113 "../lib/Models/StyleManager.vala"
			_tmp84_ = 90.0;
#line 1051 "StyleManager.c"
		} else {
#line 113 "../lib/Models/StyleManager.vala"
			_tmp84_ = 80.0;
#line 1055 "StyleManager.c"
		}
#line 113 "../lib/Models/StyleManager.vala"
		he_color_from_params (8.0, 85.0, _tmp83_, &_tmp85_);
#line 113 "../lib/Models/StyleManager.vala"
		_tmp86_ = cam16_color;
#line 113 "../lib/Models/StyleManager.vala"
		_tmp87_ = cam16_color;
#line 113 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp86_.h, _tmp87_.c, _tmp84_, &_tmp88_);
#line 113 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp85_, &_tmp88_, &_tmp89_);
#line 113 "../lib/Models/StyleManager.vala"
		_tmp82_ = _tmp89_;
#line 1069 "StyleManager.c"
	} else {
		gdouble _tmp90_ = 0.0;
		gdouble _tmp91_ = 0.0;
		HeColorHCTColor _tmp92_ = {0};
		HeColorCAM16Color _tmp93_;
		HeColorCAM16Color _tmp94_;
		HeColorHCTColor _tmp95_ = {0};
		HeColorHCTColor _tmp96_ = {0};
#line 114 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 114 "../lib/Models/StyleManager.vala"
			_tmp90_ = 20.0;
#line 1082 "StyleManager.c"
		} else {
#line 114 "../lib/Models/StyleManager.vala"
			_tmp90_ = 40.0;
#line 1086 "StyleManager.c"
		}
#line 114 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 114 "../lib/Models/StyleManager.vala"
			_tmp91_ = 20.0;
#line 1092 "StyleManager.c"
		} else {
#line 114 "../lib/Models/StyleManager.vala"
			_tmp91_ = 40.0;
#line 1096 "StyleManager.c"
		}
#line 114 "../lib/Models/StyleManager.vala"
		he_color_from_params (2.0, 49.0, _tmp90_, &_tmp92_);
#line 114 "../lib/Models/StyleManager.vala"
		_tmp93_ = cam16_color;
#line 114 "../lib/Models/StyleManager.vala"
		_tmp94_ = cam16_color;
#line 114 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp93_.h, _tmp94_.c, _tmp91_, &_tmp95_);
#line 114 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp92_, &_tmp95_, &_tmp96_);
#line 114 "../lib/Models/StyleManager.vala"
		_tmp82_ = _tmp96_;
#line 1110 "StyleManager.c"
	}
#line 112 "../lib/Models/StyleManager.vala"
	meson_red_hct = _tmp82_;
#line 115 "../lib/Models/StyleManager.vala"
	_tmp97_ = meson_red_hct;
#line 115 "../lib/Models/StyleManager.vala"
	_tmp98_ = meson_red_hct;
#line 115 "../lib/Models/StyleManager.vala"
	_tmp99_ = meson_red_hct;
#line 115 "../lib/Models/StyleManager.vala"
	_tmp100_ = he_color_hct_to_hex (_tmp97_.h, _tmp98_.c, _tmp99_.t);
#line 115 "../lib/Models/StyleManager.vala"
	meson_red_hex = _tmp100_;
#line 117 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1126 "StyleManager.c"
		gdouble _tmp102_ = 0.0;
		gdouble _tmp103_ = 0.0;
		HeColorHCTColor _tmp104_ = {0};
		HeColorCAM16Color _tmp105_;
		HeColorCAM16Color _tmp106_;
		HeColorHCTColor _tmp107_ = {0};
		HeColorHCTColor _tmp108_ = {0};
#line 118 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 118 "../lib/Models/StyleManager.vala"
			_tmp102_ = 90.0;
#line 1138 "StyleManager.c"
		} else {
#line 118 "../lib/Models/StyleManager.vala"
			_tmp102_ = 80.0;
#line 1142 "StyleManager.c"
		}
#line 118 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 118 "../lib/Models/StyleManager.vala"
			_tmp103_ = 90.0;
#line 1148 "StyleManager.c"
		} else {
#line 118 "../lib/Models/StyleManager.vala"
			_tmp103_ = 80.0;
#line 1152 "StyleManager.c"
		}
#line 118 "../lib/Models/StyleManager.vala"
		he_color_from_params (55.0, 29.0, _tmp102_, &_tmp104_);
#line 118 "../lib/Models/StyleManager.vala"
		_tmp105_ = cam16_color;
#line 118 "../lib/Models/StyleManager.vala"
		_tmp106_ = cam16_color;
#line 118 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp105_.h, _tmp106_.c, _tmp103_, &_tmp107_);
#line 118 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp104_, &_tmp107_, &_tmp108_);
#line 118 "../lib/Models/StyleManager.vala"
		_tmp101_ = _tmp108_;
#line 1166 "StyleManager.c"
	} else {
		gdouble _tmp109_ = 0.0;
		gdouble _tmp110_ = 0.0;
		HeColorHCTColor _tmp111_ = {0};
		HeColorCAM16Color _tmp112_;
		HeColorCAM16Color _tmp113_;
		HeColorHCTColor _tmp114_ = {0};
		HeColorHCTColor _tmp115_ = {0};
#line 119 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 119 "../lib/Models/StyleManager.vala"
			_tmp109_ = 20.0;
#line 1179 "StyleManager.c"
		} else {
#line 119 "../lib/Models/StyleManager.vala"
			_tmp109_ = 40.0;
#line 1183 "StyleManager.c"
		}
#line 119 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 119 "../lib/Models/StyleManager.vala"
			_tmp110_ = 20.0;
#line 1189 "StyleManager.c"
		} else {
#line 119 "../lib/Models/StyleManager.vala"
			_tmp110_ = 40.0;
#line 1193 "StyleManager.c"
		}
#line 119 "../lib/Models/StyleManager.vala"
		he_color_from_params (50.0, 61.0, _tmp109_, &_tmp111_);
#line 119 "../lib/Models/StyleManager.vala"
		_tmp112_ = cam16_color;
#line 119 "../lib/Models/StyleManager.vala"
		_tmp113_ = cam16_color;
#line 119 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp112_.h, _tmp113_.c, _tmp110_, &_tmp114_);
#line 119 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp111_, &_tmp114_, &_tmp115_);
#line 119 "../lib/Models/StyleManager.vala"
		_tmp101_ = _tmp115_;
#line 1207 "StyleManager.c"
	}
#line 117 "../lib/Models/StyleManager.vala"
	lepton_orange_hct = _tmp101_;
#line 120 "../lib/Models/StyleManager.vala"
	_tmp116_ = lepton_orange_hct;
#line 120 "../lib/Models/StyleManager.vala"
	_tmp117_ = lepton_orange_hct;
#line 120 "../lib/Models/StyleManager.vala"
	_tmp118_ = lepton_orange_hct;
#line 120 "../lib/Models/StyleManager.vala"
	_tmp119_ = he_color_hct_to_hex (_tmp116_.h, _tmp117_.c, _tmp118_.t);
#line 120 "../lib/Models/StyleManager.vala"
	lepton_orange_hex = _tmp119_;
#line 122 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1223 "StyleManager.c"
		gdouble _tmp121_ = 0.0;
		gdouble _tmp122_ = 0.0;
		HeColorHCTColor _tmp123_ = {0};
		HeColorCAM16Color _tmp124_;
		HeColorCAM16Color _tmp125_;
		HeColorHCTColor _tmp126_ = {0};
		HeColorHCTColor _tmp127_ = {0};
#line 123 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 123 "../lib/Models/StyleManager.vala"
			_tmp121_ = 90.0;
#line 1235 "StyleManager.c"
		} else {
#line 123 "../lib/Models/StyleManager.vala"
			_tmp121_ = 80.0;
#line 1239 "StyleManager.c"
		}
#line 123 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 123 "../lib/Models/StyleManager.vala"
			_tmp122_ = 90.0;
#line 1245 "StyleManager.c"
		} else {
#line 123 "../lib/Models/StyleManager.vala"
			_tmp122_ = 80.0;
#line 1249 "StyleManager.c"
		}
#line 123 "../lib/Models/StyleManager.vala"
		he_color_from_params (89.0, 37.0, _tmp121_, &_tmp123_);
#line 123 "../lib/Models/StyleManager.vala"
		_tmp124_ = cam16_color;
#line 123 "../lib/Models/StyleManager.vala"
		_tmp125_ = cam16_color;
#line 123 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp124_.h, _tmp125_.c, _tmp122_, &_tmp126_);
#line 123 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp123_, &_tmp126_, &_tmp127_);
#line 123 "../lib/Models/StyleManager.vala"
		_tmp120_ = _tmp127_;
#line 1263 "StyleManager.c"
	} else {
		gdouble _tmp128_ = 0.0;
		gdouble _tmp129_ = 0.0;
		HeColorHCTColor _tmp130_ = {0};
		HeColorCAM16Color _tmp131_;
		HeColorCAM16Color _tmp132_;
		HeColorHCTColor _tmp133_ = {0};
		HeColorHCTColor _tmp134_ = {0};
#line 124 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 124 "../lib/Models/StyleManager.vala"
			_tmp128_ = 20.0;
#line 1276 "StyleManager.c"
		} else {
#line 124 "../lib/Models/StyleManager.vala"
			_tmp128_ = 40.0;
#line 1280 "StyleManager.c"
		}
#line 124 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 124 "../lib/Models/StyleManager.vala"
			_tmp129_ = 20.0;
#line 1286 "StyleManager.c"
		} else {
#line 124 "../lib/Models/StyleManager.vala"
			_tmp129_ = 40.0;
#line 1290 "StyleManager.c"
		}
#line 124 "../lib/Models/StyleManager.vala"
		he_color_from_params (81.0, 55.0, _tmp128_, &_tmp130_);
#line 124 "../lib/Models/StyleManager.vala"
		_tmp131_ = cam16_color;
#line 124 "../lib/Models/StyleManager.vala"
		_tmp132_ = cam16_color;
#line 124 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp131_.h, _tmp132_.c, _tmp129_, &_tmp133_);
#line 124 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp130_, &_tmp133_, &_tmp134_);
#line 124 "../lib/Models/StyleManager.vala"
		_tmp120_ = _tmp134_;
#line 1304 "StyleManager.c"
	}
#line 122 "../lib/Models/StyleManager.vala"
	electron_yellow_hct = _tmp120_;
#line 125 "../lib/Models/StyleManager.vala"
	_tmp135_ = electron_yellow_hct;
#line 125 "../lib/Models/StyleManager.vala"
	_tmp136_ = electron_yellow_hct;
#line 125 "../lib/Models/StyleManager.vala"
	_tmp137_ = electron_yellow_hct;
#line 125 "../lib/Models/StyleManager.vala"
	_tmp138_ = he_color_hct_to_hex (_tmp135_.h, _tmp136_.c, _tmp137_.t);
#line 125 "../lib/Models/StyleManager.vala"
	electron_yellow_hex = _tmp138_;
#line 127 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1320 "StyleManager.c"
		gdouble _tmp140_ = 0.0;
		gdouble _tmp141_ = 0.0;
		HeColorHCTColor _tmp142_ = {0};
		HeColorCAM16Color _tmp143_;
		HeColorCAM16Color _tmp144_;
		HeColorHCTColor _tmp145_ = {0};
		HeColorHCTColor _tmp146_ = {0};
#line 128 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 128 "../lib/Models/StyleManager.vala"
			_tmp140_ = 90.0;
#line 1332 "StyleManager.c"
		} else {
#line 128 "../lib/Models/StyleManager.vala"
			_tmp140_ = 80.0;
#line 1336 "StyleManager.c"
		}
#line 128 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 128 "../lib/Models/StyleManager.vala"
			_tmp141_ = 90.0;
#line 1342 "StyleManager.c"
		} else {
#line 128 "../lib/Models/StyleManager.vala"
			_tmp141_ = 80.0;
#line 1346 "StyleManager.c"
		}
#line 128 "../lib/Models/StyleManager.vala"
		he_color_from_params (152.0, 43.0, _tmp140_, &_tmp142_);
#line 128 "../lib/Models/StyleManager.vala"
		_tmp143_ = cam16_color;
#line 128 "../lib/Models/StyleManager.vala"
		_tmp144_ = cam16_color;
#line 128 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp143_.h, _tmp144_.c, _tmp141_, &_tmp145_);
#line 128 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp142_, &_tmp145_, &_tmp146_);
#line 128 "../lib/Models/StyleManager.vala"
		_tmp139_ = _tmp146_;
#line 1360 "StyleManager.c"
	} else {
		gdouble _tmp147_ = 0.0;
		gdouble _tmp148_ = 0.0;
		HeColorHCTColor _tmp149_ = {0};
		HeColorCAM16Color _tmp150_;
		HeColorCAM16Color _tmp151_;
		HeColorHCTColor _tmp152_ = {0};
		HeColorHCTColor _tmp153_ = {0};
#line 129 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 129 "../lib/Models/StyleManager.vala"
			_tmp147_ = 20.0;
#line 1373 "StyleManager.c"
		} else {
#line 129 "../lib/Models/StyleManager.vala"
			_tmp147_ = 40.0;
#line 1377 "StyleManager.c"
		}
#line 129 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 129 "../lib/Models/StyleManager.vala"
			_tmp148_ = 20.0;
#line 1383 "StyleManager.c"
		} else {
#line 129 "../lib/Models/StyleManager.vala"
			_tmp148_ = 40.0;
#line 1387 "StyleManager.c"
		}
#line 129 "../lib/Models/StyleManager.vala"
		he_color_from_params (147.0, 71.0, _tmp147_, &_tmp149_);
#line 129 "../lib/Models/StyleManager.vala"
		_tmp150_ = cam16_color;
#line 129 "../lib/Models/StyleManager.vala"
		_tmp151_ = cam16_color;
#line 129 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp150_.h, _tmp151_.c, _tmp148_, &_tmp152_);
#line 129 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp149_, &_tmp152_, &_tmp153_);
#line 129 "../lib/Models/StyleManager.vala"
		_tmp139_ = _tmp153_;
#line 1401 "StyleManager.c"
	}
#line 127 "../lib/Models/StyleManager.vala"
	muon_green_hct = _tmp139_;
#line 130 "../lib/Models/StyleManager.vala"
	_tmp154_ = muon_green_hct;
#line 130 "../lib/Models/StyleManager.vala"
	_tmp155_ = muon_green_hct;
#line 130 "../lib/Models/StyleManager.vala"
	_tmp156_ = muon_green_hct;
#line 130 "../lib/Models/StyleManager.vala"
	_tmp157_ = he_color_hct_to_hex (_tmp154_.h, _tmp155_.c, _tmp156_.t);
#line 130 "../lib/Models/StyleManager.vala"
	muon_green_hex = _tmp157_;
#line 132 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1417 "StyleManager.c"
		gdouble _tmp159_ = 0.0;
		gdouble _tmp160_ = 0.0;
		HeColorHCTColor _tmp161_ = {0};
		HeColorCAM16Color _tmp162_;
		HeColorCAM16Color _tmp163_;
		HeColorHCTColor _tmp164_ = {0};
		HeColorHCTColor _tmp165_ = {0};
#line 133 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 133 "../lib/Models/StyleManager.vala"
			_tmp159_ = 90.0;
#line 1429 "StyleManager.c"
		} else {
#line 133 "../lib/Models/StyleManager.vala"
			_tmp159_ = 80.0;
#line 1433 "StyleManager.c"
		}
#line 133 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 133 "../lib/Models/StyleManager.vala"
			_tmp160_ = 90.0;
#line 1439 "StyleManager.c"
		} else {
#line 133 "../lib/Models/StyleManager.vala"
			_tmp160_ = 80.0;
#line 1443 "StyleManager.c"
		}
#line 133 "../lib/Models/StyleManager.vala"
		he_color_from_params (182.0, 25.0, _tmp159_, &_tmp161_);
#line 133 "../lib/Models/StyleManager.vala"
		_tmp162_ = cam16_color;
#line 133 "../lib/Models/StyleManager.vala"
		_tmp163_ = cam16_color;
#line 133 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp162_.h, _tmp163_.c, _tmp160_, &_tmp164_);
#line 133 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp161_, &_tmp164_, &_tmp165_);
#line 133 "../lib/Models/StyleManager.vala"
		_tmp158_ = _tmp165_;
#line 1457 "StyleManager.c"
	} else {
		gdouble _tmp166_ = 0.0;
		gdouble _tmp167_ = 0.0;
		HeColorHCTColor _tmp168_ = {0};
		HeColorCAM16Color _tmp169_;
		HeColorCAM16Color _tmp170_;
		HeColorHCTColor _tmp171_ = {0};
		HeColorHCTColor _tmp172_ = {0};
#line 134 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 134 "../lib/Models/StyleManager.vala"
			_tmp166_ = 20.0;
#line 1470 "StyleManager.c"
		} else {
#line 134 "../lib/Models/StyleManager.vala"
			_tmp166_ = 40.0;
#line 1474 "StyleManager.c"
		}
#line 134 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 134 "../lib/Models/StyleManager.vala"
			_tmp167_ = 20.0;
#line 1480 "StyleManager.c"
		} else {
#line 134 "../lib/Models/StyleManager.vala"
			_tmp167_ = 40.0;
#line 1484 "StyleManager.c"
		}
#line 134 "../lib/Models/StyleManager.vala"
		he_color_from_params (177.0, 42.0, _tmp166_, &_tmp168_);
#line 134 "../lib/Models/StyleManager.vala"
		_tmp169_ = cam16_color;
#line 134 "../lib/Models/StyleManager.vala"
		_tmp170_ = cam16_color;
#line 134 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp169_.h, _tmp170_.c, _tmp167_, &_tmp171_);
#line 134 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp168_, &_tmp171_, &_tmp172_);
#line 134 "../lib/Models/StyleManager.vala"
		_tmp158_ = _tmp172_;
#line 1498 "StyleManager.c"
	}
#line 132 "../lib/Models/StyleManager.vala"
	baryon_mint_hct = _tmp158_;
#line 135 "../lib/Models/StyleManager.vala"
	_tmp173_ = baryon_mint_hct;
#line 135 "../lib/Models/StyleManager.vala"
	_tmp174_ = baryon_mint_hct;
#line 135 "../lib/Models/StyleManager.vala"
	_tmp175_ = baryon_mint_hct;
#line 135 "../lib/Models/StyleManager.vala"
	_tmp176_ = he_color_hct_to_hex (_tmp173_.h, _tmp174_.c, _tmp175_.t);
#line 135 "../lib/Models/StyleManager.vala"
	baryon_mint_hex = _tmp176_;
#line 137 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1514 "StyleManager.c"
		gdouble _tmp178_ = 0.0;
		gdouble _tmp179_ = 0.0;
		HeColorHCTColor _tmp180_ = {0};
		HeColorCAM16Color _tmp181_;
		HeColorCAM16Color _tmp182_;
		HeColorHCTColor _tmp183_ = {0};
		HeColorHCTColor _tmp184_ = {0};
#line 138 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 138 "../lib/Models/StyleManager.vala"
			_tmp178_ = 90.0;
#line 1526 "StyleManager.c"
		} else {
#line 138 "../lib/Models/StyleManager.vala"
			_tmp178_ = 80.0;
#line 1530 "StyleManager.c"
		}
#line 138 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 138 "../lib/Models/StyleManager.vala"
			_tmp179_ = 90.0;
#line 1536 "StyleManager.c"
		} else {
#line 138 "../lib/Models/StyleManager.vala"
			_tmp179_ = 80.0;
#line 1540 "StyleManager.c"
		}
#line 138 "../lib/Models/StyleManager.vala"
		he_color_from_params (233.0, 34.0, _tmp178_, &_tmp180_);
#line 138 "../lib/Models/StyleManager.vala"
		_tmp181_ = cam16_color;
#line 138 "../lib/Models/StyleManager.vala"
		_tmp182_ = cam16_color;
#line 138 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp181_.h, _tmp182_.c, _tmp179_, &_tmp183_);
#line 138 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp180_, &_tmp183_, &_tmp184_);
#line 138 "../lib/Models/StyleManager.vala"
		_tmp177_ = _tmp184_;
#line 1554 "StyleManager.c"
	} else {
		gdouble _tmp185_ = 0.0;
		gdouble _tmp186_ = 0.0;
		HeColorHCTColor _tmp187_ = {0};
		HeColorCAM16Color _tmp188_;
		HeColorCAM16Color _tmp189_;
		HeColorHCTColor _tmp190_ = {0};
		HeColorHCTColor _tmp191_ = {0};
#line 139 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 139 "../lib/Models/StyleManager.vala"
			_tmp185_ = 20.0;
#line 1567 "StyleManager.c"
		} else {
#line 139 "../lib/Models/StyleManager.vala"
			_tmp185_ = 40.0;
#line 1571 "StyleManager.c"
		}
#line 139 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 139 "../lib/Models/StyleManager.vala"
			_tmp186_ = 20.0;
#line 1577 "StyleManager.c"
		} else {
#line 139 "../lib/Models/StyleManager.vala"
			_tmp186_ = 40.0;
#line 1581 "StyleManager.c"
		}
#line 139 "../lib/Models/StyleManager.vala"
		he_color_from_params (240.0, 53.0, _tmp185_, &_tmp187_);
#line 139 "../lib/Models/StyleManager.vala"
		_tmp188_ = cam16_color;
#line 139 "../lib/Models/StyleManager.vala"
		_tmp189_ = cam16_color;
#line 139 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp188_.h, _tmp189_.c, _tmp186_, &_tmp190_);
#line 139 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp187_, &_tmp190_, &_tmp191_);
#line 139 "../lib/Models/StyleManager.vala"
		_tmp177_ = _tmp191_;
#line 1595 "StyleManager.c"
	}
#line 137 "../lib/Models/StyleManager.vala"
	proton_blue_hct = _tmp177_;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp192_ = proton_blue_hct;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp193_ = proton_blue_hct;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp194_ = proton_blue_hct;
#line 140 "../lib/Models/StyleManager.vala"
	_tmp195_ = he_color_hct_to_hex (_tmp192_.h, _tmp193_.c, _tmp194_.t);
#line 140 "../lib/Models/StyleManager.vala"
	proton_blue_hex = _tmp195_;
#line 142 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1611 "StyleManager.c"
		gdouble _tmp197_ = 0.0;
		gdouble _tmp198_ = 0.0;
		HeColorHCTColor _tmp199_ = {0};
		HeColorCAM16Color _tmp200_;
		HeColorCAM16Color _tmp201_;
		HeColorHCTColor _tmp202_ = {0};
		HeColorHCTColor _tmp203_ = {0};
#line 143 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 143 "../lib/Models/StyleManager.vala"
			_tmp197_ = 90.0;
#line 1623 "StyleManager.c"
		} else {
#line 143 "../lib/Models/StyleManager.vala"
			_tmp197_ = 80.0;
#line 1627 "StyleManager.c"
		}
#line 143 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 143 "../lib/Models/StyleManager.vala"
			_tmp198_ = 90.0;
#line 1633 "StyleManager.c"
		} else {
#line 143 "../lib/Models/StyleManager.vala"
			_tmp198_ = 80.0;
#line 1637 "StyleManager.c"
		}
#line 143 "../lib/Models/StyleManager.vala"
		he_color_from_params (291.0, 67.0, _tmp197_, &_tmp199_);
#line 143 "../lib/Models/StyleManager.vala"
		_tmp200_ = cam16_color;
#line 143 "../lib/Models/StyleManager.vala"
		_tmp201_ = cam16_color;
#line 143 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp200_.h, _tmp201_.c, _tmp198_, &_tmp202_);
#line 143 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp199_, &_tmp202_, &_tmp203_);
#line 143 "../lib/Models/StyleManager.vala"
		_tmp196_ = _tmp203_;
#line 1651 "StyleManager.c"
	} else {
		gdouble _tmp204_ = 0.0;
		gdouble _tmp205_ = 0.0;
		HeColorHCTColor _tmp206_ = {0};
		HeColorCAM16Color _tmp207_;
		HeColorCAM16Color _tmp208_;
		HeColorHCTColor _tmp209_ = {0};
		HeColorHCTColor _tmp210_ = {0};
#line 144 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 144 "../lib/Models/StyleManager.vala"
			_tmp204_ = 20.0;
#line 1664 "StyleManager.c"
		} else {
#line 144 "../lib/Models/StyleManager.vala"
			_tmp204_ = 40.0;
#line 1668 "StyleManager.c"
		}
#line 144 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 144 "../lib/Models/StyleManager.vala"
			_tmp205_ = 20.0;
#line 1674 "StyleManager.c"
		} else {
#line 144 "../lib/Models/StyleManager.vala"
			_tmp205_ = 40.0;
#line 1678 "StyleManager.c"
		}
#line 144 "../lib/Models/StyleManager.vala"
		he_color_from_params (288.0, 84.0, _tmp204_, &_tmp206_);
#line 144 "../lib/Models/StyleManager.vala"
		_tmp207_ = cam16_color;
#line 144 "../lib/Models/StyleManager.vala"
		_tmp208_ = cam16_color;
#line 144 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp207_.h, _tmp208_.c, _tmp205_, &_tmp209_);
#line 144 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp206_, &_tmp209_, &_tmp210_);
#line 144 "../lib/Models/StyleManager.vala"
		_tmp196_ = _tmp210_;
#line 1692 "StyleManager.c"
	}
#line 142 "../lib/Models/StyleManager.vala"
	photon_indigo_hct = _tmp196_;
#line 145 "../lib/Models/StyleManager.vala"
	_tmp211_ = photon_indigo_hct;
#line 145 "../lib/Models/StyleManager.vala"
	_tmp212_ = photon_indigo_hct;
#line 145 "../lib/Models/StyleManager.vala"
	_tmp213_ = photon_indigo_hct;
#line 145 "../lib/Models/StyleManager.vala"
	_tmp214_ = he_color_hct_to_hex (_tmp211_.h, _tmp212_.c, _tmp213_.t);
#line 145 "../lib/Models/StyleManager.vala"
	photon_indigo_hex = _tmp214_;
#line 147 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1708 "StyleManager.c"
		gdouble _tmp216_ = 0.0;
		gdouble _tmp217_ = 0.0;
		HeColorHCTColor _tmp218_ = {0};
		HeColorCAM16Color _tmp219_;
		HeColorCAM16Color _tmp220_;
		HeColorHCTColor _tmp221_ = {0};
		HeColorHCTColor _tmp222_ = {0};
#line 148 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 148 "../lib/Models/StyleManager.vala"
			_tmp216_ = 90.0;
#line 1720 "StyleManager.c"
		} else {
#line 148 "../lib/Models/StyleManager.vala"
			_tmp216_ = 80.0;
#line 1724 "StyleManager.c"
		}
#line 148 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 148 "../lib/Models/StyleManager.vala"
			_tmp217_ = 90.0;
#line 1730 "StyleManager.c"
		} else {
#line 148 "../lib/Models/StyleManager.vala"
			_tmp217_ = 80.0;
#line 1734 "StyleManager.c"
		}
#line 148 "../lib/Models/StyleManager.vala"
		he_color_from_params (309.0, 34.0, _tmp216_, &_tmp218_);
#line 148 "../lib/Models/StyleManager.vala"
		_tmp219_ = cam16_color;
#line 148 "../lib/Models/StyleManager.vala"
		_tmp220_ = cam16_color;
#line 148 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp219_.h, _tmp220_.c, _tmp217_, &_tmp221_);
#line 148 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp218_, &_tmp221_, &_tmp222_);
#line 148 "../lib/Models/StyleManager.vala"
		_tmp215_ = _tmp222_;
#line 1748 "StyleManager.c"
	} else {
		gdouble _tmp223_ = 0.0;
		gdouble _tmp224_ = 0.0;
		HeColorHCTColor _tmp225_ = {0};
		HeColorCAM16Color _tmp226_;
		HeColorCAM16Color _tmp227_;
		HeColorHCTColor _tmp228_ = {0};
		HeColorHCTColor _tmp229_ = {0};
#line 149 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 149 "../lib/Models/StyleManager.vala"
			_tmp223_ = 20.0;
#line 1761 "StyleManager.c"
		} else {
#line 149 "../lib/Models/StyleManager.vala"
			_tmp223_ = 40.0;
#line 1765 "StyleManager.c"
		}
#line 149 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 149 "../lib/Models/StyleManager.vala"
			_tmp224_ = 20.0;
#line 1771 "StyleManager.c"
		} else {
#line 149 "../lib/Models/StyleManager.vala"
			_tmp224_ = 40.0;
#line 1775 "StyleManager.c"
		}
#line 149 "../lib/Models/StyleManager.vala"
		he_color_from_params (311.0, 57.0, _tmp223_, &_tmp225_);
#line 149 "../lib/Models/StyleManager.vala"
		_tmp226_ = cam16_color;
#line 149 "../lib/Models/StyleManager.vala"
		_tmp227_ = cam16_color;
#line 149 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp226_.h, _tmp227_.c, _tmp224_, &_tmp228_);
#line 149 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp225_, &_tmp228_, &_tmp229_);
#line 149 "../lib/Models/StyleManager.vala"
		_tmp215_ = _tmp229_;
#line 1789 "StyleManager.c"
	}
#line 147 "../lib/Models/StyleManager.vala"
	tau_purple_hct = _tmp215_;
#line 150 "../lib/Models/StyleManager.vala"
	_tmp230_ = tau_purple_hct;
#line 150 "../lib/Models/StyleManager.vala"
	_tmp231_ = tau_purple_hct;
#line 150 "../lib/Models/StyleManager.vala"
	_tmp232_ = tau_purple_hct;
#line 150 "../lib/Models/StyleManager.vala"
	_tmp233_ = he_color_hct_to_hex (_tmp230_.h, _tmp231_.c, _tmp232_.t);
#line 150 "../lib/Models/StyleManager.vala"
	tau_purple_hex = _tmp233_;
#line 152 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1805 "StyleManager.c"
		gdouble _tmp235_ = 0.0;
		gdouble _tmp236_ = 0.0;
		HeColorHCTColor _tmp237_ = {0};
		HeColorCAM16Color _tmp238_;
		HeColorCAM16Color _tmp239_;
		HeColorHCTColor _tmp240_ = {0};
		HeColorHCTColor _tmp241_ = {0};
#line 153 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 153 "../lib/Models/StyleManager.vala"
			_tmp235_ = 90.0;
#line 1817 "StyleManager.c"
		} else {
#line 153 "../lib/Models/StyleManager.vala"
			_tmp235_ = 80.0;
#line 1821 "StyleManager.c"
		}
#line 153 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 153 "../lib/Models/StyleManager.vala"
			_tmp236_ = 90.0;
#line 1827 "StyleManager.c"
		} else {
#line 153 "../lib/Models/StyleManager.vala"
			_tmp236_ = 80.0;
#line 1831 "StyleManager.c"
		}
#line 153 "../lib/Models/StyleManager.vala"
		he_color_from_params (337.0, 34.0, _tmp235_, &_tmp237_);
#line 153 "../lib/Models/StyleManager.vala"
		_tmp238_ = cam16_color;
#line 153 "../lib/Models/StyleManager.vala"
		_tmp239_ = cam16_color;
#line 153 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp238_.h, _tmp239_.c, _tmp236_, &_tmp240_);
#line 153 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp237_, &_tmp240_, &_tmp241_);
#line 153 "../lib/Models/StyleManager.vala"
		_tmp234_ = _tmp241_;
#line 1845 "StyleManager.c"
	} else {
		gdouble _tmp242_ = 0.0;
		gdouble _tmp243_ = 0.0;
		HeColorHCTColor _tmp244_ = {0};
		HeColorCAM16Color _tmp245_;
		HeColorCAM16Color _tmp246_;
		HeColorHCTColor _tmp247_ = {0};
		HeColorHCTColor _tmp248_ = {0};
#line 154 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 154 "../lib/Models/StyleManager.vala"
			_tmp242_ = 20.0;
#line 1858 "StyleManager.c"
		} else {
#line 154 "../lib/Models/StyleManager.vala"
			_tmp242_ = 40.0;
#line 1862 "StyleManager.c"
		}
#line 154 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 154 "../lib/Models/StyleManager.vala"
			_tmp243_ = 20.0;
#line 1868 "StyleManager.c"
		} else {
#line 154 "../lib/Models/StyleManager.vala"
			_tmp243_ = 40.0;
#line 1872 "StyleManager.c"
		}
#line 154 "../lib/Models/StyleManager.vala"
		he_color_from_params (340.0, 60.0, _tmp242_, &_tmp244_);
#line 154 "../lib/Models/StyleManager.vala"
		_tmp245_ = cam16_color;
#line 154 "../lib/Models/StyleManager.vala"
		_tmp246_ = cam16_color;
#line 154 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp245_.h, _tmp246_.c, _tmp243_, &_tmp247_);
#line 154 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp244_, &_tmp247_, &_tmp248_);
#line 154 "../lib/Models/StyleManager.vala"
		_tmp234_ = _tmp248_;
#line 1886 "StyleManager.c"
	}
#line 152 "../lib/Models/StyleManager.vala"
	fermion_pink_hct = _tmp234_;
#line 155 "../lib/Models/StyleManager.vala"
	_tmp249_ = fermion_pink_hct;
#line 155 "../lib/Models/StyleManager.vala"
	_tmp250_ = fermion_pink_hct;
#line 155 "../lib/Models/StyleManager.vala"
	_tmp251_ = fermion_pink_hct;
#line 155 "../lib/Models/StyleManager.vala"
	_tmp252_ = he_color_hct_to_hex (_tmp249_.h, _tmp250_.c, _tmp251_.t);
#line 155 "../lib/Models/StyleManager.vala"
	fermion_pink_hex = _tmp252_;
#line 157 "../lib/Models/StyleManager.vala"
	if (self->is_dark) {
#line 1902 "StyleManager.c"
		gdouble _tmp254_ = 0.0;
		gdouble _tmp255_ = 0.0;
		HeColorHCTColor _tmp256_ = {0};
		HeColorCAM16Color _tmp257_;
		HeColorCAM16Color _tmp258_;
		HeColorHCTColor _tmp259_ = {0};
		HeColorHCTColor _tmp260_ = {0};
#line 158 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 158 "../lib/Models/StyleManager.vala"
			_tmp254_ = 90.0;
#line 1914 "StyleManager.c"
		} else {
#line 158 "../lib/Models/StyleManager.vala"
			_tmp254_ = 80.0;
#line 1918 "StyleManager.c"
		}
#line 158 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 158 "../lib/Models/StyleManager.vala"
			_tmp255_ = 90.0;
#line 1924 "StyleManager.c"
		} else {
#line 158 "../lib/Models/StyleManager.vala"
			_tmp255_ = 80.0;
#line 1928 "StyleManager.c"
		}
#line 158 "../lib/Models/StyleManager.vala"
		he_color_from_params (66.0, 12.0, _tmp254_, &_tmp256_);
#line 158 "../lib/Models/StyleManager.vala"
		_tmp257_ = cam16_color;
#line 158 "../lib/Models/StyleManager.vala"
		_tmp258_ = cam16_color;
#line 158 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp257_.h, _tmp258_.c, _tmp255_, &_tmp259_);
#line 158 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp256_, &_tmp259_, &_tmp260_);
#line 158 "../lib/Models/StyleManager.vala"
		_tmp253_ = _tmp260_;
#line 1942 "StyleManager.c"
	} else {
		gdouble _tmp261_ = 0.0;
		gdouble _tmp262_ = 0.0;
		HeColorHCTColor _tmp263_ = {0};
		HeColorCAM16Color _tmp264_;
		HeColorCAM16Color _tmp265_;
		HeColorHCTColor _tmp266_ = {0};
		HeColorHCTColor _tmp267_ = {0};
#line 159 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 159 "../lib/Models/StyleManager.vala"
			_tmp261_ = 20.0;
#line 1955 "StyleManager.c"
		} else {
#line 159 "../lib/Models/StyleManager.vala"
			_tmp261_ = 40.0;
#line 1959 "StyleManager.c"
		}
#line 159 "../lib/Models/StyleManager.vala"
		if (self->is_contrast) {
#line 159 "../lib/Models/StyleManager.vala"
			_tmp262_ = 20.0;
#line 1965 "StyleManager.c"
		} else {
#line 159 "../lib/Models/StyleManager.vala"
			_tmp262_ = 40.0;
#line 1969 "StyleManager.c"
		}
#line 159 "../lib/Models/StyleManager.vala"
		he_color_from_params (61.0, 30.0, _tmp261_, &_tmp263_);
#line 159 "../lib/Models/StyleManager.vala"
		_tmp264_ = cam16_color;
#line 159 "../lib/Models/StyleManager.vala"
		_tmp265_ = cam16_color;
#line 159 "../lib/Models/StyleManager.vala"
		he_color_from_params (_tmp264_.h, _tmp265_.c, _tmp262_, &_tmp266_);
#line 159 "../lib/Models/StyleManager.vala"
		he_color_hct_blend (&_tmp263_, &_tmp266_, &_tmp267_);
#line 159 "../lib/Models/StyleManager.vala"
		_tmp253_ = _tmp267_;
#line 1983 "StyleManager.c"
	}
#line 157 "../lib/Models/StyleManager.vala"
	gluon_brown_hct = _tmp253_;
#line 160 "../lib/Models/StyleManager.vala"
	_tmp268_ = gluon_brown_hct;
#line 160 "../lib/Models/StyleManager.vala"
	_tmp269_ = gluon_brown_hct;
#line 160 "../lib/Models/StyleManager.vala"
	_tmp270_ = gluon_brown_hct;
#line 160 "../lib/Models/StyleManager.vala"
	_tmp271_ = he_color_hct_to_hex (_tmp268_.h, _tmp269_.c, _tmp270_.t);
#line 160 "../lib/Models/StyleManager.vala"
	gluon_brown_hex = _tmp271_;
#line 162 "../lib/Models/StyleManager.vala"
	_tmp272_ = g_strdup ("");
#line 162 "../lib/Models/StyleManager.vala"
	css = _tmp272_;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp273_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp274_ = _tmp273_.primary_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp275_ = string_to_string (_tmp274_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp276_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp277_ = _tmp276_.primary_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp278_ = string_to_string (_tmp277_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp279_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp280_ = _tmp279_.on_primary_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp281_ = string_to_string (_tmp280_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp282_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp283_ = _tmp282_.primary_container_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp284_ = string_to_string (_tmp283_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp285_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp286_ = _tmp285_.primary_container_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp287_ = string_to_string (_tmp286_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp288_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp289_ = _tmp288_.on_primary_container_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp290_ = string_to_string (_tmp289_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp291_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp292_ = _tmp291_.surface_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp293_ = string_to_string (_tmp292_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp294_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp295_ = _tmp294_.surface_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp296_ = string_to_string (_tmp295_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp297_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp298_ = _tmp297_.surface_bg_variant_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp299_ = string_to_string (_tmp298_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp300_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp301_ = _tmp300_.surface_container_high_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp302_ = string_to_string (_tmp301_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp303_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp304_ = _tmp303_.surface_container_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp305_ = string_to_string (_tmp304_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp306_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp307_ = _tmp306_.surface_fg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp308_ = string_to_string (_tmp307_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp309_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp310_ = _tmp309_.surface_fg_variant_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp311_ = string_to_string (_tmp310_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp312_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp313_ = _tmp312_.surface_fg_variant_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp314_ = string_to_string (_tmp313_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp315_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp316_ = _tmp315_.surface_fg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp317_ = string_to_string (_tmp316_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp318_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp319_ = _tmp318_.surface_fg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp320_ = string_to_string (_tmp319_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp321_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp322_ = _tmp321_.surface_bright_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp323_ = string_to_string (_tmp322_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp324_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp325_ = _tmp324_.surface_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp326_ = string_to_string (_tmp325_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp327_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp328_ = _tmp327_.surface_dim_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp329_ = string_to_string (_tmp328_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp330_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp331_ = _tmp330_.surface_container_lowest_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp332_ = string_to_string (_tmp331_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp333_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp334_ = _tmp333_.surface_container_low_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp335_ = string_to_string (_tmp334_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp336_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp337_ = _tmp336_.surface_container_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp338_ = string_to_string (_tmp337_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp339_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp340_ = _tmp339_.surface_container_high_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp341_ = string_to_string (_tmp340_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp342_ = chosen_scheme;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp343_ = _tmp342_.surface_container_highest_bg_hex;
#line 163 "../lib/Models/StyleManager.vala"
	_tmp344_ = string_to_string (_tmp343_);
#line 163 "../lib/Models/StyleManager.vala"
	_tmp345_ = g_strconcat ("\n    @define-color accent_color ", _tmp275_, ";\n    @define-color accent_bg_color ", _tmp278_, ";\n    @define-color accent_fg_color ", _tmp281_, ";\n    @define-color accent_container_color ", _tmp284_, ";\n    @define-color accent_container_bg_color ", _tmp287_, ";\n    @define-color accent_container_fg_color ", _tmp290_, ";\n\n    @define-color window_bg_color ", _tmp293_, ";\n    @define-color view_bg_color ", _tmp296_, ";\n    @define-color headerbar_bg_color ", _tmp299_, ";\n    @define-color popover_bg_color ", _tmp302_, ";\n    @define-color card_bg_color ", _tmp305_, ";\n    @define-color window_fg_color ", _tmp308_, ";\n    @define-color view_fg_color ", _tmp311_, ";\n    @define-color headerbar_fg_color ", _tmp314_, ";\n    @define-color popover_fg_color ", _tmp317_, ";\n    @define-color card_fg_color ", _tmp320_, ";\n\n    @define-color surface_bright_bg_color ", _tmp323_, ";\n    @define-color surface_bg_color ", _tmp326_, ";\n    @define-color surface_dim_bg_color ", _tmp329_, ";\n    @define-color surface_container_lowest_bg_color ", _tmp332_, ";\n    @define-color surface_container_low_bg_color ", _tmp335_, ";\n    @define-color surface_container_bg_color ", _tmp338_, ";\n    @define-color surface_container_high_bg_color ", _tmp341_, ";\n    @define-color surface_container_highest_bg_color ", _tmp344_, ";\n    ", NULL);
#line 163 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 163 "../lib/Models/StyleManager.vala"
	css = _tmp345_;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp346_ = css;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp347_ = error_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp348_ = string_to_string (_tmp347_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp349_ = on_error_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp350_ = string_to_string (_tmp349_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp351_ = error_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp352_ = string_to_string (_tmp351_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp353_ = on_error_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp354_ = string_to_string (_tmp353_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp355_ = error_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp356_ = string_to_string (_tmp355_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp357_ = on_error_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp358_ = string_to_string (_tmp357_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp359_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp360_ = _tmp359_.secondary_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp361_ = string_to_string (_tmp360_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp362_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp363_ = _tmp362_.on_secondary_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp364_ = string_to_string (_tmp363_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp365_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp366_ = _tmp365_.secondary_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp367_ = string_to_string (_tmp366_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp368_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp369_ = _tmp368_.secondary_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp370_ = string_to_string (_tmp369_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp371_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp372_ = _tmp371_.secondary_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp373_ = string_to_string (_tmp372_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp374_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp375_ = _tmp374_.on_secondary_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp376_ = string_to_string (_tmp375_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp377_ = error_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp378_ = string_to_string (_tmp377_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp379_ = on_error_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp380_ = string_to_string (_tmp379_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp381_ = error_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp382_ = string_to_string (_tmp381_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp383_ = error_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp384_ = string_to_string (_tmp383_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp385_ = error_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp386_ = string_to_string (_tmp385_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp387_ = on_error_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp388_ = string_to_string (_tmp387_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp389_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp390_ = _tmp389_.tertiary_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp391_ = string_to_string (_tmp390_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp392_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp393_ = _tmp392_.on_tertiary_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp394_ = string_to_string (_tmp393_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp395_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp396_ = _tmp395_.tertiary_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp397_ = string_to_string (_tmp396_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp398_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp399_ = _tmp398_.tertiary_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp400_ = string_to_string (_tmp399_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp401_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp402_ = _tmp401_.tertiary_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp403_ = string_to_string (_tmp402_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp404_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp405_ = _tmp404_.on_tertiary_container_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp406_ = string_to_string (_tmp405_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp407_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp408_ = _tmp407_.outline_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp409_ = string_to_string (_tmp408_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp410_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp411_ = _tmp410_.outline_variant_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp412_ = string_to_string (_tmp411_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp413_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp414_ = _tmp413_.shadow_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp415_ = string_to_string (_tmp414_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp416_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp417_ = _tmp416_.scrim_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp418_ = string_to_string (_tmp417_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp419_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp420_ = _tmp419_.inverse_surface_bg_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp421_ = string_to_string (_tmp420_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp422_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp423_ = _tmp422_.inverse_surface_fg_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp424_ = string_to_string (_tmp423_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp425_ = chosen_scheme;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp426_ = _tmp425_.inverse_primary_hex;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp427_ = string_to_string (_tmp426_);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp428_ = g_strconcat ("\n    @define-color destructive_bg_color ", _tmp348_, ";\n    @define-color destructive_fg_color ", _tmp350_, ";\n    @define-color destructive_color ", _tmp352_, ";\n    @define-color destructive_container_color ", _tmp354_, ";\n    @define-color destructive_container_bg_color ", _tmp356_, ";\n    @define-color destructive_container_fg_color ", _tmp358_, ";\n\n    @define-color suggested_bg_color ", _tmp361_, ";\n    @define-color suggested_fg_color ", _tmp364_, ";\n    @define-color suggested_color ", _tmp367_, ";\n    @define-color suggested_container_color ", _tmp370_, ";\n    @define-color suggested_container_bg_color ", _tmp373_, ";\n    @define-color suggested_container_fg_color ", _tmp376_, ";\n\n    @define-color error_bg_color ", _tmp378_, ";\n    @define-color error_fg_color ", _tmp380_, ";\n    @define-color error_color ", _tmp382_, ";\n    @define-color error_container_color ", _tmp384_, ";\n    @define-color error_container_bg_color ", _tmp386_, ";\n    @define-color error_container_fg_color ", _tmp388_, ";\n\n    @define-color success_bg_color ", _tmp391_, ";\n    @define-color success_fg_color ", _tmp394_, ";\n    @define-color success_color ", _tmp397_, ";\n    @define-color success_container_color ", _tmp400_, ";\n    @define-color success_container_bg_color ", _tmp403_, ";\n    @define-color success_container_fg_color ", _tmp406_, ";\n\n    @define-color outline ", _tmp409_, ";\n    @define-color borders ", _tmp412_, ";\n    @define-color shadow ", _tmp415_, ";\n    @define-color scrim ", _tmp418_, ";\n    @define-color osd_bg_color ", _tmp421_, ";\n    @define-color osd_fg_color ", _tmp424_, ";\n    @define-color osd_accent_color ", _tmp427_, ";\n    ", NULL);
#line 192 "../lib/Models/StyleManager.vala"
	_tmp429_ = _tmp428_;
#line 192 "../lib/Models/StyleManager.vala"
	_tmp430_ = g_strconcat (_tmp346_, _tmp429_, NULL);
#line 192 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 192 "../lib/Models/StyleManager.vala"
	css = _tmp430_;
#line 192 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp429_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp431_ = css;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp432_ = meson_red_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp433_ = string_to_string (_tmp432_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp434_ = lepton_orange_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp435_ = string_to_string (_tmp434_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp436_ = electron_yellow_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp437_ = string_to_string (_tmp436_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp438_ = muon_green_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp439_ = string_to_string (_tmp438_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp440_ = baryon_mint_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp441_ = string_to_string (_tmp440_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp442_ = proton_blue_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp443_ = string_to_string (_tmp442_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp444_ = photon_indigo_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp445_ = string_to_string (_tmp444_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp446_ = tau_purple_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp447_ = string_to_string (_tmp446_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp448_ = fermion_pink_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp449_ = string_to_string (_tmp448_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp450_ = gluon_brown_hex;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp451_ = string_to_string (_tmp450_);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp452_ = g_strconcat ("\n    @define-color meson_red ", _tmp433_, ";\n    @define-color lepton_orange ", _tmp435_, ";\n    @define-color electron_yellow ", _tmp437_, ";\n    @define-color muon_green ", _tmp439_, ";\n    @define-color baryon_mint ", _tmp441_, ";\n    @define-color proton_blue ", _tmp443_, ";\n    @define-color photon_indigo ", _tmp445_, ";\n    @define-color tau_purple ", _tmp447_, ";\n    @define-color fermion_pink ", _tmp449_, ";\n    @define-color gluon_brown ", _tmp451_, ";\n    ", NULL);
#line 230 "../lib/Models/StyleManager.vala"
	_tmp453_ = _tmp452_;
#line 230 "../lib/Models/StyleManager.vala"
	_tmp454_ = g_strconcat (_tmp431_, _tmp453_, NULL);
#line 230 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 230 "../lib/Models/StyleManager.vala"
	css = _tmp454_;
#line 230 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp453_);
#line 243 "../lib/Models/StyleManager.vala"
	light_weight = 300 * self->font_weight;
#line 244 "../lib/Models/StyleManager.vala"
	heavy_weight = 700 * self->font_weight;
#line 246 "../lib/Models/StyleManager.vala"
	_tmp455_ = css;
#line 246 "../lib/Models/StyleManager.vala"
	_tmp456_ = double_to_string (base_weight);
#line 246 "../lib/Models/StyleManager.vala"
	_tmp457_ = _tmp456_;
#line 246 "../lib/Models/StyleManager.vala"
	_tmp458_ = double_to_string (light_weight);
#line 246 "../lib/Models/StyleManager.vala"
	_tmp459_ = _tmp458_;
#line 246 "../lib/Models/StyleManager.vala"
	_tmp460_ = double_to_string (heavy_weight);
#line 246 "../lib/Models/StyleManager.vala"
	_tmp461_ = _tmp460_;
#line 246 "../lib/Models/StyleManager.vala"
	_tmp462_ = g_strconcat ("\n" \
"    label,\n" \
"    .view-switcher button label,\n" \
"    .big-display,\n" \
"    .view-subtitle,\n" \
"    .cb-subtitle,\n" \
"    .body {\n" \
"      font-weight: ", _tmp457_, ";\n" \
"    }\n" \
"    .large-title,\n" \
"    .display,\n" \
"    .view-title {\n" \
"      font-weight: ", _tmp459_, ";\n" \
"    }\n" \
"    .title-1,\n" \
"    .title-2,\n" \
"    .title-3,\n" \
"    .title-4,\n" \
"    .heading,\n" \
"    .header,\n" \
"    .caption,\n" \
"    .caption-heading,\n" \
"    .cb-title,\n" \
"    button label,\n" \
"    .badge label,\n" \
"    .badge-info label,\n" \
"    .tint-badge label,\n" \
"    .modifier-badge label {\n" \
"      font-weight: ", _tmp461_, ";\n    }\n    ", NULL);
#line 246 "../lib/Models/StyleManager.vala"
	_tmp463_ = _tmp462_;
#line 246 "../lib/Models/StyleManager.vala"
	_tmp464_ = g_strconcat (_tmp455_, _tmp463_, NULL);
#line 246 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 246 "../lib/Models/StyleManager.vala"
	css = _tmp464_;
#line 246 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp463_);
#line 246 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp461_);
#line 246 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp459_);
#line 246 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp457_);
#line 278 "../lib/Models/StyleManager.vala"
	_tmp465_ = double_to_string (0.5 * base_roundness);
#line 278 "../lib/Models/StyleManager.vala"
	_tmp466_ = _tmp465_;
#line 278 "../lib/Models/StyleManager.vala"
	_tmp467_ = g_strconcat (_tmp466_, "px", NULL);
#line 278 "../lib/Models/StyleManager.vala"
	_tmp468_ = _tmp467_;
#line 278 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp466_);
#line 278 "../lib/Models/StyleManager.vala"
	small_roundness = _tmp468_;
#line 279 "../lib/Models/StyleManager.vala"
	_tmp469_ = double_to_string (1 * base_roundness);
#line 279 "../lib/Models/StyleManager.vala"
	_tmp470_ = _tmp469_;
#line 279 "../lib/Models/StyleManager.vala"
	_tmp471_ = g_strconcat (_tmp470_, "px", NULL);
#line 279 "../lib/Models/StyleManager.vala"
	_tmp472_ = _tmp471_;
#line 279 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp470_);
#line 279 "../lib/Models/StyleManager.vala"
	medium_roundness = _tmp472_;
#line 280 "../lib/Models/StyleManager.vala"
	_tmp473_ = double_to_string (2 * base_roundness);
#line 280 "../lib/Models/StyleManager.vala"
	_tmp474_ = _tmp473_;
#line 280 "../lib/Models/StyleManager.vala"
	_tmp475_ = g_strconcat (_tmp474_, "px", NULL);
#line 280 "../lib/Models/StyleManager.vala"
	_tmp476_ = _tmp475_;
#line 280 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp474_);
#line 280 "../lib/Models/StyleManager.vala"
	large_roundness = _tmp476_;
#line 281 "../lib/Models/StyleManager.vala"
	_tmp477_ = double_to_string (3 * base_roundness);
#line 281 "../lib/Models/StyleManager.vala"
	_tmp478_ = _tmp477_;
#line 281 "../lib/Models/StyleManager.vala"
	_tmp479_ = g_strconcat (_tmp478_, "px", NULL);
#line 281 "../lib/Models/StyleManager.vala"
	_tmp480_ = _tmp479_;
#line 281 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp478_);
#line 281 "../lib/Models/StyleManager.vala"
	x_large_roundness = _tmp480_;
#line 282 "../lib/Models/StyleManager.vala"
	_tmp481_ = double_to_string (12.5 * base_roundness);
#line 282 "../lib/Models/StyleManager.vala"
	_tmp482_ = _tmp481_;
#line 282 "../lib/Models/StyleManager.vala"
	_tmp483_ = g_strconcat (_tmp482_, "px", NULL);
#line 282 "../lib/Models/StyleManager.vala"
	_tmp484_ = _tmp483_;
#line 282 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp482_);
#line 282 "../lib/Models/StyleManager.vala"
	circle_roundness = _tmp484_;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp485_ = css;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp486_ = small_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp487_ = string_to_string (_tmp486_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp488_ = medium_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp489_ = string_to_string (_tmp488_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp490_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp491_ = string_to_string (_tmp490_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp492_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp493_ = string_to_string (_tmp492_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp494_ = circle_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp495_ = string_to_string (_tmp494_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp496_ = small_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp497_ = string_to_string (_tmp496_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp498_ = medium_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp499_ = string_to_string (_tmp498_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp500_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp501_ = string_to_string (_tmp500_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp502_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp503_ = string_to_string (_tmp502_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp504_ = circle_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp505_ = string_to_string (_tmp504_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp506_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp507_ = string_to_string (_tmp506_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp508_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp509_ = string_to_string (_tmp508_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp510_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp511_ = string_to_string (_tmp510_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp512_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp513_ = string_to_string (_tmp512_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp514_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp515_ = string_to_string (_tmp514_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp516_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp517_ = string_to_string (_tmp516_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp518_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp519_ = string_to_string (_tmp518_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp520_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp521_ = string_to_string (_tmp520_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp522_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp523_ = string_to_string (_tmp522_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp524_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp525_ = string_to_string (_tmp524_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp526_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp527_ = string_to_string (_tmp526_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp528_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp529_ = string_to_string (_tmp528_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp530_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp531_ = string_to_string (_tmp530_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp532_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp533_ = string_to_string (_tmp532_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp534_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp535_ = string_to_string (_tmp534_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp536_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp537_ = string_to_string (_tmp536_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp538_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp539_ = string_to_string (_tmp538_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp540_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp541_ = string_to_string (_tmp540_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp542_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp543_ = string_to_string (_tmp542_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp544_ = x_large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp545_ = string_to_string (_tmp544_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp546_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp547_ = string_to_string (_tmp546_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp548_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp549_ = string_to_string (_tmp548_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp550_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp551_ = string_to_string (_tmp550_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp552_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp553_ = string_to_string (_tmp552_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp554_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp555_ = string_to_string (_tmp554_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp556_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp557_ = string_to_string (_tmp556_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp558_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp559_ = string_to_string (_tmp558_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp560_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp561_ = string_to_string (_tmp560_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp562_ = large_roundness;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp563_ = string_to_string (_tmp562_);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp564_ = g_strconcat ("\n    .small-radius {\n      border-radius: ", _tmp487_, ";\n    }\n    .medium-radius {\n      border-radius: ", _tmp489_, ";\n    }\n    .large-radius {\n      border-radius: ", _tmp491_, ";\n    }\n    .x-large-radius {\n      border-radius: ", _tmp493_, ";\n    }\n    .circle-radius {\n      border-radius: ", _tmp495_, ";\n" \
"    }\n" \
"\n" \
"    .view-switcher button.toggle {\n" \
"      border-radius: 0px;\n" \
"    }\n" \
"    .badge,\n" \
"    .badge-info,\n" \
"    .tint-badge {\n" \
"      border-radius: ", _tmp497_, ";\n" \
"    }\n" \
"    button,\n" \
"    .toast-box,\n" \
"    .text-view,\n" \
"    windowcontrols > button > image,\n" \
"    popover > contents,\n" \
"    check {\n" \
"      border-radius: ", _tmp499_, ";\n" \
"    }\n" \
"    .text-field,\n" \
"    .navigation-section-button,\n" \
"    scale > trough,\n" \
"    scale > trough > slider,\n" \
"    window.csd {\n" \
"      border-radius: ", _tmp501_, ";\n" \
"    }\n" \
"    .content-block,\n" \
"    .mini-content-block,\n" \
"    .bottom-bar,\n" \
"    .dialog-content,\n" \
"    .switchbar,\n" \
"    .navigation-section-list row .mini-content-block,\n" \
"    window.csd.dialog.message,\n" \
"    window.csd.dialog-content {\n" \
"      border-radius: ", _tmp503_, ";\n" \
"    }\n" \
"    .disclosure-button,\n" \
"    .disclosure-button .toggle,\n" \
"    .overlay-button,\n" \
"    .iconic-button,\n" \
"    .text-field.search,\n" \
"    .switch,\n" \
"    .switch > slider,\n" \
"    .modifier-badge,\n" \
"    .circular,\n" \
"    .pill-button,\n" \
"    switch,\n" \
"    switch > slider,\n" \
"    radio {\n" \
"      border-radius: ", _tmp505_, ";\n" \
"    }\n" \
"    .content-list row:first-child .mini-content-block {\n" \
"      border-top-left-radius: ", _tmp507_, ";\n	    border-top-right-radius: ", _tmp509_, ";\n      border-bottom-left-radius: ", _tmp511_, ";\n      border-bottom-right-radius: ", _tmp513_, ";\n" \
"    }\n" \
"    .content-list row:first-child:last-child .mini-content-block {\n" \
"      border-top-left-radius: ", _tmp515_, ";\n	    border-top-right-radius: ", _tmp517_, ";\n      border-bottom-left-radius: ", _tmp519_, ";\n      border-bottom-right-radius: ", _tmp521_, ";\n" \
"    }\n" \
"    .content-list row:last-child .mini-content-block {\n" \
"      border-top-left-radius: ", _tmp523_, ";\n	    border-top-right-radius: ", _tmp525_, ";\n      border-bottom-left-radius: ", _tmp527_, ";\n      border-bottom-right-radius: ", _tmp529_, ";\n" \
"    }\n" \
"    .segmented-button > button:not(:first-child),\n" \
"    .segmented-button > button:not(:last-child) {\n" \
"        border-top-left-radius: 0;\n" \
"        border-bottom-left-radius: 0;\n" \
"        border-top-right-radius: 0;\n" \
"        border-bottom-right-radius: 0;\n" \
"    }\n" \
"    .segmented-button button:first-child {\n" \
"        border-top-left-radius: ", _tmp531_, ";\n        border-bottom-left-radius: ", _tmp533_, ";\n" \
"    }\n" \
"    .segmented-button button:first-child:dir(rtl) {\n" \
"        border-top-right-radius: ", _tmp535_, ";\n        border-bottom-right-radius: ", _tmp537_, ";\n" \
"    }\n" \
"    .segmented-button button:last-child {\n" \
"        border-top-right-radius: ", _tmp539_, ";\n        border-bottom-right-radius: ", _tmp541_, ";\n" \
"    }\n" \
"    .segmented-button button:last-child:dir(rtl) {\n" \
"        border-top-left-radius: ", _tmp543_, ";\n        border-bottom-left-radius: ", _tmp545_, ";\n" \
"    }\n" \
"    progressbar > trough > progress {\n" \
"      border-radius: ", _tmp547_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.left {\n" \
"      border-top-left-radius: ", _tmp549_, ";\n      border-bottom-left-radius: ", _tmp551_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.right {\n" \
"      border-top-right-radius: ", _tmp553_, ";\n      border-bottom-right-radius: ", _tmp555_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.top {\n" \
"      border-top-right-radius: ", _tmp557_, ";\n      border-top-left-radius: ", _tmp559_, ";\n" \
"    }\n" \
"    progressbar > trough > progress.bottom {\n" \
"      border-bottom-right-radius: ", _tmp561_, ";\n      border-bottom-left-radius: ", _tmp563_, ";\n    }\n    ", NULL);
#line 284 "../lib/Models/StyleManager.vala"
	_tmp565_ = _tmp564_;
#line 284 "../lib/Models/StyleManager.vala"
	_tmp566_ = g_strconcat (_tmp485_, _tmp565_, NULL);
#line 284 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 284 "../lib/Models/StyleManager.vala"
	css = _tmp566_;
#line 284 "../lib/Models/StyleManager.vala"
	_g_free0 (_tmp565_);
#line 411 "../lib/Models/StyleManager.vala"
	_tmp567_ = self->priv->accent;
#line 411 "../lib/Models/StyleManager.vala"
	_tmp568_ = css;
#line 411 "../lib/Models/StyleManager.vala"
	he_misc_init_css_provider_from_string (_tmp567_, _tmp568_);
#line 412 "../lib/Models/StyleManager.vala"
	_tmp569_ = self->priv->light;
#line 412 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp569_, !self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 413 "../lib/Models/StyleManager.vala"
	_tmp570_ = self->priv->dark;
#line 413 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp570_, self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 414 "../lib/Models/StyleManager.vala"
	_tmp571_ = self->priv->_user_dark;
#line 414 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp571_, self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK);
#line 416 "../lib/Models/StyleManager.vala"
	_tmp572_ = gtk_settings_get_default ();
#line 416 "../lib/Models/StyleManager.vala"
	_tmp573_ = _g_object_ref0 (_tmp572_);
#line 416 "../lib/Models/StyleManager.vala"
	settings = _tmp573_;
#line 417 "../lib/Models/StyleManager.vala"
	_tmp574_ = settings;
#line 417 "../lib/Models/StyleManager.vala"
	g_object_set (_tmp574_, "gtk-application-prefer-dark-theme", self->is_dark, NULL);
#line 81 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (settings);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (circle_roundness);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (x_large_roundness);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (large_roundness);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (medium_roundness);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (small_roundness);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (css);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (gluon_brown_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (fermion_pink_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (tau_purple_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (photon_indigo_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (proton_blue_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (baryon_mint_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (muon_green_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (electron_yellow_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (lepton_orange_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (meson_red_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (on_error_container_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (error_container_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (on_error_hex);
#line 81 "../lib/Models/StyleManager.vala"
	_g_free0 (error_hex);
#line 81 "../lib/Models/StyleManager.vala"
	he_scheme_destroy (&chosen_scheme);
#line 81 "../lib/Models/StyleManager.vala"
	_he_color_rgb_color_free0 (rgb_color);
#line 2721 "StyleManager.c"
}

/**
  * Register the style manager with GTK. This will also call update.
  */
void
he_style_manager_register (HeStyleManager* self)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkSettings* settings = NULL;
	GtkSettings* _tmp4_;
	GtkSettings* _tmp5_;
#line 423 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 425 "../lib/Models/StyleManager.vala"
	g_debug ("StyleManager.vala:425: Loading bundled Helium stylesheet");
#line 426 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->light;
#line 426 "../lib/Models/StyleManager.vala"
	gtk_css_provider_load_from_resource (_tmp0_, "/com/fyralabs/Helium/gtk.css");
#line 427 "../lib/Models/StyleManager.vala"
	_tmp1_ = self->priv->dark;
#line 427 "../lib/Models/StyleManager.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/com/fyralabs/Helium/gtk-dark.css");
#line 434 "../lib/Models/StyleManager.vala"
	_tmp2_ = self->priv->accent;
#line 434 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp2_, TRUE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT);
#line 435 "../lib/Models/StyleManager.vala"
	_tmp3_ = self->priv->_user_base;
#line 435 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp3_, TRUE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE);
#line 438 "../lib/Models/StyleManager.vala"
	_tmp4_ = gtk_settings_get_default ();
#line 438 "../lib/Models/StyleManager.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 438 "../lib/Models/StyleManager.vala"
	settings = _tmp5_;
#line 439 "../lib/Models/StyleManager.vala"
	g_object_set (settings, "gtk-theme-name", "Helium-empty", NULL);
#line 440 "../lib/Models/StyleManager.vala"
	g_object_set (settings, "gtk-icon-theme-name", "Hydrogen", NULL);
#line 442 "../lib/Models/StyleManager.vala"
	he_style_manager_set_is_registered (self, TRUE);
#line 444 "../lib/Models/StyleManager.vala"
	he_style_manager_update (self);
#line 423 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (settings);
#line 2773 "StyleManager.c"
}

/**
  * Unregister the style manager with GTK.
  */
void
he_style_manager_unregister (HeStyleManager* self)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
#line 450 "../lib/Models/StyleManager.vala"
	g_return_if_fail (self != NULL);
#line 451 "../lib/Models/StyleManager.vala"
	_tmp0_ = self->priv->accent;
#line 451 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp0_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT);
#line 452 "../lib/Models/StyleManager.vala"
	_tmp1_ = self->priv->light;
#line 452 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp1_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 453 "../lib/Models/StyleManager.vala"
	_tmp2_ = self->priv->dark;
#line 453 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp2_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
#line 454 "../lib/Models/StyleManager.vala"
	_tmp3_ = self->priv->_user_base;
#line 454 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp3_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE);
#line 455 "../lib/Models/StyleManager.vala"
	_tmp4_ = self->priv->_user_dark;
#line 455 "../lib/Models/StyleManager.vala"
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp4_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK);
#line 457 "../lib/Models/StyleManager.vala"
	he_style_manager_set_is_registered (self, FALSE);
#line 2811 "StyleManager.c"
}

HeStyleManager*
he_style_manager_construct (GType object_type)
{
	HeStyleManager * self = NULL;
#line 24 "../lib/Models/StyleManager.vala"
	self = (HeStyleManager*) g_object_new (object_type, NULL);
#line 24 "../lib/Models/StyleManager.vala"
	return self;
#line 2822 "StyleManager.c"
}

HeStyleManager*
he_style_manager_new (void)
{
#line 24 "../lib/Models/StyleManager.vala"
	return he_style_manager_construct (HE_TYPE_STYLE_MANAGER);
#line 2830 "StyleManager.c"
}

static void
he_style_manager_class_init (HeStyleManagerClass * klass,
                             gpointer klass_data)
{
#line 24 "../lib/Models/StyleManager.vala"
	he_style_manager_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/Models/StyleManager.vala"
	g_type_class_adjust_private_offset (klass, &HeStyleManager_private_offset);
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_style_manager_get_property;
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_style_manager_set_property;
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (klass)->finalize = he_style_manager_finalize;
#line 2847 "StyleManager.c"
	/**
	  * Whether the style manager has been registered. Unregistered style managers will not apply their styles.
	  */
#line 24 "../lib/Models/StyleManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY] = g_param_spec_boolean ("is-registered", "is-registered", "is-registered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2853 "StyleManager.c"
	/**
	  * The base style provider for application provided styles. In this case user refers to the application, not the user of the application.
	  */
#line 24 "../lib/Models/StyleManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_USER_BASE_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_USER_BASE_PROPERTY] = g_param_spec_object ("user-base", "user-base", "user-base", gtk_css_provider_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2859 "StyleManager.c"
	/**
	  * The dark style provider for application provided styles. This will be applied in addition to the base style provider when dark mode is enabled.
	  */
#line 24 "../lib/Models/StyleManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_USER_DARK_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_USER_DARK_PROPERTY] = g_param_spec_object ("user-dark", "user-dark", "user-dark", gtk_css_provider_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2865 "StyleManager.c"
}

static void
he_style_manager_instance_init (HeStyleManager * self,
                                gpointer klass)
{
	HeDefaultScheme* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
	GtkCssProvider* _tmp5_;
#line 24 "../lib/Models/StyleManager.vala"
	self->priv = he_style_manager_get_instance_private (self);
#line 28 "../lib/Models/StyleManager.vala"
	self->accent_color = NULL;
#line 33 "../lib/Models/StyleManager.vala"
	self->font_weight = 1.0;
#line 38 "../lib/Models/StyleManager.vala"
	self->roundness = 1.0;
#line 43 "../lib/Models/StyleManager.vala"
	self->is_dark = FALSE;
#line 48 "../lib/Models/StyleManager.vala"
	self->is_contrast = FALSE;
#line 53 "../lib/Models/StyleManager.vala"
	_tmp0_ = he_default_scheme_new ();
#line 53 "../lib/Models/StyleManager.vala"
	self->scheme_factory = (HeSchemeFactory*) _tmp0_;
#line 58 "../lib/Models/StyleManager.vala"
	self->priv->_is_registered = FALSE;
#line 65 "../lib/Models/StyleManager.vala"
	_tmp1_ = gtk_css_provider_new ();
#line 65 "../lib/Models/StyleManager.vala"
	self->priv->light = _tmp1_;
#line 66 "../lib/Models/StyleManager.vala"
	_tmp2_ = gtk_css_provider_new ();
#line 66 "../lib/Models/StyleManager.vala"
	self->priv->dark = _tmp2_;
#line 67 "../lib/Models/StyleManager.vala"
	_tmp3_ = gtk_css_provider_new ();
#line 67 "../lib/Models/StyleManager.vala"
	self->priv->accent = _tmp3_;
#line 72 "../lib/Models/StyleManager.vala"
	_tmp4_ = gtk_css_provider_new ();
#line 72 "../lib/Models/StyleManager.vala"
	self->priv->_user_base = _tmp4_;
#line 76 "../lib/Models/StyleManager.vala"
	_tmp5_ = gtk_css_provider_new ();
#line 76 "../lib/Models/StyleManager.vala"
	self->priv->_user_dark = _tmp5_;
#line 2916 "StyleManager.c"
}

static void
he_style_manager_finalize (GObject * obj)
{
	HeStyleManager * self;
#line 24 "../lib/Models/StyleManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_STYLE_MANAGER, HeStyleManager);
#line 461 "../lib/Models/StyleManager.vala"
	he_style_manager_unregister (self);
#line 28 "../lib/Models/StyleManager.vala"
	_he_color_rgb_color_free0 (self->accent_color);
#line 53 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->scheme_factory);
#line 65 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->light);
#line 66 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->dark);
#line 67 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->accent);
#line 72 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->_user_base);
#line 76 "../lib/Models/StyleManager.vala"
	_g_object_unref0 (self->priv->_user_dark);
#line 24 "../lib/Models/StyleManager.vala"
	G_OBJECT_CLASS (he_style_manager_parent_class)->finalize (obj);
#line 2943 "StyleManager.c"
}

/**
* A class that manages the style of the application in conjunction with the provided preferences.
* This is a low-level class that should not be used directly. Instead, let the `He.Application` class manage this for you.
*/
static GType
he_style_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeStyleManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_style_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeStyleManager), 0, (GInstanceInitFunc) he_style_manager_instance_init, NULL };
	GType he_style_manager_type_id;
	he_style_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "HeStyleManager", &g_define_type_info, 0);
	HeStyleManager_private_offset = g_type_add_instance_private (he_style_manager_type_id, sizeof (HeStyleManagerPrivate));
	return he_style_manager_type_id;
}

GType
he_style_manager_get_type (void)
{
	static volatile gsize he_style_manager_type_id__once = 0;
	if (g_once_init_enter (&he_style_manager_type_id__once)) {
		GType he_style_manager_type_id;
		he_style_manager_type_id = he_style_manager_get_type_once ();
		g_once_init_leave (&he_style_manager_type_id__once, he_style_manager_type_id);
	}
	return he_style_manager_type_id__once;
}

static void
_vala_he_style_manager_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	HeStyleManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_STYLE_MANAGER, HeStyleManager);
#line 24 "../lib/Models/StyleManager.vala"
	switch (property_id) {
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		g_value_set_boolean (value, he_style_manager_get_is_registered (self));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_USER_BASE_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		g_value_set_object (value, he_style_manager_get_user_base (self));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_USER_DARK_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		g_value_set_object (value, he_style_manager_get_user_dark (self));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 3000 "StyleManager.c"
		default:
#line 24 "../lib/Models/StyleManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 3006 "StyleManager.c"
	}
}

static void
_vala_he_style_manager_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	HeStyleManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_STYLE_MANAGER, HeStyleManager);
#line 24 "../lib/Models/StyleManager.vala"
	switch (property_id) {
#line 24 "../lib/Models/StyleManager.vala"
		case HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY:
#line 24 "../lib/Models/StyleManager.vala"
		he_style_manager_set_is_registered (self, g_value_get_boolean (value));
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 3026 "StyleManager.c"
		default:
#line 24 "../lib/Models/StyleManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Models/StyleManager.vala"
		break;
#line 3032 "StyleManager.c"
	}
}

