/* ARGB.c generated by valac 0.56.15, the Vala compiler
 * generated from ARGB.vala, do not modify */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "libhelium-1.h"

#define HE_COLOR_XN 0.95047
#define HE_COLOR_YN 1.00000
#define HE_COLOR_ZN 1.08883
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

const gdouble HE_COLOR_SRGB_TO_XYZ[3][3] = {{0.41233895, 0.35762064, 0.18051042}, {0.2126, 0.7152, 0.0722}, {0.01932141, 0.11916382, 0.95034478}};
VALA_EXTERN const gdouble HE_COLOR_XYZ_TO_SRGB[3][3];

gint
he_color_rgb_to_argb_int (HeColorRGBColor* color)
{
	gint clr = 0;
	HeColorRGBColor _tmp0_;
	HeColorRGBColor _tmp1_;
	HeColorRGBColor _tmp2_;
	gint result;
#line 8 "../lib/Utils/Color/ARGB.vala"
	g_return_val_if_fail (color != NULL, 0);
#line 9 "../lib/Utils/Color/ARGB.vala"
	clr = 0;
#line 10 "../lib/Utils/Color/ARGB.vala"
	_tmp0_ = *color;
#line 10 "../lib/Utils/Color/ARGB.vala"
	clr |= ((gint) _tmp0_.r) << 16;
#line 11 "../lib/Utils/Color/ARGB.vala"
	_tmp1_ = *color;
#line 11 "../lib/Utils/Color/ARGB.vala"
	clr |= ((gint) _tmp1_.g) << 8;
#line 12 "../lib/Utils/Color/ARGB.vala"
	_tmp2_ = *color;
#line 12 "../lib/Utils/Color/ARGB.vala"
	clr |= (gint) _tmp2_.b;
#line 14 "../lib/Utils/Color/ARGB.vala"
	result = clr;
#line 14 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 53 "ARGB.c"
}

gint
he_color_lab_to_argb_int (HeColorLABColor* lab)
{
	gdouble* white_point = NULL;
	gdouble* _tmp0_;
	gint white_point_length1;
	gint _white_point_size_;
	gdouble fy = 0.0;
	HeColorLABColor _tmp1_;
	gdouble fx = 0.0;
	HeColorLABColor _tmp2_;
	gdouble fz = 0.0;
	HeColorLABColor _tmp3_;
	gdouble xn = 0.0;
	gdouble yn = 0.0;
	gdouble zn = 0.0;
	HeColorXYZColor xyz = {0};
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	HeColorXYZColor _tmp7_ = {0};
	HeColorXYZColor _tmp8_;
	gint result;
#line 17 "../lib/Utils/Color/ARGB.vala"
	g_return_val_if_fail (lab != NULL, 0);
#line 18 "../lib/Utils/Color/ARGB.vala"
	_tmp0_ = g_new0 (gdouble, 3);
#line 18 "../lib/Utils/Color/ARGB.vala"
	_tmp0_[0] = HE_COLOR_XN;
#line 18 "../lib/Utils/Color/ARGB.vala"
	_tmp0_[1] = HE_COLOR_YN;
#line 18 "../lib/Utils/Color/ARGB.vala"
	_tmp0_[2] = HE_COLOR_ZN;
#line 18 "../lib/Utils/Color/ARGB.vala"
	white_point = _tmp0_;
#line 18 "../lib/Utils/Color/ARGB.vala"
	white_point_length1 = 3;
#line 18 "../lib/Utils/Color/ARGB.vala"
	_white_point_size_ = white_point_length1;
#line 19 "../lib/Utils/Color/ARGB.vala"
	_tmp1_ = *lab;
#line 19 "../lib/Utils/Color/ARGB.vala"
	fy = (_tmp1_.l + 16.0) / 116.0;
#line 20 "../lib/Utils/Color/ARGB.vala"
	_tmp2_ = *lab;
#line 20 "../lib/Utils/Color/ARGB.vala"
	fx = (_tmp2_.a / 500.0) + fy;
#line 21 "../lib/Utils/Color/ARGB.vala"
	_tmp3_ = *lab;
#line 21 "../lib/Utils/Color/ARGB.vala"
	fz = fy - (_tmp3_.b / 200.0);
#line 22 "../lib/Utils/Color/ARGB.vala"
	xn = he_math_utils_lab_inverse_fovea (fx);
#line 23 "../lib/Utils/Color/ARGB.vala"
	yn = he_math_utils_lab_inverse_fovea (fy);
#line 24 "../lib/Utils/Color/ARGB.vala"
	zn = he_math_utils_lab_inverse_fovea (fz);
#line 25 "../lib/Utils/Color/ARGB.vala"
	_tmp4_ = white_point[0];
#line 25 "../lib/Utils/Color/ARGB.vala"
	_tmp5_ = white_point[1];
#line 25 "../lib/Utils/Color/ARGB.vala"
	_tmp6_ = white_point[2];
#line 25 "../lib/Utils/Color/ARGB.vala"
	_tmp7_.x = xn * _tmp4_;
#line 25 "../lib/Utils/Color/ARGB.vala"
	_tmp7_.y = yn * _tmp5_;
#line 25 "../lib/Utils/Color/ARGB.vala"
	_tmp7_.z = zn * _tmp6_;
#line 25 "../lib/Utils/Color/ARGB.vala"
	xyz = _tmp7_;
#line 26 "../lib/Utils/Color/ARGB.vala"
	_tmp8_ = xyz;
#line 26 "../lib/Utils/Color/ARGB.vala"
	result = he_color_xyz_to_argb (&_tmp8_);
#line 26 "../lib/Utils/Color/ARGB.vala"
	white_point = (g_free (white_point), NULL);
#line 26 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 135 "ARGB.c"
}

gint
he_color_argb_from_rgb_int (gint red,
                            gint green,
                            gint blue)
{
	gint result;
#line 30 "../lib/Utils/Color/ARGB.vala"
	result = (((255 << 24) | ((red & 255) << 16)) | ((green & 255) << 8)) | (blue & 255);
#line 30 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 148 "ARGB.c"
}

gint
he_color_xyz_to_argb (HeColorXYZColor* xyz)
{
	gdouble* matrix = NULL;
	HeColorXYZColor _tmp0_;
	HeColorXYZColor _tmp1_;
	HeColorXYZColor _tmp2_;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gdouble* _tmp6_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gint matrix_length1;
	gint _matrix_size_;
	gint r = 0;
	gdouble _tmp8_;
	gint g = 0;
	gdouble _tmp9_;
	gint b = 0;
	gdouble _tmp10_;
	gint result;
#line 33 "../lib/Utils/Color/ARGB.vala"
	g_return_val_if_fail (xyz != NULL, 0);
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp0_ = *xyz;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp1_ = *xyz;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp2_ = *xyz;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp3_ = g_new0 (gdouble, 3);
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp3_[0] = _tmp0_.x;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp3_[1] = _tmp1_.y;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp3_[2] = _tmp2_.z;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp4_ = _tmp3_;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp4__length1 = 3;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp6_ = he_math_utils_elem_mul (_tmp4_, (gint) 3, HE_COLOR_XYZ_TO_SRGB, (gint) G_N_ELEMENTS (HE_COLOR_XYZ_TO_SRGB), (gint) G_N_ELEMENTS (HE_COLOR_XYZ_TO_SRGB[0]), &_tmp5_);
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp7_ = _tmp6_;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp7__length1 = _tmp5_;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_tmp4_ = (g_free (_tmp4_), NULL);
#line 34 "../lib/Utils/Color/ARGB.vala"
	matrix = _tmp7_;
#line 34 "../lib/Utils/Color/ARGB.vala"
	matrix_length1 = _tmp7__length1;
#line 34 "../lib/Utils/Color/ARGB.vala"
	_matrix_size_ = matrix_length1;
#line 35 "../lib/Utils/Color/ARGB.vala"
	_tmp8_ = matrix[0];
#line 35 "../lib/Utils/Color/ARGB.vala"
	r = he_math_utils_delinearized (_tmp8_);
#line 36 "../lib/Utils/Color/ARGB.vala"
	_tmp9_ = matrix[1];
#line 36 "../lib/Utils/Color/ARGB.vala"
	g = he_math_utils_delinearized (_tmp9_);
#line 37 "../lib/Utils/Color/ARGB.vala"
	_tmp10_ = matrix[2];
#line 37 "../lib/Utils/Color/ARGB.vala"
	b = he_math_utils_delinearized (_tmp10_);
#line 38 "../lib/Utils/Color/ARGB.vala"
	result = he_color_argb_from_rgb_int (r, g, b);
#line 38 "../lib/Utils/Color/ARGB.vala"
	matrix = (g_free (matrix), NULL);
#line 38 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 226 "ARGB.c"
}

gdouble*
he_color_argb_to_rgb (gint argb,
                      gint* result_length1)
{
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	gdouble* _tmp0_;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gdouble* result;
#line 42 "../lib/Utils/Color/ARGB.vala"
	r = he_math_utils_linearized (he_color_red_from_rgba_int (argb));
#line 43 "../lib/Utils/Color/ARGB.vala"
	g = he_math_utils_linearized (he_color_green_from_rgba_int (argb));
#line 44 "../lib/Utils/Color/ARGB.vala"
	b = he_math_utils_linearized (he_color_blue_from_rgba_int (argb));
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp0_ = g_new0 (gdouble, 3);
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp0_[0] = r;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp0_[1] = g;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp0_[2] = b;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp1_ = _tmp0_;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp1__length1 = 3;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp3_ = he_math_utils_elem_mul (_tmp1_, (gint) 3, HE_COLOR_SRGB_TO_XYZ, (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ), (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ[0]), &_tmp2_);
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp4_ = _tmp3_;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp4__length1 = _tmp2_;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp5_ = _tmp4_;
#line 45 "../lib/Utils/Color/ARGB.vala"
	_tmp5__length1 = _tmp4__length1;
#line 45 "../lib/Utils/Color/ARGB.vala"
	if (result_length1) {
#line 45 "../lib/Utils/Color/ARGB.vala"
		*result_length1 = _tmp5__length1;
#line 280 "ARGB.c"
	}
#line 45 "../lib/Utils/Color/ARGB.vala"
	result = _tmp5_;
#line 45 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 286 "ARGB.c"
}

gint
he_color_alpha_from_rgba_int (gint argb)
{
	gint result;
#line 49 "../lib/Utils/Color/ARGB.vala"
	result = (argb >> 24) & 255;
#line 49 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 297 "ARGB.c"
}

gint
he_color_red_from_rgba_int (gint argb)
{
	gint result;
#line 53 "../lib/Utils/Color/ARGB.vala"
	result = (argb >> 16) & 255;
#line 53 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 308 "ARGB.c"
}

gint
he_color_green_from_rgba_int (gint argb)
{
	gint result;
#line 57 "../lib/Utils/Color/ARGB.vala"
	result = (argb >> 8) & 255;
#line 57 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 319 "ARGB.c"
}

gint
he_color_blue_from_rgba_int (gint argb)
{
	gint result;
#line 61 "../lib/Utils/Color/ARGB.vala"
	result = argb & 255;
#line 61 "../lib/Utils/Color/ARGB.vala"
	return result;
#line 330 "ARGB.c"
}

