/* LAB.c generated by valac 0.56.15, the Vala compiler
 * generated from LAB.vala, do not modify */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "libhelium-1.h"
#include <string.h>

#define HE_COLOR_KN 16.0
#define HE_COLOR_XN 0.95047
#define HE_COLOR_YN 1.00000
#define HE_COLOR_ZN 1.08883
#define HE_COLOR_T0 0.137931034
#define HE_COLOR_T1 0.206896552
#define HE_COLOR_T2 0.128418549
#define HE_COLOR_T3 0.008856452
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const gdouble HE_COLOR_SRGB_TO_XYZ[3][3];

gdouble
he_color_lab_color_distance (HeColorLABColor *self,
                             HeColorLABColor* lab)
{
	gdouble d_l = 0.0;
	HeColorLABColor _tmp0_;
	gdouble d_a = 0.0;
	HeColorLABColor _tmp1_;
	gdouble d_b = 0.0;
	HeColorLABColor _tmp2_;
	gdouble result;
#line 21 "../lib/Utils/Color/LAB.vala"
	g_return_val_if_fail (lab != NULL, 0.0);
#line 22 "../lib/Utils/Color/LAB.vala"
	_tmp0_ = *lab;
#line 22 "../lib/Utils/Color/LAB.vala"
	d_l = (*self).l - _tmp0_.l;
#line 23 "../lib/Utils/Color/LAB.vala"
	_tmp1_ = *lab;
#line 23 "../lib/Utils/Color/LAB.vala"
	d_a = (*self).a - _tmp1_.a;
#line 24 "../lib/Utils/Color/LAB.vala"
	_tmp2_ = *lab;
#line 24 "../lib/Utils/Color/LAB.vala"
	d_b = (*self).b - _tmp2_.b;
#line 25 "../lib/Utils/Color/LAB.vala"
	result = ((d_l * d_l) + (d_a * d_a)) + (d_b * d_b);
#line 25 "../lib/Utils/Color/LAB.vala"
	return result;
#line 62 "LAB.c"
}

HeColorLABColor*
he_color_lab_color_dup (const HeColorLABColor* self)
{
	HeColorLABColor* dup;
#line 16 "../lib/Utils/Color/LAB.vala"
	dup = g_new0 (HeColorLABColor, 1);
#line 16 "../lib/Utils/Color/LAB.vala"
	memcpy (dup, self, sizeof (HeColorLABColor));
#line 16 "../lib/Utils/Color/LAB.vala"
	return dup;
#line 75 "LAB.c"
}

void
he_color_lab_color_free (HeColorLABColor* self)
{
#line 16 "../lib/Utils/Color/LAB.vala"
	g_free (self);
#line 83 "LAB.c"
}

static GType
he_color_lab_color_get_type_once (void)
{
	GType he_color_lab_color_type_id;
	he_color_lab_color_type_id = g_boxed_type_register_static ("HeColorLABColor", (GBoxedCopyFunc) he_color_lab_color_dup, (GBoxedFreeFunc) he_color_lab_color_free);
	return he_color_lab_color_type_id;
}

GType
he_color_lab_color_get_type (void)
{
	static volatile gsize he_color_lab_color_type_id__once = 0;
	if (g_once_init_enter (&he_color_lab_color_type_id__once)) {
		GType he_color_lab_color_type_id;
		he_color_lab_color_type_id = he_color_lab_color_get_type_once ();
		g_once_init_leave (&he_color_lab_color_type_id__once, he_color_lab_color_type_id);
	}
	return he_color_lab_color_type_id__once;
}

gdouble
he_color_xyz_value_to_lab (gdouble v)
{
	gdouble result;
#line 30 "../lib/Utils/Color/LAB.vala"
	if (v > HE_COLOR_T3) {
#line 30 "../lib/Utils/Color/LAB.vala"
		result = pow (v, 1. / 3.);
#line 30 "../lib/Utils/Color/LAB.vala"
		return result;
#line 116 "LAB.c"
	}
#line 31 "../lib/Utils/Color/LAB.vala"
	result = (v / HE_COLOR_T2) + HE_COLOR_T0;
#line 31 "../lib/Utils/Color/LAB.vala"
	return result;
#line 122 "LAB.c"
}

void
he_color_xyz_to_lab (HeColorXYZColor* color,
                     HeColorLABColor* result)
{
	gdouble l = 0.0;
	HeColorXYZColor _tmp0_;
	gdouble a = 0.0;
	HeColorXYZColor _tmp1_;
	gdouble b = 0.0;
	HeColorXYZColor _tmp2_;
	HeColorLABColor _result_ = {0};
	HeColorLABColor _tmp3_ = {0};
#line 34 "../lib/Utils/Color/LAB.vala"
	g_return_if_fail (color != NULL);
#line 35 "../lib/Utils/Color/LAB.vala"
	_tmp0_ = *color;
#line 35 "../lib/Utils/Color/LAB.vala"
	l = he_color_xyz_value_to_lab (_tmp0_.x);
#line 36 "../lib/Utils/Color/LAB.vala"
	_tmp1_ = *color;
#line 36 "../lib/Utils/Color/LAB.vala"
	a = he_color_xyz_value_to_lab (_tmp1_.y);
#line 37 "../lib/Utils/Color/LAB.vala"
	_tmp2_ = *color;
#line 37 "../lib/Utils/Color/LAB.vala"
	b = he_color_xyz_value_to_lab (_tmp2_.z);
#line 39 "../lib/Utils/Color/LAB.vala"
	_tmp3_.l = l;
#line 39 "../lib/Utils/Color/LAB.vala"
	_tmp3_.a = a;
#line 39 "../lib/Utils/Color/LAB.vala"
	_tmp3_.b = b;
#line 39 "../lib/Utils/Color/LAB.vala"
	_result_ = _tmp3_;
#line 45 "../lib/Utils/Color/LAB.vala"
	*result = _result_;
#line 45 "../lib/Utils/Color/LAB.vala"
	return;
#line 163 "LAB.c"
}

void
he_color_lch_to_lab (HeColorLCHColor* color,
                     HeColorLABColor* result)
{
	gdouble hr = 0.0;
	HeColorLCHColor _tmp0_;
	HeColorLABColor _result_ = {0};
	HeColorLCHColor _tmp1_;
	HeColorLCHColor _tmp2_;
	HeColorLCHColor _tmp3_;
	HeColorLABColor _tmp4_ = {0};
#line 48 "../lib/Utils/Color/LAB.vala"
	g_return_if_fail (color != NULL);
#line 49 "../lib/Utils/Color/LAB.vala"
	_tmp0_ = *color;
#line 49 "../lib/Utils/Color/LAB.vala"
	hr = (_tmp0_.h * G_PI) / 180.0;
#line 50 "../lib/Utils/Color/LAB.vala"
	_tmp1_ = *color;
#line 50 "../lib/Utils/Color/LAB.vala"
	_tmp2_ = *color;
#line 50 "../lib/Utils/Color/LAB.vala"
	_tmp3_ = *color;
#line 50 "../lib/Utils/Color/LAB.vala"
	_tmp4_.l = _tmp1_.l;
#line 50 "../lib/Utils/Color/LAB.vala"
	_tmp4_.a = _tmp2_.c * cos (hr);
#line 50 "../lib/Utils/Color/LAB.vala"
	_tmp4_.b = _tmp3_.c * sin (hr);
#line 50 "../lib/Utils/Color/LAB.vala"
	_result_ = _tmp4_;
#line 56 "../lib/Utils/Color/LAB.vala"
	*result = _result_;
#line 56 "../lib/Utils/Color/LAB.vala"
	return;
#line 201 "LAB.c"
}

void
he_color_rgb_to_lab (HeColorRGBColor* color,
                     HeColorLABColor* result)
{
	HeColorXYZColor xyz_color = {0};
	HeColorRGBColor _tmp0_;
	HeColorXYZColor _tmp1_ = {0};
	gdouble l = 0.0;
	HeColorXYZColor _tmp2_;
	gdouble _tmp3_ = 0.0;
	HeColorLABColor _result_ = {0};
	HeColorXYZColor _tmp4_;
	HeColorXYZColor _tmp5_;
	HeColorXYZColor _tmp6_;
	HeColorXYZColor _tmp7_;
	HeColorLABColor _tmp8_ = {0};
#line 59 "../lib/Utils/Color/LAB.vala"
	g_return_if_fail (color != NULL);
#line 60 "../lib/Utils/Color/LAB.vala"
	_tmp0_ = *color;
#line 60 "../lib/Utils/Color/LAB.vala"
	he_color_rgb_to_xyz (&_tmp0_, &_tmp1_);
#line 60 "../lib/Utils/Color/LAB.vala"
	xyz_color = _tmp1_;
#line 61 "../lib/Utils/Color/LAB.vala"
	_tmp2_ = xyz_color;
#line 61 "../lib/Utils/Color/LAB.vala"
	l = (116. * _tmp2_.y) - 16.;
#line 64 "../lib/Utils/Color/LAB.vala"
	if (l < ((gdouble) 0)) {
#line 64 "../lib/Utils/Color/LAB.vala"
		_tmp3_ = (gdouble) 0;
#line 236 "LAB.c"
	} else {
#line 64 "../lib/Utils/Color/LAB.vala"
		_tmp3_ = l;
#line 240 "LAB.c"
	}
#line 63 "../lib/Utils/Color/LAB.vala"
	_tmp4_ = xyz_color;
#line 63 "../lib/Utils/Color/LAB.vala"
	_tmp5_ = xyz_color;
#line 63 "../lib/Utils/Color/LAB.vala"
	_tmp6_ = xyz_color;
#line 63 "../lib/Utils/Color/LAB.vala"
	_tmp7_ = xyz_color;
#line 63 "../lib/Utils/Color/LAB.vala"
	_tmp8_.l = _tmp3_;
#line 63 "../lib/Utils/Color/LAB.vala"
	_tmp8_.a = 500. * (_tmp4_.x - _tmp5_.y);
#line 63 "../lib/Utils/Color/LAB.vala"
	_tmp8_.b = 200. * (_tmp6_.y - _tmp7_.z);
#line 63 "../lib/Utils/Color/LAB.vala"
	_result_ = _tmp8_;
#line 69 "../lib/Utils/Color/LAB.vala"
	*result = _result_;
#line 69 "../lib/Utils/Color/LAB.vala"
	return;
#line 262 "LAB.c"
}

void
he_color_lab_from_argb (gint argb,
                        HeColorLABColor* result)
{
	gdouble linear_r = 0.0;
	gdouble linear_g = 0.0;
	gdouble linear_b = 0.0;
	gdouble* xyz = NULL;
	gdouble* _tmp0_;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gint xyz_length1;
	gint _xyz_size_;
	gdouble* d65 = NULL;
	gdouble* _tmp5_;
	gint d65_length1;
	gint _d65_size_;
	gdouble xn = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble yn = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble zn = 0.0;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble fz = 0.0;
	gdouble l = 0.0;
	gdouble a = 0.0;
	gdouble b = 0.0;
	HeColorLABColor _tmp12_ = {0};
#line 73 "../lib/Utils/Color/LAB.vala"
	linear_r = he_math_utils_linearized (he_color_red_from_rgba_int (argb));
#line 74 "../lib/Utils/Color/LAB.vala"
	linear_g = he_math_utils_linearized (he_color_green_from_rgba_int (argb));
#line 75 "../lib/Utils/Color/LAB.vala"
	linear_b = he_math_utils_linearized (he_color_blue_from_rgba_int (argb));
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp0_ = g_new0 (gdouble, 3);
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp0_[0] = linear_r;
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp0_[1] = linear_g;
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp0_[2] = linear_b;
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp1_ = _tmp0_;
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp1__length1 = 3;
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp3_ = he_math_utils_elem_mul (_tmp1_, (gint) 3, HE_COLOR_SRGB_TO_XYZ, (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ), (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ[0]), &_tmp2_);
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp4_ = _tmp3_;
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp4__length1 = _tmp2_;
#line 76 "../lib/Utils/Color/LAB.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 76 "../lib/Utils/Color/LAB.vala"
	xyz = _tmp4_;
#line 76 "../lib/Utils/Color/LAB.vala"
	xyz_length1 = _tmp4__length1;
#line 76 "../lib/Utils/Color/LAB.vala"
	_xyz_size_ = xyz_length1;
#line 77 "../lib/Utils/Color/LAB.vala"
	_tmp5_ = g_new0 (gdouble, 3);
#line 77 "../lib/Utils/Color/LAB.vala"
	_tmp5_[0] = HE_COLOR_XN;
#line 77 "../lib/Utils/Color/LAB.vala"
	_tmp5_[1] = HE_COLOR_YN;
#line 77 "../lib/Utils/Color/LAB.vala"
	_tmp5_[2] = HE_COLOR_ZN;
#line 77 "../lib/Utils/Color/LAB.vala"
	d65 = _tmp5_;
#line 77 "../lib/Utils/Color/LAB.vala"
	d65_length1 = 3;
#line 77 "../lib/Utils/Color/LAB.vala"
	_d65_size_ = d65_length1;
#line 78 "../lib/Utils/Color/LAB.vala"
	_tmp6_ = xyz[0];
#line 78 "../lib/Utils/Color/LAB.vala"
	_tmp7_ = d65[0];
#line 78 "../lib/Utils/Color/LAB.vala"
	xn = _tmp6_ / _tmp7_;
#line 79 "../lib/Utils/Color/LAB.vala"
	_tmp8_ = xyz[1];
#line 79 "../lib/Utils/Color/LAB.vala"
	_tmp9_ = d65[1];
#line 79 "../lib/Utils/Color/LAB.vala"
	yn = _tmp8_ / _tmp9_;
#line 80 "../lib/Utils/Color/LAB.vala"
	_tmp10_ = xyz[2];
#line 80 "../lib/Utils/Color/LAB.vala"
	_tmp11_ = d65[2];
#line 80 "../lib/Utils/Color/LAB.vala"
	zn = _tmp10_ / _tmp11_;
#line 81 "../lib/Utils/Color/LAB.vala"
	fx = he_math_utils_lab_fovea (xn);
#line 82 "../lib/Utils/Color/LAB.vala"
	fy = he_math_utils_lab_fovea (yn);
#line 83 "../lib/Utils/Color/LAB.vala"
	fz = he_math_utils_lab_fovea (zn);
#line 84 "../lib/Utils/Color/LAB.vala"
	l = (116.0 * fy) - 16;
#line 85 "../lib/Utils/Color/LAB.vala"
	a = 500.0 * (fx - fy);
#line 86 "../lib/Utils/Color/LAB.vala"
	b = 200.0 * (fy - fz);
#line 87 "../lib/Utils/Color/LAB.vala"
	_tmp12_.l = l;
#line 87 "../lib/Utils/Color/LAB.vala"
	_tmp12_.a = a;
#line 87 "../lib/Utils/Color/LAB.vala"
	_tmp12_.b = b;
#line 87 "../lib/Utils/Color/LAB.vala"
	*result = _tmp12_;
#line 87 "../lib/Utils/Color/LAB.vala"
	d65 = (g_free (d65), NULL);
#line 87 "../lib/Utils/Color/LAB.vala"
	xyz = (g_free (xyz), NULL);
#line 87 "../lib/Utils/Color/LAB.vala"
	return;
#line 392 "LAB.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

