/* Score.c generated by valac 0.56.15, the Vala compiler
 * generated from Score.vala, do not modify */

/* Adapted from the Java implementation of material-color-utilities licensed under the Apache License, Version 2.0*/
/* Copyright (c) 2021 Google LLC*/

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define HE_SCORE_CUTOFF_CHROMA 15.0
#define HE_SCORE_CUTOFF_EXCITED_PROPORTION 0.01
#define HE_SCORE_CUTOFF_TONE 10.0
#define HE_SCORE_TARGET_CHROMA 48.0
#define HE_SCORE_WEIGHT_CHROMA_ABOVE 0.3
#define HE_SCORE_WEIGHT_CHROMA_BELOW 0.1
#define HE_SCORE_WEIGHT_PROPORTION 0.7
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _HeScoreParamSpecAnnotatedColor HeScoreParamSpecAnnotatedColor;
typedef struct _HeParamSpecScore HeParamSpecScore;

struct _Block2Data {
	int _ref_count_;
	GPtrArray* self;
	GCompareFunc compare_func;
};

struct _HeScoreParamSpecAnnotatedColor {
	GParamSpec parent_instance;
};

struct _HeParamSpecScore {
	GParamSpec parent_instance;
};

static gpointer he_score_parent_class = NULL;
static gpointer he_score_annotated_color_parent_class = NULL;
GCompareFunc he_score_annotated_color_cmp = NULL;

static gint* _int_dup (gint* self);
static void _vala_array_add2 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add3 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _he_score_annotated_color_unref0_ (gpointer var);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gint ___lambda0__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static gboolean he_score_good_color_finder (HeScore* self,
                                     HeScoreAnnotatedColor* color);
static gboolean he_score_colors_are_too_close (HeScore* self,
                                        HeScoreAnnotatedColor* color_one,
                                        HeScoreAnnotatedColor* color_two);
static void _g_free0_ (gpointer var);
static void _vala_gint_free_function_content_of (gpointer data);
static gint _he_score_annotated_color_cmp_lambda27_ (HeScoreAnnotatedColor* a,
                                              HeScoreAnnotatedColor* b);
static gint __he_score_annotated_color_cmp_lambda27__gcompare_func (gconstpointer a,
                                                             gconstpointer b);
static void he_score_annotated_color_finalize (HeScoreAnnotatedColor * obj);
static GType he_score_annotated_color_get_type_once (void);
static void he_score_finalize (HeScore * obj);
static GType he_score_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 36 "../lib/Utils/Ensor/Score.vala"
	dup = g_new0 (gint, 1);
#line 36 "../lib/Utils/Ensor/Score.vala"
	memcpy (dup, self, sizeof (gint));
#line 36 "../lib/Utils/Ensor/Score.vala"
	return dup;
#line 100 "Score.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 36 "../lib/Utils/Ensor/Score.vala"
	return self ? _int_dup (self) : NULL;
#line 108 "Score.c"
}

static void
_vala_array_add2 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 38 "../lib/Utils/Ensor/Score.vala"
	if ((*length) == (*size)) {
#line 38 "../lib/Utils/Ensor/Score.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 38 "../lib/Utils/Ensor/Score.vala"
		*array = g_renew (gint, *array, *size);
#line 123 "Score.c"
	}
#line 38 "../lib/Utils/Ensor/Score.vala"
	(*array)[(*length)++] = value;
#line 127 "Score.c"
}

static void
_vala_array_add3 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 39 "../lib/Utils/Ensor/Score.vala"
	if ((*length) == (*size)) {
#line 39 "../lib/Utils/Ensor/Score.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 39 "../lib/Utils/Ensor/Score.vala"
		*array = g_renew (gint, *array, *size);
#line 142 "Score.c"
	}
#line 39 "../lib/Utils/Ensor/Score.vala"
	(*array)[(*length)++] = value;
#line 146 "Score.c"
}

static void
_he_score_annotated_color_unref0_ (gpointer var)
{
#line 47 "../lib/Utils/Ensor/Score.vala"
	(var == NULL) ? NULL : (var = (he_score_annotated_color_unref (var), NULL));
#line 154 "Score.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 5879 "glib-2.0.vapi"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 5879 "glib-2.0.vapi"
	return _data2_;
#line 164 "Score.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 5879 "glib-2.0.vapi"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 174 "Score.c"
		GPtrArray* self;
#line 5879 "glib-2.0.vapi"
		self = _data2_->self;
#line 5879 "glib-2.0.vapi"
		_g_ptr_array_unref0 (self);
#line 5879 "glib-2.0.vapi"
		g_slice_free (Block2Data, _data2_);
#line 182 "Score.c"
	}
}

static gint
__lambda0_ (Block2Data* _data2_,
            gconstpointer** a,
            gconstpointer** b)
{
	GPtrArray* self;
	gint result;
#line 5880 "glib-2.0.vapi"
	self = _data2_->self;
#line 5881 "glib-2.0.vapi"
	result = _data2_->compare_func ((gconstpointer**) (*a), (gconstpointer**) (*b));
#line 5881 "glib-2.0.vapi"
	return result;
#line 199 "Score.c"
}

static gint
___lambda0__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda0_ (self, a, b);
#line 5880 "glib-2.0.vapi"
	return result;
#line 211 "Score.c"
}

static void
vala_g_ptr_array_sort (GPtrArray* self,
                       GCompareFunc compare_func)
{
	Block2Data* _data2_;
#line 5879 "glib-2.0.vapi"
	g_return_if_fail (self != NULL);
#line 5879 "glib-2.0.vapi"
	_data2_ = g_slice_new0 (Block2Data);
#line 5879 "glib-2.0.vapi"
	_data2_->_ref_count_ = 1;
#line 5879 "glib-2.0.vapi"
	_data2_->self = g_ptr_array_ref (self);
#line 5879 "glib-2.0.vapi"
	_data2_->compare_func = compare_func;
#line 5880 "glib-2.0.vapi"
	g_ptr_array_sort_with_data (self, ___lambda0__gcompare_data_func, _data2_);
#line 5879 "glib-2.0.vapi"
	block2_data_unref (_data2_);
#line 5879 "glib-2.0.vapi"
	_data2_ = NULL;
#line 235 "Score.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5907 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5908 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5908 "glib-2.0.vapi"
	return result;
#line 248 "Score.c"
}

static gpointer
_he_score_annotated_color_ref0 (gpointer self)
{
#line 111 "../lib/Utils/Ensor/Score.vala"
	return self ? he_score_annotated_color_ref (self) : NULL;
#line 256 "Score.c"
}

static void
_g_free0_ (gpointer var)
{
#line 128 "../lib/Utils/Ensor/Score.vala"
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
#line 264 "Score.c"
}

static void
_vala_gint_free_function_content_of (gpointer data)
{
	gint* self;
#line 128 "../lib/Utils/Ensor/Score.vala"
	self = *((gint**) data);
#line 128 "../lib/Utils/Ensor/Score.vala"
	_g_free0_ (self);
#line 275 "Score.c"
}

GArray*
he_score_score (HeScore* self,
                GHashTable* colors_to_population)
{
	gdouble population_sum = 0.0;
	guint input_size = 0U;
	gint* argbs = NULL;
	gint* _tmp0_;
	gint argbs_length1;
	gint _argbs_size_;
	gint* populations = NULL;
	gint* _tmp1_;
	gint populations_length1;
	gint _populations_size_;
	GList* _tmp2_;
	gdouble* hue_proportions = NULL;
	gdouble* _tmp12_;
	gint hue_proportions_length1;
	gint _hue_proportions_size_;
	GPtrArray* colors = NULL;
	GPtrArray* _tmp13_;
	GPtrArray* _tmp58_;
	GCompareFunc _tmp59_;
	GPtrArray* selected_colors = NULL;
	GPtrArray* _tmp68_;
	GPtrArray* _tmp95_;
	gint _tmp96_;
	gint _tmp97_;
	GArray* return_value = NULL;
	GArray* _tmp100_;
	GArray* _tmp110_;
	GArray* result;
#line 28 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (colors_to_population != NULL, NULL);
#line 29 "../lib/Utils/Ensor/Score.vala"
	population_sum = 0.0;
#line 30 "../lib/Utils/Ensor/Score.vala"
	input_size = g_hash_table_size (colors_to_population);
#line 32 "../lib/Utils/Ensor/Score.vala"
	_tmp0_ = g_new0 (gint, 0);
#line 32 "../lib/Utils/Ensor/Score.vala"
	argbs = _tmp0_;
#line 32 "../lib/Utils/Ensor/Score.vala"
	argbs_length1 = 0;
#line 32 "../lib/Utils/Ensor/Score.vala"
	_argbs_size_ = argbs_length1;
#line 33 "../lib/Utils/Ensor/Score.vala"
	_tmp1_ = g_new0 (gint, 0);
#line 33 "../lib/Utils/Ensor/Score.vala"
	populations = _tmp1_;
#line 33 "../lib/Utils/Ensor/Score.vala"
	populations_length1 = 0;
#line 33 "../lib/Utils/Ensor/Score.vala"
	_populations_size_ = populations_length1;
#line 35 "../lib/Utils/Ensor/Score.vala"
	_tmp2_ = g_hash_table_get_keys (colors_to_population);
#line 336 "Score.c"
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
#line 35 "../lib/Utils/Ensor/Score.vala"
		key_collection = _tmp2_;
#line 35 "../lib/Utils/Ensor/Score.vala"
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 344 "Score.c"
			gint* key = NULL;
#line 35 "../lib/Utils/Ensor/Score.vala"
			key = (gint*) key_it->data;
#line 348 "Score.c"
			{
				gint* val = NULL;
				gint* _tmp3_;
				gconstpointer _tmp4_;
				gint* _tmp5_;
				gint* _tmp6_;
				gint* _tmp7_;
#line 36 "../lib/Utils/Ensor/Score.vala"
				_tmp3_ = key;
#line 36 "../lib/Utils/Ensor/Score.vala"
				_tmp4_ = g_hash_table_lookup (colors_to_population, _tmp3_);
#line 36 "../lib/Utils/Ensor/Score.vala"
				_tmp5_ = __int_dup0 ((gint*) _tmp4_);
#line 36 "../lib/Utils/Ensor/Score.vala"
				val = _tmp5_;
#line 38 "../lib/Utils/Ensor/Score.vala"
				_tmp6_ = key;
#line 38 "../lib/Utils/Ensor/Score.vala"
				_vala_array_add2 (&argbs, &argbs_length1, &_argbs_size_, *_tmp6_);
#line 39 "../lib/Utils/Ensor/Score.vala"
				_tmp7_ = val;
#line 39 "../lib/Utils/Ensor/Score.vala"
				_vala_array_add3 (&populations, &populations_length1, &_populations_size_, *_tmp7_);
#line 35 "../lib/Utils/Ensor/Score.vala"
				_g_free0 (val);
#line 374 "Score.c"
			}
		}
#line 35 "../lib/Utils/Ensor/Score.vala"
		(key_collection == NULL) ? NULL : (key_collection = (g_list_free (key_collection), NULL));
#line 379 "Score.c"
	}
	{
		gint i = 0;
#line 42 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 385 "Score.c"
		{
			gboolean _tmp8_ = FALSE;
#line 42 "../lib/Utils/Ensor/Score.vala"
			_tmp8_ = TRUE;
#line 42 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 392 "Score.c"
				gint* _tmp10_;
				gint _tmp10__length1;
				gint _tmp11_;
#line 42 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp8_) {
#line 398 "Score.c"
					gint _tmp9_;
#line 42 "../lib/Utils/Ensor/Score.vala"
					_tmp9_ = i;
#line 42 "../lib/Utils/Ensor/Score.vala"
					i = _tmp9_ + 1;
#line 404 "Score.c"
				}
#line 42 "../lib/Utils/Ensor/Score.vala"
				_tmp8_ = FALSE;
#line 42 "../lib/Utils/Ensor/Score.vala"
				if (!(((guint) i) < input_size)) {
#line 42 "../lib/Utils/Ensor/Score.vala"
					break;
#line 412 "Score.c"
				}
#line 43 "../lib/Utils/Ensor/Score.vala"
				_tmp10_ = populations;
#line 43 "../lib/Utils/Ensor/Score.vala"
				_tmp10__length1 = populations_length1;
#line 43 "../lib/Utils/Ensor/Score.vala"
				_tmp11_ = _tmp10_[i];
#line 43 "../lib/Utils/Ensor/Score.vala"
				population_sum += (gdouble) _tmp11_;
#line 422 "Score.c"
			}
		}
	}
#line 46 "../lib/Utils/Ensor/Score.vala"
	_tmp12_ = g_new0 (gdouble, 361);
#line 46 "../lib/Utils/Ensor/Score.vala"
	hue_proportions = _tmp12_;
#line 46 "../lib/Utils/Ensor/Score.vala"
	hue_proportions_length1 = 361;
#line 46 "../lib/Utils/Ensor/Score.vala"
	_hue_proportions_size_ = hue_proportions_length1;
#line 47 "../lib/Utils/Ensor/Score.vala"
	_tmp13_ = g_ptr_array_new_full ((guint) 0, _he_score_annotated_color_unref0_);
#line 47 "../lib/Utils/Ensor/Score.vala"
	colors = _tmp13_;
#line 438 "Score.c"
	{
		gint i = 0;
#line 49 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 443 "Score.c"
		{
			gboolean _tmp14_ = FALSE;
#line 49 "../lib/Utils/Ensor/Score.vala"
			_tmp14_ = TRUE;
#line 49 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 450 "Score.c"
				gdouble proportion = 0.0;
				gint* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				HeColorCAM16Color cam = {0};
				gint* _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				HeColorCAM16Color _tmp20_ = {0};
				gint hue = 0;
				HeColorCAM16Color _tmp21_;
				gdouble* _tmp22_;
				gint _tmp22__length1;
				GPtrArray* _tmp23_;
				gint* _tmp24_;
				gint _tmp24__length1;
				gint _tmp25_;
				HeColorCAM16Color _tmp26_;
				HeColorCAM16Color _tmp27_;
				HeScoreAnnotatedColor* _tmp28_ = NULL;
#line 49 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp14_) {
#line 473 "Score.c"
					gint _tmp15_;
#line 49 "../lib/Utils/Ensor/Score.vala"
					_tmp15_ = i;
#line 49 "../lib/Utils/Ensor/Score.vala"
					i = _tmp15_ + 1;
#line 479 "Score.c"
				}
#line 49 "../lib/Utils/Ensor/Score.vala"
				_tmp14_ = FALSE;
#line 49 "../lib/Utils/Ensor/Score.vala"
				if (!(((guint) i) < input_size)) {
#line 49 "../lib/Utils/Ensor/Score.vala"
					break;
#line 487 "Score.c"
				}
#line 50 "../lib/Utils/Ensor/Score.vala"
				_tmp16_ = populations;
#line 50 "../lib/Utils/Ensor/Score.vala"
				_tmp16__length1 = populations_length1;
#line 50 "../lib/Utils/Ensor/Score.vala"
				_tmp17_ = _tmp16_[i];
#line 50 "../lib/Utils/Ensor/Score.vala"
				proportion = _tmp17_ / population_sum;
#line 52 "../lib/Utils/Ensor/Score.vala"
				_tmp18_ = argbs;
#line 52 "../lib/Utils/Ensor/Score.vala"
				_tmp18__length1 = argbs_length1;
#line 52 "../lib/Utils/Ensor/Score.vala"
				_tmp19_ = _tmp18_[i];
#line 52 "../lib/Utils/Ensor/Score.vala"
				he_color_cam16_from_int (_tmp19_, &_tmp20_);
#line 52 "../lib/Utils/Ensor/Score.vala"
				cam = _tmp20_;
#line 54 "../lib/Utils/Ensor/Score.vala"
				_tmp21_ = cam;
#line 54 "../lib/Utils/Ensor/Score.vala"
				hue = (gint) he_math_utils_sanitize_degrees (round (_tmp21_.h));
#line 55 "../lib/Utils/Ensor/Score.vala"
				_tmp22_ = hue_proportions;
#line 55 "../lib/Utils/Ensor/Score.vala"
				_tmp22__length1 = hue_proportions_length1;
#line 55 "../lib/Utils/Ensor/Score.vala"
				_tmp22_[hue] += proportion;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp23_ = colors;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp24_ = argbs;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp24__length1 = argbs_length1;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp25_ = _tmp24_[i];
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp26_ = cam;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp27_ = cam;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp28_ = he_score_annotated_color_new ();
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp28_->argb = _tmp25_;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp28_->cam_hue = _tmp26_.h;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp28_->cam_chroma = _tmp27_.c;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp28_->excited_proportion = (gdouble) 0;
#line 59 "../lib/Utils/Ensor/Score.vala"
				_tmp28_->score = (gdouble) -1;
#line 59 "../lib/Utils/Ensor/Score.vala"
				g_ptr_array_add (_tmp23_, _tmp28_);
#line 543 "Score.c"
			}
		}
	}
	{
		gint i = 0;
#line 68 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 551 "Score.c"
		{
			gboolean _tmp29_ = FALSE;
#line 68 "../lib/Utils/Ensor/Score.vala"
			_tmp29_ = TRUE;
#line 68 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 558 "Score.c"
				gint hue = 0;
				GPtrArray* _tmp31_;
				gconstpointer _tmp32_;
#line 68 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp29_) {
#line 564 "Score.c"
					gint _tmp30_;
#line 68 "../lib/Utils/Ensor/Score.vala"
					_tmp30_ = i;
#line 68 "../lib/Utils/Ensor/Score.vala"
					i = _tmp30_ + 1;
#line 570 "Score.c"
				}
#line 68 "../lib/Utils/Ensor/Score.vala"
				_tmp29_ = FALSE;
#line 68 "../lib/Utils/Ensor/Score.vala"
				if (!(((guint) i) < input_size)) {
#line 68 "../lib/Utils/Ensor/Score.vala"
					break;
#line 578 "Score.c"
				}
#line 69 "../lib/Utils/Ensor/Score.vala"
				_tmp31_ = colors;
#line 69 "../lib/Utils/Ensor/Score.vala"
				_tmp32_ = g_ptr_array_index (_tmp31_, (guint) i);
#line 69 "../lib/Utils/Ensor/Score.vala"
				hue = (gint) round (((HeScoreAnnotatedColor*) _tmp32_)->cam_hue);
#line 586 "Score.c"
				{
					gint j = 0;
#line 70 "../lib/Utils/Ensor/Score.vala"
					j = hue - 15;
#line 591 "Score.c"
					{
						gboolean _tmp33_ = FALSE;
#line 70 "../lib/Utils/Ensor/Score.vala"
						_tmp33_ = TRUE;
#line 70 "../lib/Utils/Ensor/Score.vala"
						while (TRUE) {
#line 598 "Score.c"
							gint sanitized_hue = 0;
							GPtrArray* _tmp35_;
							gconstpointer _tmp36_;
							GPtrArray* _tmp37_;
							gconstpointer _tmp38_;
							gdouble* _tmp39_;
							gint _tmp39__length1;
							gdouble _tmp40_;
#line 70 "../lib/Utils/Ensor/Score.vala"
							if (!_tmp33_) {
#line 609 "Score.c"
								gint _tmp34_;
#line 70 "../lib/Utils/Ensor/Score.vala"
								_tmp34_ = j;
#line 70 "../lib/Utils/Ensor/Score.vala"
								j = _tmp34_ + 1;
#line 615 "Score.c"
							}
#line 70 "../lib/Utils/Ensor/Score.vala"
							_tmp33_ = FALSE;
#line 70 "../lib/Utils/Ensor/Score.vala"
							if (!(j < (hue + 15))) {
#line 70 "../lib/Utils/Ensor/Score.vala"
								break;
#line 623 "Score.c"
							}
#line 71 "../lib/Utils/Ensor/Score.vala"
							sanitized_hue = (gint) he_math_utils_sanitize_degrees ((gdouble) j);
#line 72 "../lib/Utils/Ensor/Score.vala"
							_tmp35_ = colors;
#line 72 "../lib/Utils/Ensor/Score.vala"
							_tmp36_ = g_ptr_array_index (_tmp35_, (guint) i);
#line 72 "../lib/Utils/Ensor/Score.vala"
							_tmp37_ = colors;
#line 72 "../lib/Utils/Ensor/Score.vala"
							_tmp38_ = g_ptr_array_index (_tmp37_, (guint) i);
#line 72 "../lib/Utils/Ensor/Score.vala"
							_tmp39_ = hue_proportions;
#line 72 "../lib/Utils/Ensor/Score.vala"
							_tmp39__length1 = hue_proportions_length1;
#line 72 "../lib/Utils/Ensor/Score.vala"
							_tmp40_ = _tmp39_[sanitized_hue];
#line 72 "../lib/Utils/Ensor/Score.vala"
							((HeScoreAnnotatedColor*) _tmp38_)->excited_proportion = ((HeScoreAnnotatedColor*) _tmp38_)->excited_proportion + _tmp40_;
#line 643 "Score.c"
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
#line 76 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 654 "Score.c"
		{
			gboolean _tmp41_ = FALSE;
#line 76 "../lib/Utils/Ensor/Score.vala"
			_tmp41_ = TRUE;
#line 76 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 661 "Score.c"
				gdouble proportion_score = 0.0;
				GPtrArray* _tmp43_;
				gconstpointer _tmp44_;
				gdouble chroma = 0.0;
				GPtrArray* _tmp45_;
				gconstpointer _tmp46_;
				gdouble _tmp47_ = 0.0;
				gdouble chroma_weight = 0.0;
				gdouble chroma_score = 0.0;
				GPtrArray* _tmp48_;
				gconstpointer _tmp49_;
#line 76 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp41_) {
#line 675 "Score.c"
					gint _tmp42_;
#line 76 "../lib/Utils/Ensor/Score.vala"
					_tmp42_ = i;
#line 76 "../lib/Utils/Ensor/Score.vala"
					i = _tmp42_ + 1;
#line 681 "Score.c"
				}
#line 76 "../lib/Utils/Ensor/Score.vala"
				_tmp41_ = FALSE;
#line 76 "../lib/Utils/Ensor/Score.vala"
				if (!(((guint) i) < input_size)) {
#line 76 "../lib/Utils/Ensor/Score.vala"
					break;
#line 689 "Score.c"
				}
#line 77 "../lib/Utils/Ensor/Score.vala"
				_tmp43_ = colors;
#line 77 "../lib/Utils/Ensor/Score.vala"
				_tmp44_ = g_ptr_array_index (_tmp43_, (guint) i);
#line 77 "../lib/Utils/Ensor/Score.vala"
				proportion_score = (((HeScoreAnnotatedColor*) _tmp44_)->excited_proportion * 100.0) * HE_SCORE_WEIGHT_PROPORTION;
#line 78 "../lib/Utils/Ensor/Score.vala"
				_tmp45_ = colors;
#line 78 "../lib/Utils/Ensor/Score.vala"
				_tmp46_ = g_ptr_array_index (_tmp45_, (guint) i);
#line 78 "../lib/Utils/Ensor/Score.vala"
				chroma = ((HeScoreAnnotatedColor*) _tmp46_)->cam_chroma;
#line 79 "../lib/Utils/Ensor/Score.vala"
				if (chroma > HE_SCORE_TARGET_CHROMA) {
#line 79 "../lib/Utils/Ensor/Score.vala"
					_tmp47_ = HE_SCORE_WEIGHT_CHROMA_ABOVE;
#line 707 "Score.c"
				} else {
#line 79 "../lib/Utils/Ensor/Score.vala"
					_tmp47_ = HE_SCORE_WEIGHT_CHROMA_BELOW;
#line 711 "Score.c"
				}
#line 79 "../lib/Utils/Ensor/Score.vala"
				chroma_weight = _tmp47_;
#line 80 "../lib/Utils/Ensor/Score.vala"
				chroma_score = (chroma - HE_SCORE_TARGET_CHROMA) * chroma_weight;
#line 82 "../lib/Utils/Ensor/Score.vala"
				_tmp48_ = colors;
#line 82 "../lib/Utils/Ensor/Score.vala"
				_tmp49_ = g_ptr_array_index (_tmp48_, (guint) i);
#line 82 "../lib/Utils/Ensor/Score.vala"
				((HeScoreAnnotatedColor*) _tmp49_)->score = chroma_score + proportion_score;
#line 723 "Score.c"
			}
		}
	}
	{
		gint i = 0;
#line 85 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 731 "Score.c"
		{
			gboolean _tmp50_ = FALSE;
#line 85 "../lib/Utils/Ensor/Score.vala"
			_tmp50_ = TRUE;
#line 85 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 738 "Score.c"
				GPtrArray* _tmp52_;
				gconstpointer _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				GPtrArray* _tmp56_;
				gconstpointer _tmp57_;
#line 85 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp50_) {
#line 747 "Score.c"
					gint _tmp51_;
#line 85 "../lib/Utils/Ensor/Score.vala"
					_tmp51_ = i;
#line 85 "../lib/Utils/Ensor/Score.vala"
					i = _tmp51_ + 1;
#line 753 "Score.c"
				}
#line 85 "../lib/Utils/Ensor/Score.vala"
				_tmp50_ = FALSE;
#line 85 "../lib/Utils/Ensor/Score.vala"
				if (!(((guint) i) < input_size)) {
#line 85 "../lib/Utils/Ensor/Score.vala"
					break;
#line 761 "Score.c"
				}
#line 86 "../lib/Utils/Ensor/Score.vala"
				_tmp52_ = colors;
#line 86 "../lib/Utils/Ensor/Score.vala"
				_tmp53_ = g_ptr_array_index (_tmp52_, (guint) i);
#line 86 "../lib/Utils/Ensor/Score.vala"
				_tmp54_ = he_color_hexcode_argb (((HeScoreAnnotatedColor*) _tmp53_)->argb);
#line 86 "../lib/Utils/Ensor/Score.vala"
				_tmp55_ = _tmp54_;
#line 86 "../lib/Utils/Ensor/Score.vala"
				_tmp56_ = colors;
#line 86 "../lib/Utils/Ensor/Score.vala"
				_tmp57_ = g_ptr_array_index (_tmp56_, (guint) i);
#line 86 "../lib/Utils/Ensor/Score.vala"
				g_print ("COLORS #%d BEFORE: %s SCORE: %f\n", i, _tmp55_, ((HeScoreAnnotatedColor*) _tmp57_)->score);
#line 86 "../lib/Utils/Ensor/Score.vala"
				_g_free0 (_tmp55_);
#line 779 "Score.c"
			}
		}
	}
#line 88 "../lib/Utils/Ensor/Score.vala"
	_tmp58_ = colors;
#line 88 "../lib/Utils/Ensor/Score.vala"
	_tmp59_ = he_score_annotated_color_cmp;
#line 88 "../lib/Utils/Ensor/Score.vala"
	vala_g_ptr_array_sort (_tmp58_, _tmp59_);
#line 789 "Score.c"
	{
		gint i = 0;
#line 89 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 794 "Score.c"
		{
			gboolean _tmp60_ = FALSE;
#line 89 "../lib/Utils/Ensor/Score.vala"
			_tmp60_ = TRUE;
#line 89 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 801 "Score.c"
				GPtrArray* _tmp62_;
				gconstpointer _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				GPtrArray* _tmp66_;
				gconstpointer _tmp67_;
#line 89 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp60_) {
#line 810 "Score.c"
					gint _tmp61_;
#line 89 "../lib/Utils/Ensor/Score.vala"
					_tmp61_ = i;
#line 89 "../lib/Utils/Ensor/Score.vala"
					i = _tmp61_ + 1;
#line 816 "Score.c"
				}
#line 89 "../lib/Utils/Ensor/Score.vala"
				_tmp60_ = FALSE;
#line 89 "../lib/Utils/Ensor/Score.vala"
				if (!(((guint) i) < input_size)) {
#line 89 "../lib/Utils/Ensor/Score.vala"
					break;
#line 824 "Score.c"
				}
#line 90 "../lib/Utils/Ensor/Score.vala"
				_tmp62_ = colors;
#line 90 "../lib/Utils/Ensor/Score.vala"
				_tmp63_ = g_ptr_array_index (_tmp62_, (guint) i);
#line 90 "../lib/Utils/Ensor/Score.vala"
				_tmp64_ = he_color_hexcode_argb (((HeScoreAnnotatedColor*) _tmp63_)->argb);
#line 90 "../lib/Utils/Ensor/Score.vala"
				_tmp65_ = _tmp64_;
#line 90 "../lib/Utils/Ensor/Score.vala"
				_tmp66_ = colors;
#line 90 "../lib/Utils/Ensor/Score.vala"
				_tmp67_ = g_ptr_array_index (_tmp66_, (guint) i);
#line 90 "../lib/Utils/Ensor/Score.vala"
				g_print ("COLORS #%d AFTER: %s SCORE: %f\n", i, _tmp65_, ((HeScoreAnnotatedColor*) _tmp67_)->score);
#line 90 "../lib/Utils/Ensor/Score.vala"
				_g_free0 (_tmp65_);
#line 842 "Score.c"
			}
		}
	}
#line 93 "../lib/Utils/Ensor/Score.vala"
	_tmp68_ = g_ptr_array_new_full ((guint) 0, _he_score_annotated_color_unref0_);
#line 93 "../lib/Utils/Ensor/Score.vala"
	selected_colors = _tmp68_;
#line 850 "Score.c"
	{
		gint i = 0;
#line 94 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 855 "Score.c"
		{
			gboolean _tmp69_ = FALSE;
#line 94 "../lib/Utils/Ensor/Score.vala"
			_tmp69_ = TRUE;
#line 94 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 862 "Score.c"
				GPtrArray* _tmp71_;
				gconstpointer _tmp72_;
				gboolean is_duplicate_color = FALSE;
				GPtrArray* _tmp82_;
				GPtrArray* _tmp83_;
				gconstpointer _tmp84_;
				HeScoreAnnotatedColor* _tmp85_;
#line 94 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp69_) {
#line 872 "Score.c"
					gint _tmp70_;
#line 94 "../lib/Utils/Ensor/Score.vala"
					_tmp70_ = i;
#line 94 "../lib/Utils/Ensor/Score.vala"
					i = _tmp70_ + 1;
#line 878 "Score.c"
				}
#line 94 "../lib/Utils/Ensor/Score.vala"
				_tmp69_ = FALSE;
#line 94 "../lib/Utils/Ensor/Score.vala"
				if (!(((guint) i) < input_size)) {
#line 94 "../lib/Utils/Ensor/Score.vala"
					break;
#line 886 "Score.c"
				}
#line 95 "../lib/Utils/Ensor/Score.vala"
				_tmp71_ = colors;
#line 95 "../lib/Utils/Ensor/Score.vala"
				_tmp72_ = g_ptr_array_index (_tmp71_, (guint) i);
#line 95 "../lib/Utils/Ensor/Score.vala"
				if (!he_score_good_color_finder (self, (HeScoreAnnotatedColor*) _tmp72_)) {
#line 96 "../lib/Utils/Ensor/Score.vala"
					continue;
#line 896 "Score.c"
				}
#line 99 "../lib/Utils/Ensor/Score.vala"
				is_duplicate_color = FALSE;
#line 900 "Score.c"
				{
					gint j = 0;
#line 100 "../lib/Utils/Ensor/Score.vala"
					j = 0;
#line 905 "Score.c"
					{
						gboolean _tmp73_ = FALSE;
#line 100 "../lib/Utils/Ensor/Score.vala"
						_tmp73_ = TRUE;
#line 100 "../lib/Utils/Ensor/Score.vala"
						while (TRUE) {
#line 912 "Score.c"
							GPtrArray* _tmp75_;
							gint _tmp76_;
							gint _tmp77_;
							GPtrArray* _tmp78_;
							gconstpointer _tmp79_;
							GPtrArray* _tmp80_;
							gconstpointer _tmp81_;
#line 100 "../lib/Utils/Ensor/Score.vala"
							if (!_tmp73_) {
#line 922 "Score.c"
								gint _tmp74_;
#line 100 "../lib/Utils/Ensor/Score.vala"
								_tmp74_ = j;
#line 100 "../lib/Utils/Ensor/Score.vala"
								j = _tmp74_ + 1;
#line 928 "Score.c"
							}
#line 100 "../lib/Utils/Ensor/Score.vala"
							_tmp73_ = FALSE;
#line 100 "../lib/Utils/Ensor/Score.vala"
							_tmp75_ = selected_colors;
#line 100 "../lib/Utils/Ensor/Score.vala"
							_tmp76_ = vala_g_ptr_array_get_length (_tmp75_);
#line 100 "../lib/Utils/Ensor/Score.vala"
							_tmp77_ = _tmp76_;
#line 100 "../lib/Utils/Ensor/Score.vala"
							if (!(j < _tmp77_)) {
#line 100 "../lib/Utils/Ensor/Score.vala"
								break;
#line 942 "Score.c"
							}
#line 101 "../lib/Utils/Ensor/Score.vala"
							_tmp78_ = selected_colors;
#line 101 "../lib/Utils/Ensor/Score.vala"
							_tmp79_ = g_ptr_array_index (_tmp78_, (guint) j);
#line 101 "../lib/Utils/Ensor/Score.vala"
							_tmp80_ = colors;
#line 101 "../lib/Utils/Ensor/Score.vala"
							_tmp81_ = g_ptr_array_index (_tmp80_, (guint) i);
#line 101 "../lib/Utils/Ensor/Score.vala"
							if (he_score_colors_are_too_close (self, (HeScoreAnnotatedColor*) _tmp79_, (HeScoreAnnotatedColor*) _tmp81_)) {
#line 102 "../lib/Utils/Ensor/Score.vala"
								is_duplicate_color = TRUE;
#line 103 "../lib/Utils/Ensor/Score.vala"
								break;
#line 958 "Score.c"
							}
						}
					}
				}
#line 107 "../lib/Utils/Ensor/Score.vala"
				if (is_duplicate_color) {
#line 108 "../lib/Utils/Ensor/Score.vala"
					continue;
#line 967 "Score.c"
				}
#line 111 "../lib/Utils/Ensor/Score.vala"
				_tmp82_ = selected_colors;
#line 111 "../lib/Utils/Ensor/Score.vala"
				_tmp83_ = colors;
#line 111 "../lib/Utils/Ensor/Score.vala"
				_tmp84_ = g_ptr_array_index (_tmp83_, (guint) i);
#line 111 "../lib/Utils/Ensor/Score.vala"
				_tmp85_ = _he_score_annotated_color_ref0 ((HeScoreAnnotatedColor*) _tmp84_);
#line 111 "../lib/Utils/Ensor/Score.vala"
				g_ptr_array_add (_tmp82_, _tmp85_);
#line 979 "Score.c"
			}
		}
	}
	{
		gint i = 0;
#line 114 "../lib/Utils/Ensor/Score.vala"
		i = 0;
#line 987 "Score.c"
		{
			gboolean _tmp86_ = FALSE;
#line 114 "../lib/Utils/Ensor/Score.vala"
			_tmp86_ = TRUE;
#line 114 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 994 "Score.c"
				GPtrArray* _tmp88_;
				gint _tmp89_;
				gint _tmp90_;
				GPtrArray* _tmp91_;
				gconstpointer _tmp92_;
				gchar* _tmp93_;
				gchar* _tmp94_;
#line 114 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp86_) {
#line 1004 "Score.c"
					gint _tmp87_;
#line 114 "../lib/Utils/Ensor/Score.vala"
					_tmp87_ = i;
#line 114 "../lib/Utils/Ensor/Score.vala"
					i = _tmp87_ + 1;
#line 1010 "Score.c"
				}
#line 114 "../lib/Utils/Ensor/Score.vala"
				_tmp86_ = FALSE;
#line 114 "../lib/Utils/Ensor/Score.vala"
				_tmp88_ = selected_colors;
#line 114 "../lib/Utils/Ensor/Score.vala"
				_tmp89_ = vala_g_ptr_array_get_length (_tmp88_);
#line 114 "../lib/Utils/Ensor/Score.vala"
				_tmp90_ = _tmp89_;
#line 114 "../lib/Utils/Ensor/Score.vala"
				if (!(i < _tmp90_)) {
#line 114 "../lib/Utils/Ensor/Score.vala"
					break;
#line 1024 "Score.c"
				}
#line 115 "../lib/Utils/Ensor/Score.vala"
				_tmp91_ = selected_colors;
#line 115 "../lib/Utils/Ensor/Score.vala"
				_tmp92_ = g_ptr_array_index (_tmp91_, (guint) i);
#line 115 "../lib/Utils/Ensor/Score.vala"
				_tmp93_ = he_color_hexcode_argb (((HeScoreAnnotatedColor*) _tmp92_)->argb);
#line 115 "../lib/Utils/Ensor/Score.vala"
				_tmp94_ = _tmp93_;
#line 115 "../lib/Utils/Ensor/Score.vala"
				g_print ("COLORS #%d AFTER SELECTION: %s\n", i, _tmp94_);
#line 115 "../lib/Utils/Ensor/Score.vala"
				_g_free0 (_tmp94_);
#line 1038 "Score.c"
			}
		}
	}
#line 118 "../lib/Utils/Ensor/Score.vala"
	_tmp95_ = selected_colors;
#line 118 "../lib/Utils/Ensor/Score.vala"
	_tmp96_ = vala_g_ptr_array_get_length (_tmp95_);
#line 118 "../lib/Utils/Ensor/Score.vala"
	_tmp97_ = _tmp96_;
#line 118 "../lib/Utils/Ensor/Score.vala"
	if (_tmp97_ == 0) {
#line 1050 "Score.c"
		GPtrArray* _tmp98_;
		HeScoreAnnotatedColor* _tmp99_ = NULL;
#line 119 "../lib/Utils/Ensor/Score.vala"
		_tmp98_ = selected_colors;
#line 119 "../lib/Utils/Ensor/Score.vala"
		_tmp99_ = he_score_annotated_color_new ();
#line 119 "../lib/Utils/Ensor/Score.vala"
		_tmp99_->argb = atoi ("#FF8C56BF");
#line 119 "../lib/Utils/Ensor/Score.vala"
		_tmp99_->cam_hue = 311.12;
#line 119 "../lib/Utils/Ensor/Score.vala"
		_tmp99_->cam_chroma = 57.36;
#line 119 "../lib/Utils/Ensor/Score.vala"
		_tmp99_->excited_proportion = (gdouble) 0;
#line 119 "../lib/Utils/Ensor/Score.vala"
		_tmp99_->score = (gdouble) 0;
#line 119 "../lib/Utils/Ensor/Score.vala"
		g_ptr_array_add (_tmp98_, _tmp99_);
#line 1069 "Score.c"
	}
#line 128 "../lib/Utils/Ensor/Score.vala"
	_tmp100_ = g_array_new (TRUE, TRUE, sizeof (gint*));
#line 128 "../lib/Utils/Ensor/Score.vala"
	g_array_set_clear_func (_tmp100_, (GDestroyNotify) _vala_gint_free_function_content_of);
#line 128 "../lib/Utils/Ensor/Score.vala"
	return_value = _tmp100_;
#line 1077 "Score.c"
	{
		gint j = 0;
#line 130 "../lib/Utils/Ensor/Score.vala"
		j = 0;
#line 1082 "Score.c"
		{
			gboolean _tmp101_ = FALSE;
#line 130 "../lib/Utils/Ensor/Score.vala"
			_tmp101_ = TRUE;
#line 130 "../lib/Utils/Ensor/Score.vala"
			while (TRUE) {
#line 1089 "Score.c"
				GPtrArray* _tmp103_;
				gint _tmp104_;
				gint _tmp105_;
				GArray* _tmp106_;
				GPtrArray* _tmp107_;
				gconstpointer _tmp108_;
				gint* _tmp109_;
#line 130 "../lib/Utils/Ensor/Score.vala"
				if (!_tmp101_) {
#line 1099 "Score.c"
					gint _tmp102_;
#line 130 "../lib/Utils/Ensor/Score.vala"
					_tmp102_ = j;
#line 130 "../lib/Utils/Ensor/Score.vala"
					j = _tmp102_ + 1;
#line 1105 "Score.c"
				}
#line 130 "../lib/Utils/Ensor/Score.vala"
				_tmp101_ = FALSE;
#line 130 "../lib/Utils/Ensor/Score.vala"
				_tmp103_ = selected_colors;
#line 130 "../lib/Utils/Ensor/Score.vala"
				_tmp104_ = vala_g_ptr_array_get_length (_tmp103_);
#line 130 "../lib/Utils/Ensor/Score.vala"
				_tmp105_ = _tmp104_;
#line 130 "../lib/Utils/Ensor/Score.vala"
				if (!(j < _tmp105_)) {
#line 130 "../lib/Utils/Ensor/Score.vala"
					break;
#line 1119 "Score.c"
				}
#line 131 "../lib/Utils/Ensor/Score.vala"
				_tmp106_ = return_value;
#line 131 "../lib/Utils/Ensor/Score.vala"
				_tmp107_ = selected_colors;
#line 131 "../lib/Utils/Ensor/Score.vala"
				_tmp108_ = g_ptr_array_index (_tmp107_, (guint) j);
#line 131 "../lib/Utils/Ensor/Score.vala"
				_tmp109_ = __int_dup0 (&((HeScoreAnnotatedColor*) _tmp108_)->argb);
#line 131 "../lib/Utils/Ensor/Score.vala"
				g_array_append_val (_tmp106_, _tmp109_);
#line 1131 "Score.c"
			}
		}
	}
#line 134 "../lib/Utils/Ensor/Score.vala"
	_tmp110_ = return_value;
#line 134 "../lib/Utils/Ensor/Score.vala"
	g_print ("FIRST ENSOR ARGB RESULT: %d\n", *g_array_index (_tmp110_, gint*, (guint) 0));
#line 136 "../lib/Utils/Ensor/Score.vala"
	result = return_value;
#line 136 "../lib/Utils/Ensor/Score.vala"
	_g_ptr_array_unref0 (selected_colors);
#line 136 "../lib/Utils/Ensor/Score.vala"
	_g_ptr_array_unref0 (colors);
#line 136 "../lib/Utils/Ensor/Score.vala"
	hue_proportions = (g_free (hue_proportions), NULL);
#line 136 "../lib/Utils/Ensor/Score.vala"
	populations = (g_free (populations), NULL);
#line 136 "../lib/Utils/Ensor/Score.vala"
	argbs = (g_free (argbs), NULL);
#line 136 "../lib/Utils/Ensor/Score.vala"
	return result;
#line 1153 "Score.c"
}

static gboolean
he_score_good_color_finder (HeScore* self,
                            HeScoreAnnotatedColor* color)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 139 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 139 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (color != NULL, FALSE);
#line 140 "../lib/Utils/Ensor/Score.vala"
	if (color->cam_chroma >= HE_SCORE_CUTOFF_CHROMA) {
#line 141 "../lib/Utils/Ensor/Score.vala"
		_tmp1_ = he_math_utils_lstar_from_argb (color->argb) >= HE_SCORE_CUTOFF_TONE;
#line 1171 "Score.c"
	} else {
#line 140 "../lib/Utils/Ensor/Score.vala"
		_tmp1_ = FALSE;
#line 1175 "Score.c"
	}
#line 140 "../lib/Utils/Ensor/Score.vala"
	if (_tmp1_) {
#line 142 "../lib/Utils/Ensor/Score.vala"
		_tmp0_ = color->excited_proportion >= HE_SCORE_CUTOFF_EXCITED_PROPORTION;
#line 1181 "Score.c"
	} else {
#line 140 "../lib/Utils/Ensor/Score.vala"
		_tmp0_ = FALSE;
#line 1185 "Score.c"
	}
#line 140 "../lib/Utils/Ensor/Score.vala"
	result = _tmp0_;
#line 140 "../lib/Utils/Ensor/Score.vala"
	return result;
#line 1191 "Score.c"
}

static gboolean
he_score_colors_are_too_close (HeScore* self,
                               HeScoreAnnotatedColor* color_one,
                               HeScoreAnnotatedColor* color_two)
{
	gboolean result;
#line 145 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (color_one != NULL, FALSE);
#line 145 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (color_two != NULL, FALSE);
#line 146 "../lib/Utils/Ensor/Score.vala"
	result = he_math_utils_difference_degrees (color_one->cam_hue, color_two->cam_hue) < 15.0;
#line 146 "../lib/Utils/Ensor/Score.vala"
	return result;
#line 1210 "Score.c"
}

HeScore*
he_score_construct (GType object_type)
{
	HeScore* self = NULL;
#line 5 "../lib/Utils/Ensor/Score.vala"
	self = (HeScore*) g_type_create_instance (object_type);
#line 5 "../lib/Utils/Ensor/Score.vala"
	return self;
#line 1221 "Score.c"
}

HeScore*
he_score_new (void)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	return he_score_construct (HE_TYPE_SCORE);
#line 1229 "Score.c"
}

static gint
_he_score_annotated_color_cmp_lambda27_ (HeScoreAnnotatedColor* a,
                                         HeScoreAnnotatedColor* b)
{
	gint result;
#line 23 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 23 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 24 "../lib/Utils/Ensor/Score.vala"
	result = ((gint) (a->score < b->score)) - ((gint) (a->score > b->score));
#line 24 "../lib/Utils/Ensor/Score.vala"
	return result;
#line 1245 "Score.c"
}

static gint
__he_score_annotated_color_cmp_lambda27__gcompare_func (gconstpointer a,
                                                        gconstpointer b)
{
	gint result;
	result = _he_score_annotated_color_cmp_lambda27_ ((HeScoreAnnotatedColor*) a, (HeScoreAnnotatedColor*) b);
#line 23 "../lib/Utils/Ensor/Score.vala"
	return result;
#line 1256 "Score.c"
}

HeScoreAnnotatedColor*
he_score_annotated_color_construct (GType object_type)
{
	HeScoreAnnotatedColor* self = NULL;
#line 15 "../lib/Utils/Ensor/Score.vala"
	self = (HeScoreAnnotatedColor*) g_type_create_instance (object_type);
#line 15 "../lib/Utils/Ensor/Score.vala"
	return self;
#line 1267 "Score.c"
}

HeScoreAnnotatedColor*
he_score_annotated_color_new (void)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	return he_score_annotated_color_construct (HE_SCORE_TYPE_ANNOTATED_COLOR);
#line 1275 "Score.c"
}

static void
he_score_value_annotated_color_init (GValue* value)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	value->data[0].v_pointer = NULL;
#line 1283 "Score.c"
}

static void
he_score_value_annotated_color_free_value (GValue* value)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (value->data[0].v_pointer) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		he_score_annotated_color_unref (value->data[0].v_pointer);
#line 1293 "Score.c"
	}
}

static void
he_score_value_annotated_color_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (src_value->data[0].v_pointer) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		dest_value->data[0].v_pointer = he_score_annotated_color_ref (src_value->data[0].v_pointer);
#line 1305 "Score.c"
	} else {
#line 15 "../lib/Utils/Ensor/Score.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1309 "Score.c"
	}
}

static gpointer
he_score_value_annotated_color_peek_pointer (const GValue* value)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	return value->data[0].v_pointer;
#line 1318 "Score.c"
}

static gchar*
he_score_value_annotated_color_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (collect_values[0].v_pointer) {
#line 1329 "Score.c"
		HeScoreAnnotatedColor * object;
		object = collect_values[0].v_pointer;
#line 15 "../lib/Utils/Ensor/Score.vala"
		if (object->parent_instance.g_class == NULL) {
#line 15 "../lib/Utils/Ensor/Score.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1336 "Score.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 15 "../lib/Utils/Ensor/Score.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1340 "Score.c"
		}
#line 15 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = he_score_annotated_color_ref (object);
#line 1344 "Score.c"
	} else {
#line 15 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = NULL;
#line 1348 "Score.c"
	}
#line 15 "../lib/Utils/Ensor/Score.vala"
	return NULL;
#line 1352 "Score.c"
}

static gchar*
he_score_value_annotated_color_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	HeScoreAnnotatedColor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (!object_p) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1367 "Score.c"
	}
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (!value->data[0].v_pointer) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		*object_p = NULL;
#line 1373 "Score.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		*object_p = value->data[0].v_pointer;
#line 1377 "Score.c"
	} else {
#line 15 "../lib/Utils/Ensor/Score.vala"
		*object_p = he_score_annotated_color_ref (value->data[0].v_pointer);
#line 1381 "Score.c"
	}
#line 15 "../lib/Utils/Ensor/Score.vala"
	return NULL;
#line 1385 "Score.c"
}

GParamSpec*
he_score_param_spec_annotated_color (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	HeScoreParamSpecAnnotatedColor* spec;
#line 15 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (g_type_is_a (object_type, HE_SCORE_TYPE_ANNOTATED_COLOR), NULL);
#line 15 "../lib/Utils/Ensor/Score.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 15 "../lib/Utils/Ensor/Score.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 15 "../lib/Utils/Ensor/Score.vala"
	return G_PARAM_SPEC (spec);
#line 1404 "Score.c"
}

gpointer
he_score_value_get_annotated_color (const GValue* value)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_SCORE_TYPE_ANNOTATED_COLOR), NULL);
#line 15 "../lib/Utils/Ensor/Score.vala"
	return value->data[0].v_pointer;
#line 1414 "Score.c"
}

void
he_score_value_set_annotated_color (GValue* value,
                                    gpointer v_object)
{
	HeScoreAnnotatedColor * old;
#line 15 "../lib/Utils/Ensor/Score.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_SCORE_TYPE_ANNOTATED_COLOR));
#line 15 "../lib/Utils/Ensor/Score.vala"
	old = value->data[0].v_pointer;
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (v_object) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HE_SCORE_TYPE_ANNOTATED_COLOR));
#line 15 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = v_object;
#line 15 "../lib/Utils/Ensor/Score.vala"
		he_score_annotated_color_ref (value->data[0].v_pointer);
#line 1436 "Score.c"
	} else {
#line 15 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = NULL;
#line 1440 "Score.c"
	}
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (old) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		he_score_annotated_color_unref (old);
#line 1446 "Score.c"
	}
}

void
he_score_value_take_annotated_color (GValue* value,
                                     gpointer v_object)
{
	HeScoreAnnotatedColor * old;
#line 15 "../lib/Utils/Ensor/Score.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_SCORE_TYPE_ANNOTATED_COLOR));
#line 15 "../lib/Utils/Ensor/Score.vala"
	old = value->data[0].v_pointer;
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (v_object) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HE_SCORE_TYPE_ANNOTATED_COLOR));
#line 15 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = v_object;
#line 1467 "Score.c"
	} else {
#line 15 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = NULL;
#line 1471 "Score.c"
	}
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (old) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		he_score_annotated_color_unref (old);
#line 1477 "Score.c"
	}
}

static void
he_score_annotated_color_class_init (HeScoreAnnotatedColorClass * klass,
                                     gpointer klass_data)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	he_score_annotated_color_parent_class = g_type_class_peek_parent (klass);
#line 15 "../lib/Utils/Ensor/Score.vala"
	((HeScoreAnnotatedColorClass *) klass)->finalize = he_score_annotated_color_finalize;
#line 23 "../lib/Utils/Ensor/Score.vala"
	he_score_annotated_color_cmp = __he_score_annotated_color_cmp_lambda27__gcompare_func;
#line 1491 "Score.c"
}

static void
he_score_annotated_color_instance_init (HeScoreAnnotatedColor * self,
                                        gpointer klass)
{
#line 15 "../lib/Utils/Ensor/Score.vala"
	self->ref_count = 1;
#line 1500 "Score.c"
}

static void
he_score_annotated_color_finalize (HeScoreAnnotatedColor * obj)
{
	HeScoreAnnotatedColor * self;
#line 15 "../lib/Utils/Ensor/Score.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_SCORE_TYPE_ANNOTATED_COLOR, HeScoreAnnotatedColor);
#line 15 "../lib/Utils/Ensor/Score.vala"
	g_signal_handlers_destroy (self);
#line 1511 "Score.c"
}

static GType
he_score_annotated_color_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { he_score_value_annotated_color_init, he_score_value_annotated_color_free_value, he_score_value_annotated_color_copy_value, he_score_value_annotated_color_peek_pointer, "p", he_score_value_annotated_color_collect_value, "p", he_score_value_annotated_color_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HeScoreAnnotatedColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_score_annotated_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeScoreAnnotatedColor), 0, (GInstanceInitFunc) he_score_annotated_color_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType he_score_annotated_color_type_id;
	he_score_annotated_color_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HeScoreAnnotatedColor", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return he_score_annotated_color_type_id;
}

GType
he_score_annotated_color_get_type (void)
{
	static volatile gsize he_score_annotated_color_type_id__once = 0;
	if (g_once_init_enter (&he_score_annotated_color_type_id__once)) {
		GType he_score_annotated_color_type_id;
		he_score_annotated_color_type_id = he_score_annotated_color_get_type_once ();
		g_once_init_leave (&he_score_annotated_color_type_id__once, he_score_annotated_color_type_id);
	}
	return he_score_annotated_color_type_id__once;
}

gpointer
he_score_annotated_color_ref (gpointer instance)
{
	HeScoreAnnotatedColor * self;
	self = instance;
#line 15 "../lib/Utils/Ensor/Score.vala"
	g_atomic_int_inc (&self->ref_count);
#line 15 "../lib/Utils/Ensor/Score.vala"
	return instance;
#line 1546 "Score.c"
}

void
he_score_annotated_color_unref (gpointer instance)
{
	HeScoreAnnotatedColor * self;
	self = instance;
#line 15 "../lib/Utils/Ensor/Score.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 15 "../lib/Utils/Ensor/Score.vala"
		HE_SCORE_ANNOTATED_COLOR_GET_CLASS (self)->finalize (self);
#line 15 "../lib/Utils/Ensor/Score.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1560 "Score.c"
	}
}

static void
he_value_score_init (GValue* value)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	value->data[0].v_pointer = NULL;
#line 1569 "Score.c"
}

static void
he_value_score_free_value (GValue* value)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (value->data[0].v_pointer) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		he_score_unref (value->data[0].v_pointer);
#line 1579 "Score.c"
	}
}

static void
he_value_score_copy_value (const GValue* src_value,
                           GValue* dest_value)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (src_value->data[0].v_pointer) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		dest_value->data[0].v_pointer = he_score_ref (src_value->data[0].v_pointer);
#line 1591 "Score.c"
	} else {
#line 5 "../lib/Utils/Ensor/Score.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1595 "Score.c"
	}
}

static gpointer
he_value_score_peek_pointer (const GValue* value)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	return value->data[0].v_pointer;
#line 1604 "Score.c"
}

static gchar*
he_value_score_collect_value (GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (collect_values[0].v_pointer) {
#line 1615 "Score.c"
		HeScore * object;
		object = collect_values[0].v_pointer;
#line 5 "../lib/Utils/Ensor/Score.vala"
		if (object->parent_instance.g_class == NULL) {
#line 5 "../lib/Utils/Ensor/Score.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1622 "Score.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 5 "../lib/Utils/Ensor/Score.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1626 "Score.c"
		}
#line 5 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = he_score_ref (object);
#line 1630 "Score.c"
	} else {
#line 5 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = NULL;
#line 1634 "Score.c"
	}
#line 5 "../lib/Utils/Ensor/Score.vala"
	return NULL;
#line 1638 "Score.c"
}

static gchar*
he_value_score_lcopy_value (const GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
	HeScore ** object_p;
	object_p = collect_values[0].v_pointer;
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (!object_p) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1653 "Score.c"
	}
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (!value->data[0].v_pointer) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		*object_p = NULL;
#line 1659 "Score.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		*object_p = value->data[0].v_pointer;
#line 1663 "Score.c"
	} else {
#line 5 "../lib/Utils/Ensor/Score.vala"
		*object_p = he_score_ref (value->data[0].v_pointer);
#line 1667 "Score.c"
	}
#line 5 "../lib/Utils/Ensor/Score.vala"
	return NULL;
#line 1671 "Score.c"
}

GParamSpec*
he_param_spec_score (const gchar* name,
                     const gchar* nick,
                     const gchar* blurb,
                     GType object_type,
                     GParamFlags flags)
{
	HeParamSpecScore* spec;
#line 5 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (g_type_is_a (object_type, HE_TYPE_SCORE), NULL);
#line 5 "../lib/Utils/Ensor/Score.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 5 "../lib/Utils/Ensor/Score.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 5 "../lib/Utils/Ensor/Score.vala"
	return G_PARAM_SPEC (spec);
#line 1690 "Score.c"
}

gpointer
he_value_get_score (const GValue* value)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_TYPE_SCORE), NULL);
#line 5 "../lib/Utils/Ensor/Score.vala"
	return value->data[0].v_pointer;
#line 1700 "Score.c"
}

void
he_value_set_score (GValue* value,
                    gpointer v_object)
{
	HeScore * old;
#line 5 "../lib/Utils/Ensor/Score.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_TYPE_SCORE));
#line 5 "../lib/Utils/Ensor/Score.vala"
	old = value->data[0].v_pointer;
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (v_object) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HE_TYPE_SCORE));
#line 5 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 5 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = v_object;
#line 5 "../lib/Utils/Ensor/Score.vala"
		he_score_ref (value->data[0].v_pointer);
#line 1722 "Score.c"
	} else {
#line 5 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = NULL;
#line 1726 "Score.c"
	}
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (old) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		he_score_unref (old);
#line 1732 "Score.c"
	}
}

void
he_value_take_score (GValue* value,
                     gpointer v_object)
{
	HeScore * old;
#line 5 "../lib/Utils/Ensor/Score.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HE_TYPE_SCORE));
#line 5 "../lib/Utils/Ensor/Score.vala"
	old = value->data[0].v_pointer;
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (v_object) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HE_TYPE_SCORE));
#line 5 "../lib/Utils/Ensor/Score.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 5 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = v_object;
#line 1753 "Score.c"
	} else {
#line 5 "../lib/Utils/Ensor/Score.vala"
		value->data[0].v_pointer = NULL;
#line 1757 "Score.c"
	}
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (old) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		he_score_unref (old);
#line 1763 "Score.c"
	}
}

static void
he_score_class_init (HeScoreClass * klass,
                     gpointer klass_data)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	he_score_parent_class = g_type_class_peek_parent (klass);
#line 5 "../lib/Utils/Ensor/Score.vala"
	((HeScoreClass *) klass)->finalize = he_score_finalize;
#line 1775 "Score.c"
}

static void
he_score_instance_init (HeScore * self,
                        gpointer klass)
{
#line 5 "../lib/Utils/Ensor/Score.vala"
	self->ref_count = 1;
#line 1784 "Score.c"
}

static void
he_score_finalize (HeScore * obj)
{
	HeScore * self;
#line 5 "../lib/Utils/Ensor/Score.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SCORE, HeScore);
#line 5 "../lib/Utils/Ensor/Score.vala"
	g_signal_handlers_destroy (self);
#line 1795 "Score.c"
}

static GType
he_score_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { he_value_score_init, he_value_score_free_value, he_value_score_copy_value, he_value_score_peek_pointer, "p", he_value_score_collect_value, "p", he_value_score_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HeScoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_score_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeScore), 0, (GInstanceInitFunc) he_score_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType he_score_type_id;
	he_score_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HeScore", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return he_score_type_id;
}

GType
he_score_get_type (void)
{
	static volatile gsize he_score_type_id__once = 0;
	if (g_once_init_enter (&he_score_type_id__once)) {
		GType he_score_type_id;
		he_score_type_id = he_score_get_type_once ();
		g_once_init_leave (&he_score_type_id__once, he_score_type_id);
	}
	return he_score_type_id__once;
}

gpointer
he_score_ref (gpointer instance)
{
	HeScore * self;
	self = instance;
#line 5 "../lib/Utils/Ensor/Score.vala"
	g_atomic_int_inc (&self->ref_count);
#line 5 "../lib/Utils/Ensor/Score.vala"
	return instance;
#line 1830 "Score.c"
}

void
he_score_unref (gpointer instance)
{
	HeScore * self;
	self = instance;
#line 5 "../lib/Utils/Ensor/Score.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 5 "../lib/Utils/Ensor/Score.vala"
		HE_SCORE_GET_CLASS (self)->finalize (self);
#line 5 "../lib/Utils/Ensor/Score.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1844 "Score.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

