/* AboutWindow.c generated by valac 0.56.15, the Vala compiler
 * generated from AboutWindow.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_ABOUT_WINDOW_0_PROPERTY,
	HE_ABOUT_WINDOW_COLOR_PROPERTY,
	HE_ABOUT_WINDOW_LICENSE_PROPERTY,
	HE_ABOUT_WINDOW_VERSION_PROPERTY,
	HE_ABOUT_WINDOW_APP_NAME_PROPERTY,
	HE_ABOUT_WINDOW_ICON_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY,
	HE_ABOUT_WINDOW_APP_ID_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY,
	HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY,
	HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY,
	HE_ABOUT_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_about_window_properties[HE_ABOUT_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeAboutWindowPrivate {
	HeAppBar* app_bar;
	GtkOverlay* window_overlay;
	GtkBox* about_box;
	GtkBox* content_box;
	GtkBox* button_box;
	GtkBox* info_box;
	GtkBox* title_box;
	GtkBox* text_box;
	GtkLabel* title_label;
	GtkLabel* copyright_label;
	GtkLabel* translators_label;
	GtkLabel* license_label;
	GtkImage* icon_image;
	HeTextButton* translate_app_button;
	HeTintButton* report_button;
	HeFillButton* more_info_button;
	HeModifierBadge* version_badge;
	HeColors _color;
	HeAboutWindowLicenses _license;
	gchar** translators;
	gint translators_length1;
	gint _translators_size_;
	gchar** developers;
	gint developers_length1;
	gint _developers_size_;
	gint _copyright_year;
	gchar* _translate_url;
	gchar* _issue_url;
	gchar* _more_info_url;
	gchar* _app_id;
};

static gint HeAboutWindow_private_offset;
static gpointer he_about_window_parent_class = NULL;

static gchar** _vala_array_dup13 (gchar** self,
                           gssize length);
static void he_about_window_update_copyright (HeAboutWindow* self,
                                       gint year,
                                       gchar** developers,
                                       gint developers_length1);
static gchar** _vala_array_dup14 (gchar** self,
                           gssize length);
static GObject * he_about_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _he_about_window___lambda8_ (HeAboutWindow* self);
static void __he_about_window___lambda8__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void _he_about_window___lambda9_ (HeAboutWindow* self);
static void __he_about_window___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void _he_about_window___lambda10_ (HeAboutWindow* self);
static void __he_about_window___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void he_about_window_finalize (GObject * obj);
static GType he_about_window_get_type_once (void);
static void _vala_he_about_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_about_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_about_window_get_instance_private (HeAboutWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeAboutWindow_private_offset);
}

/**
  * An enum of commonly used licenses to be used in AboutWindow.
  */
/**
    * Returns the license url for the license.
    */
gchar*
he_about_window_licenses_get_url (HeAboutWindowLicenses self)
{
	gchar* result;
#line 64 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 64 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 159 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 66 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("https://choosealicense.com/licenses/gpl-3.0");
#line 66 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 66 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 168 "AboutWindow.c"
		}
#line 64 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 172 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 68 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("https://choosealicense.com/licenses/mit");
#line 68 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 68 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 181 "AboutWindow.c"
		}
#line 64 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 185 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 70 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("https://choosealicense.com/licenses/mpl-2.0");
#line 70 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 70 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 194 "AboutWindow.c"
		}
#line 64 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 198 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 72 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("https://choosealicense.com/licenses/unlicense");
#line 72 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 72 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 207 "AboutWindow.c"
		}
#line 64 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 211 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 74 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("https://choosealicense.com/licenses/apache-2.0");
#line 74 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 74 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 220 "AboutWindow.c"
		}
#line 64 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 224 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 76 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("https://choosealicense.com/licenses/wtfpl");
#line 76 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 76 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 233 "AboutWindow.c"
		}
#line 64 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 237 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 78 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("https://choosealicense.com/no-permission");
#line 78 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 78 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 246 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 80 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("about:blank");
#line 80 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 80 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 257 "AboutWindow.c"
		}
	}
}

/**
    * Returns the license name for the license.
    */
gchar*
he_about_window_licenses_get_name (HeAboutWindowLicenses self)
{
	gchar* result;
#line 88 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 88 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 273 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 90 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("GPLv3");
#line 90 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 90 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 282 "AboutWindow.c"
		}
#line 88 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 286 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 92 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("MIT");
#line 92 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 92 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 295 "AboutWindow.c"
		}
#line 88 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 299 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 94 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("MPLv2");
#line 94 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 94 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 308 "AboutWindow.c"
		}
#line 88 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 312 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 96 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("Unlicense");
#line 96 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 96 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 321 "AboutWindow.c"
		}
#line 88 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 325 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 98 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("Apache License v2");
#line 98 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 98 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 334 "AboutWindow.c"
		}
#line 88 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 338 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 100 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("WTFPL");
#line 100 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 100 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 347 "AboutWindow.c"
		}
#line 88 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 351 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 102 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("a proprietary license");
#line 102 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 102 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 360 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 104 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("N/A");
#line 104 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 104 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 371 "AboutWindow.c"
		}
	}
}

static GType
he_about_window_licenses_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_ABOUT_WINDOW_LICENSES_GPLV3, "HE_ABOUT_WINDOW_LICENSES_GPLV3", "gplv3"}, {HE_ABOUT_WINDOW_LICENSES_MIT, "HE_ABOUT_WINDOW_LICENSES_MIT", "mit"}, {HE_ABOUT_WINDOW_LICENSES_MPLV2, "HE_ABOUT_WINDOW_LICENSES_MPLV2", "mplv2"}, {HE_ABOUT_WINDOW_LICENSES_UNLICENSE, "HE_ABOUT_WINDOW_LICENSES_UNLICENSE", "unlicense"}, {HE_ABOUT_WINDOW_LICENSES_APACHEV2, "HE_ABOUT_WINDOW_LICENSES_APACHEV2", "apachev2"}, {HE_ABOUT_WINDOW_LICENSES_WTFPL, "HE_ABOUT_WINDOW_LICENSES_WTFPL", "wtfpl"}, {HE_ABOUT_WINDOW_LICENSES_PROPRIETARY, "HE_ABOUT_WINDOW_LICENSES_PROPRIETARY", "proprietary"}, {0, NULL, NULL}};
	GType he_about_window_licenses_type_id;
	he_about_window_licenses_type_id = g_enum_register_static ("HeAboutWindowLicenses", values);
	return he_about_window_licenses_type_id;
}

GType
he_about_window_licenses_get_type (void)
{
	static volatile gsize he_about_window_licenses_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_licenses_type_id__once)) {
		GType he_about_window_licenses_type_id;
		he_about_window_licenses_type_id = he_about_window_licenses_get_type_once ();
		g_once_init_leave (&he_about_window_licenses_type_id__once, he_about_window_licenses_type_id);
	}
	return he_about_window_licenses_type_id__once;
}

HeColors
he_about_window_get_color (HeAboutWindow* self)
{
	HeColors result;
#line 115 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 116 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_color;
#line 116 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 407 "AboutWindow.c"
}

void
he_about_window_set_color (HeAboutWindow* self,
                           HeColors value)
{
	HeTextButton* _tmp0_;
	HeTintButton* _tmp1_;
	HeFillButton* _tmp2_;
	HeModifierBadge* _tmp3_;
#line 118 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 119 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = value;
#line 120 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translate_app_button;
#line 120 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color ((HeButton*) _tmp0_, value);
#line 121 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->report_button;
#line 121 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color ((HeButton*) _tmp1_, value);
#line 122 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->more_info_button;
#line 122 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color ((HeButton*) _tmp2_, value);
#line 123 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = self->priv->version_badge;
#line 123 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_color (_tmp3_, value);
#line 118 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY]);
#line 440 "AboutWindow.c"
}

HeAboutWindowLicenses
he_about_window_get_license (HeAboutWindow* self)
{
	HeAboutWindowLicenses result;
#line 133 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 133 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_license;
#line 133 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 453 "AboutWindow.c"
}

void
he_about_window_set_license (HeAboutWindow* self,
                             HeAboutWindowLicenses value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 134 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 135 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = value;
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->license_label;
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = g_strdup_printf (_ ("This program is licensed under %s"), "<a href=\"%s\">%s</a>");
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = he_about_window_licenses_get_url (value);
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = _tmp3_;
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = he_about_window_licenses_get_name (value);
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = _tmp5_;
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = g_strdup_printf (_tmp2_, _tmp4_, _tmp6_);
#line 136 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = _tmp7_;
#line 136 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_markup (_tmp0_, _tmp8_);
#line 136 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp8_);
#line 136 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp6_);
#line 136 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp4_);
#line 136 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp2_);
#line 134 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY]);
#line 503 "AboutWindow.c"
}

const gchar*
he_about_window_get_version (HeAboutWindow* self)
{
	const gchar* result;
	HeModifierBadge* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 144 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 144 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 144 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_modifier_badge_get_label (_tmp0_);
#line 144 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 144 "../lib/Widgets/AboutWindow.vala"
	result = _tmp2_;
#line 144 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 525 "AboutWindow.c"
}

void
he_about_window_set_version (HeAboutWindow* self,
                             const gchar* value)
{
	HeModifierBadge* _tmp0_;
#line 145 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 145 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 145 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_label (_tmp0_, value);
#line 145 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY]);
#line 541 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_name (HeAboutWindow* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 152 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 152 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 152 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 152 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 560 "AboutWindow.c"
}

void
he_about_window_set_app_name (HeAboutWindow* self,
                              const gchar* value)
{
	GtkLabel* _tmp0_;
#line 153 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 153 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 153 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_text (_tmp0_, value);
#line 153 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY]);
#line 576 "AboutWindow.c"
}

const gchar*
he_about_window_get_icon (HeAboutWindow* self)
{
	const gchar* result;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
#line 160 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 160 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_image_get_icon_name (_tmp0_);
#line 160 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 160 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 595 "AboutWindow.c"
}

void
he_about_window_set_icon (HeAboutWindow* self,
                          const gchar* value)
{
	GtkImage* _tmp0_;
#line 161 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 161 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 161 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_from_icon_name (_tmp0_, value);
#line 161 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY]);
#line 611 "AboutWindow.c"
}

gchar**
he_about_window_get_translator_names (HeAboutWindow* self,
                                      gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 169 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translators;
#line 169 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->translators_length1;
#line 169 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 169 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 169 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 169 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 637 "AboutWindow.c"
	}
#line 169 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 169 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 643 "AboutWindow.c"
}

static gchar**
_vala_array_dup13 (gchar** self,
                   gssize length)
{
#line 171 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 652 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 171 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 171 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 659 "AboutWindow.c"
			gchar* _tmp0_;
#line 171 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 171 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 665 "AboutWindow.c"
		}
#line 171 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 669 "AboutWindow.c"
	}
#line 171 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 673 "AboutWindow.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 687 "AboutWindow.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 691 "AboutWindow.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 697 "AboutWindow.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 702 "AboutWindow.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 708 "AboutWindow.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 712 "AboutWindow.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 716 "AboutWindow.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 720 "AboutWindow.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 724 "AboutWindow.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 728 "AboutWindow.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 743 "AboutWindow.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 752 "AboutWindow.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 759 "AboutWindow.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 765 "AboutWindow.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 773 "AboutWindow.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 777 "AboutWindow.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 783 "AboutWindow.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 788 "AboutWindow.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 794 "AboutWindow.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 798 "AboutWindow.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 802 "AboutWindow.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 808 "AboutWindow.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 814 "AboutWindow.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 826 "AboutWindow.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 830 "AboutWindow.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 834 "AboutWindow.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 839 "AboutWindow.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 847 "AboutWindow.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 865 "AboutWindow.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 871 "AboutWindow.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 875 "AboutWindow.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 883 "AboutWindow.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 892 "AboutWindow.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 901 "AboutWindow.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 907 "AboutWindow.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 915 "AboutWindow.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 927 "AboutWindow.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 933 "AboutWindow.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 937 "AboutWindow.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 945 "AboutWindow.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 956 "AboutWindow.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 965 "AboutWindow.c"
	}
}

void
he_about_window_set_translator_names (HeAboutWindow* self,
                                      gchar** value,
                                      gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 170 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 171 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup13 (value, value_length1) : value;
#line 171 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 171 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 171 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp0_;
#line 171 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = _tmp0__length1;
#line 171 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 172 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->translators;
#line 172 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = self->priv->translators_length1;
#line 172 "../lib/Widgets/AboutWindow.vala"
	if (_tmp1__length1 > 0) {
#line 998 "AboutWindow.c"
		GtkLabel* _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 173 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->translators_label;
#line 173 "../lib/Widgets/AboutWindow.vala"
		_tmp3_ = self->priv->translators;
#line 173 "../lib/Widgets/AboutWindow.vala"
		_tmp3__length1 = self->priv->translators_length1;
#line 173 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = _vala_g_strjoinv (", ", _tmp3_, (gint) _tmp3__length1);
#line 173 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = _tmp4_;
#line 173 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = g_strdup_printf (_ ("Translated By: %s"), _tmp5_);
#line 173 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = _tmp6_;
#line 173 "../lib/Widgets/AboutWindow.vala"
		gtk_label_set_text (_tmp2_, _tmp7_);
#line 173 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp7_);
#line 173 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp5_);
#line 174 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = self->priv->translators_label;
#line 174 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 1031 "AboutWindow.c"
	} else {
		GtkLabel* _tmp9_;
		GtkLabel* _tmp10_;
#line 176 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = self->priv->translators_label;
#line 176 "../lib/Widgets/AboutWindow.vala"
		gtk_label_set_text (_tmp9_, "");
#line 177 "../lib/Widgets/AboutWindow.vala"
		_tmp10_ = self->priv->translators_label;
#line 177 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 1043 "AboutWindow.c"
	}
#line 170 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY]);
#line 1047 "AboutWindow.c"
}

static void
he_about_window_update_copyright (HeAboutWindow* self,
                                  gint year,
                                  gchar** developers,
                                  gint developers_length1)
{
	gchar* _tmp0_ = NULL;
	gchar* developers_text = NULL;
	gchar* _tmp3_;
#line 182 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 183 "../lib/Widgets/AboutWindow.vala"
	if (developers_length1 > 0) {
#line 1063 "AboutWindow.c"
		gchar* _tmp1_;
#line 183 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = _vala_g_strjoinv (", ", developers, (gint) developers_length1);
#line 183 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp0_);
#line 183 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = _tmp1_;
#line 1071 "AboutWindow.c"
	} else {
		gchar* _tmp2_;
#line 183 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = g_strdup ("");
#line 183 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp0_);
#line 183 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = _tmp2_;
#line 1080 "AboutWindow.c"
	}
#line 183 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 183 "../lib/Widgets/AboutWindow.vala"
	developers_text = _tmp3_;
#line 185 "../lib/Widgets/AboutWindow.vala"
	if (year > 0) {
#line 1088 "AboutWindow.c"
		GtkLabel* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 186 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = self->priv->copyright_label;
#line 186 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = developers_text;
#line 186 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = g_strdup_printf (_ ("Copyright © %i %s"), year, _tmp5_);
#line 186 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = _tmp6_;
#line 186 "../lib/Widgets/AboutWindow.vala"
		gtk_label_set_text (_tmp4_, _tmp7_);
#line 186 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp7_);
#line 187 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = self->priv->copyright_label;
#line 187 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 1110 "AboutWindow.c"
	} else {
		const gchar* _tmp9_;
#line 188 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = developers_text;
#line 188 "../lib/Widgets/AboutWindow.vala"
		if (g_strcmp0 (_tmp9_, "") != 0) {
#line 1117 "AboutWindow.c"
			GtkLabel* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GtkLabel* _tmp14_;
#line 189 "../lib/Widgets/AboutWindow.vala"
			_tmp10_ = self->priv->copyright_label;
#line 189 "../lib/Widgets/AboutWindow.vala"
			_tmp11_ = developers_text;
#line 189 "../lib/Widgets/AboutWindow.vala"
			_tmp12_ = g_strdup_printf (_ ("Copyright © %s"), _tmp11_);
#line 189 "../lib/Widgets/AboutWindow.vala"
			_tmp13_ = _tmp12_;
#line 189 "../lib/Widgets/AboutWindow.vala"
			gtk_label_set_text (_tmp10_, _tmp13_);
#line 189 "../lib/Widgets/AboutWindow.vala"
			_g_free0 (_tmp13_);
#line 190 "../lib/Widgets/AboutWindow.vala"
			_tmp14_ = self->priv->copyright_label;
#line 190 "../lib/Widgets/AboutWindow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp14_, TRUE);
#line 1139 "AboutWindow.c"
		} else {
			GtkLabel* _tmp15_;
			GtkLabel* _tmp16_;
#line 192 "../lib/Widgets/AboutWindow.vala"
			_tmp15_ = self->priv->copyright_label;
#line 192 "../lib/Widgets/AboutWindow.vala"
			gtk_label_set_text (_tmp15_, "");
#line 193 "../lib/Widgets/AboutWindow.vala"
			_tmp16_ = self->priv->copyright_label;
#line 193 "../lib/Widgets/AboutWindow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp16_, FALSE);
#line 1151 "AboutWindow.c"
		}
	}
#line 182 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (developers_text);
#line 182 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp0_);
#line 1158 "AboutWindow.c"
}

gchar**
he_about_window_get_developer_names (HeAboutWindow* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 202 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 202 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 202 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 202 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 202 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 202 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 1184 "AboutWindow.c"
	}
#line 202 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 202 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1190 "AboutWindow.c"
}

static gchar**
_vala_array_dup14 (gchar** self,
                   gssize length)
{
#line 204 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 1199 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 204 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 204 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 1206 "AboutWindow.c"
			gchar* _tmp0_;
#line 204 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 204 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 1212 "AboutWindow.c"
		}
#line 204 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 1216 "AboutWindow.c"
	}
#line 204 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 1220 "AboutWindow.c"
}

void
he_about_window_set_developer_names (HeAboutWindow* self,
                                     gchar** value,
                                     gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
#line 203 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 204 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup14 (value, value_length1) : value;
#line 204 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 204 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 204 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp0_;
#line 204 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = _tmp0__length1;
#line 204 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 205 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_copyright_year (self);
#line 205 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 205 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, _tmp2_, value, (gint) value_length1);
#line 203 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY]);
#line 1254 "AboutWindow.c"
}

gint
he_about_window_get_copyright_year (HeAboutWindow* self)
{
	gint result;
#line 214 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_copyright_year;
#line 214 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1267 "AboutWindow.c"
}

void
he_about_window_set_copyright_year (HeAboutWindow* self,
                                    gint value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 215 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 216 "../lib/Widgets/AboutWindow.vala"
	self->priv->_copyright_year = value;
#line 217 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 217 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 217 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, value, _tmp0_, (gint) _tmp0__length1);
#line 215 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY]);
#line 1288 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_id (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 228 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_app_id;
#line 228 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 228 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1304 "AboutWindow.c"
}

void
he_about_window_set_app_id (HeAboutWindow* self,
                            const gchar* value)
{
	gchar* old_value;
#line 228 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 228 "../lib/Widgets/AboutWindow.vala"
	old_value = he_about_window_get_app_id (self);
#line 228 "../lib/Widgets/AboutWindow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1318 "AboutWindow.c"
		gchar* _tmp0_;
#line 228 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = g_strdup (value);
#line 228 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (self->priv->_app_id);
#line 228 "../lib/Widgets/AboutWindow.vala"
		self->priv->_app_id = _tmp0_;
#line 228 "../lib/Widgets/AboutWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY]);
#line 1328 "AboutWindow.c"
	}
}

const gchar*
he_about_window_get_translate_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 233 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_translate_url;
#line 233 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 233 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1345 "AboutWindow.c"
}

void
he_about_window_set_translate_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 234 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 235 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 235 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 235 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translate_url = _tmp0_;
#line 236 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1363 "AboutWindow.c"
		HeTextButton* _tmp1_;
#line 237 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->translate_app_button;
#line 237 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1369 "AboutWindow.c"
	} else {
		HeTextButton* _tmp2_;
#line 239 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->translate_app_button;
#line 239 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1376 "AboutWindow.c"
	}
#line 234 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY]);
#line 1380 "AboutWindow.c"
}

const gchar*
he_about_window_get_issue_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 247 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_issue_url;
#line 247 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 247 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1396 "AboutWindow.c"
}

void
he_about_window_set_issue_url (HeAboutWindow* self,
                               const gchar* value)
{
	gchar* _tmp0_;
#line 248 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 249 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 249 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 249 "../lib/Widgets/AboutWindow.vala"
	self->priv->_issue_url = _tmp0_;
#line 250 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1414 "AboutWindow.c"
		HeTintButton* _tmp1_;
#line 251 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->report_button;
#line 251 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1420 "AboutWindow.c"
	} else {
		HeTintButton* _tmp2_;
#line 253 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->report_button;
#line 253 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1427 "AboutWindow.c"
	}
#line 248 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY]);
#line 1431 "AboutWindow.c"
}

const gchar*
he_about_window_get_more_info_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 261 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 261 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_more_info_url;
#line 261 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 261 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1447 "AboutWindow.c"
}

void
he_about_window_set_more_info_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 262 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 263 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 263 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 263 "../lib/Widgets/AboutWindow.vala"
	self->priv->_more_info_url = _tmp0_;
#line 264 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1465 "AboutWindow.c"
		HeFillButton* _tmp1_;
#line 265 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->more_info_button;
#line 265 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1471 "AboutWindow.c"
	} else {
		HeFillButton* _tmp2_;
#line 267 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->more_info_button;
#line 267 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1478 "AboutWindow.c"
	}
#line 262 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY]);
#line 1482 "AboutWindow.c"
}

/**
  * Creates a new AboutWindow.
  * @param parent The parent window.
  * @param app_name Your application's name.
  * @param app_id Your application's reverse-domain name.
  * @param version Your application's version.
  * @param icon Your application's icon.
  * @param translate_url A URL where contributors can help translate the application.
  * @param issue_url A URL where users can report a problem with the application.
  * @param more_info_url A URL where users can get more information about the application.
  * @param translators Your application's translators.
  * @param developers Your application's developers.
  * @param copyright_year Your application's copyright year.
  * @param license Your application's license.
  * @param color The color of the AboutWindow.
  *
  * @since 1.0
  */
HeAboutWindow*
he_about_window_construct (GType object_type,
                           GtkWindow* parent,
                           const gchar* app_name,
                           const gchar* app_id,
                           const gchar* version,
                           const gchar* icon,
                           const gchar* translate_url,
                           const gchar* issue_url,
                           const gchar* more_info_url,
                           gchar** translators,
                           gint translators_length1,
                           gchar** developers,
                           gint developers_length1,
                           gint copyright_year,
                           HeAboutWindowLicenses license,
                           HeColors color)
{
	HeAboutWindow * self = NULL;
#line 359 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 359 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 359 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_id != NULL, NULL);
#line 359 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (version != NULL, NULL);
#line 359 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 359 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) he_window_construct (object_type);
#line 374 "../lib/Widgets/AboutWindow.vala"
	he_window_set_parent ((HeWindow*) self, parent);
#line 375 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_name (self, app_name);
#line 376 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_id (self, app_id);
#line 377 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_version (self, version);
#line 378 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_icon (self, icon);
#line 379 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translate_url (self, translate_url);
#line 380 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_issue_url (self, issue_url);
#line 381 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_more_info_url (self, more_info_url);
#line 382 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translator_names (self, translators, translators_length1);
#line 383 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_developer_names (self, developers, developers_length1);
#line 384 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_copyright_year (self, copyright_year);
#line 385 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_license (self, license);
#line 386 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_color (self, color);
#line 359 "../lib/Widgets/AboutWindow.vala"
	return self;
#line 1562 "AboutWindow.c"
}

HeAboutWindow*
he_about_window_new (GtkWindow* parent,
                     const gchar* app_name,
                     const gchar* app_id,
                     const gchar* version,
                     const gchar* icon,
                     const gchar* translate_url,
                     const gchar* issue_url,
                     const gchar* more_info_url,
                     gchar** translators,
                     gint translators_length1,
                     gchar** developers,
                     gint developers_length1,
                     gint copyright_year,
                     HeAboutWindowLicenses license,
                     HeColors color)
{
#line 359 "../lib/Widgets/AboutWindow.vala"
	return he_about_window_construct (HE_TYPE_ABOUT_WINDOW, parent, app_name, app_id, version, icon, translate_url, issue_url, more_info_url, translators, translators_length1, developers, developers_length1, copyright_year, license, color);
#line 1584 "AboutWindow.c"
}

static void
_he_about_window___lambda8_ (HeAboutWindow* self)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 323 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_window_get_parent ((HeWindow*) self);
#line 323 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 323 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = he_about_window_get_translate_url (self);
#line 323 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _tmp2_;
#line 323 "../lib/Widgets/AboutWindow.vala"
	gtk_show_uri (_tmp1_, _tmp3_, (guint32) GDK_CURRENT_TIME);
#line 1604 "AboutWindow.c"
}

static void
__he_about_window___lambda8__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 322 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda8_ ((HeAboutWindow*) self);
#line 1613 "AboutWindow.c"
}

static void
_he_about_window___lambda9_ (HeAboutWindow* self)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 327 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_window_get_parent ((HeWindow*) self);
#line 327 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 327 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = he_about_window_get_issue_url (self);
#line 327 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _tmp2_;
#line 327 "../lib/Widgets/AboutWindow.vala"
	gtk_show_uri (_tmp1_, _tmp3_, (guint32) GDK_CURRENT_TIME);
#line 1633 "AboutWindow.c"
}

static void
__he_about_window___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 326 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda9_ ((HeAboutWindow*) self);
#line 1642 "AboutWindow.c"
}

static void
_he_about_window___lambda10_ (HeAboutWindow* self)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_window_get_parent ((HeWindow*) self);
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = he_about_window_get_more_info_url (self);
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _tmp2_;
#line 331 "../lib/Widgets/AboutWindow.vala"
	gtk_show_uri (_tmp1_, _tmp3_, (guint32) GDK_CURRENT_TIME);
#line 1662 "AboutWindow.c"
}

static void
__he_about_window___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 330 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda10_ ((HeAboutWindow*) self);
#line 1671 "AboutWindow.c"
}

static GObject *
he_about_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAboutWindow * self;
	HeAppBar* _tmp0_;
	HeAppBar* _tmp1_;
	HeAppBar* _tmp2_;
	GtkOverlay* _tmp3_;
	HeAppBar* _tmp4_;
	GtkOverlay* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkImage* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkImage* _tmp15_;
	GtkBox* _tmp16_;
	GtkImage* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	HeModifierBadge* _tmp24_;
	HeModifierBadge* _tmp25_;
	GtkLabel* _tmp26_;
	GtkBox* _tmp27_;
	GtkLabel* _tmp28_;
	GtkBox* _tmp29_;
	HeModifierBadge* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkBox* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkBox* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkBox* _tmp41_;
	GtkLabel* _tmp42_;
	GtkBox* _tmp43_;
	GtkBox* _tmp44_;
	GtkBox* _tmp45_;
	HeTextButton* _tmp46_;
	GtkBox* _tmp47_;
	HeTintButton* _tmp48_;
	GtkBox* _tmp49_;
	HeFillButton* _tmp50_;
	HeTextButton* _tmp51_;
	HeTintButton* _tmp52_;
	HeFillButton* _tmp53_;
	GtkWindowHandle* window_handle = NULL;
	GtkWindowHandle* _tmp54_;
	GtkWindowHandle* _tmp55_;
	GtkOverlay* _tmp56_;
	GtkWindowHandle* _tmp57_;
#line 272 "../lib/Widgets/AboutWindow.vala"
	parent_class = G_OBJECT_CLASS (he_about_window_parent_class);
#line 272 "../lib/Widgets/AboutWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 272 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 273 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 274 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 276 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->app_bar;
#line 276 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 277 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->app_bar;
#line 277 "../lib/Widgets/AboutWindow.vala"
	he_app_bar_set_show_back (_tmp1_, FALSE);
#line 278 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->app_bar;
#line 278 "../lib/Widgets/AboutWindow.vala"
	he_app_bar_set_decoration_layout (_tmp2_, ":close");
#line 280 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = self->priv->window_overlay;
#line 280 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = self->priv->app_bar;
#line 280 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_add_overlay (_tmp3_, (GtkWidget*) _tmp4_);
#line 281 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = self->priv->window_overlay;
#line 281 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = self->priv->about_box;
#line 281 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_set_child (_tmp5_, (GtkWidget*) _tmp6_);
#line 283 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = self->priv->about_box;
#line 283 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp7_, "dialog-content");
#line 284 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = self->priv->about_box;
#line 284 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = self->priv->content_box;
#line 284 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
#line 285 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = self->priv->about_box;
#line 285 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = self->priv->button_box;
#line 285 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 287 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = self->priv->icon_image;
#line 287 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
#line 288 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = self->priv->icon_image;
#line 288 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_pixel_size (_tmp13_, 128);
#line 289 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = self->priv->icon_image;
#line 289 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp14_, 18);
#line 290 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = self->priv->icon_image;
#line 290 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, "icon-dropshadow");
#line 292 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = self->priv->content_box;
#line 292 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = self->priv->icon_image;
#line 292 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
#line 293 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = self->priv->content_box;
#line 293 "../lib/Widgets/AboutWindow.vala"
	_tmp19_ = self->priv->info_box;
#line 293 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
#line 295 "../lib/Widgets/AboutWindow.vala"
	_tmp20_ = self->priv->info_box;
#line 295 "../lib/Widgets/AboutWindow.vala"
	_tmp21_ = self->priv->title_box;
#line 295 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 296 "../lib/Widgets/AboutWindow.vala"
	_tmp22_ = self->priv->info_box;
#line 296 "../lib/Widgets/AboutWindow.vala"
	_tmp23_ = self->priv->text_box;
#line 296 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 298 "../lib/Widgets/AboutWindow.vala"
	_tmp24_ = self->priv->version_badge;
#line 298 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_tinted (_tmp24_, TRUE);
#line 299 "../lib/Widgets/AboutWindow.vala"
	_tmp25_ = self->priv->version_badge;
#line 299 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, 18);
#line 300 "../lib/Widgets/AboutWindow.vala"
	_tmp26_ = self->priv->title_label;
#line 300 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp26_, "display");
#line 301 "../lib/Widgets/AboutWindow.vala"
	_tmp27_ = self->priv->title_box;
#line 301 "../lib/Widgets/AboutWindow.vala"
	_tmp28_ = self->priv->title_label;
#line 301 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
#line 302 "../lib/Widgets/AboutWindow.vala"
	_tmp29_ = self->priv->title_box;
#line 302 "../lib/Widgets/AboutWindow.vala"
	_tmp30_ = self->priv->version_badge;
#line 302 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
#line 304 "../lib/Widgets/AboutWindow.vala"
	_tmp31_ = self->priv->copyright_label;
#line 304 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp31_, (gfloat) 0);
#line 305 "../lib/Widgets/AboutWindow.vala"
	_tmp32_ = self->priv->copyright_label;
#line 305 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp32_, FALSE);
#line 306 "../lib/Widgets/AboutWindow.vala"
	_tmp33_ = self->priv->text_box;
#line 306 "../lib/Widgets/AboutWindow.vala"
	_tmp34_ = self->priv->copyright_label;
#line 306 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 308 "../lib/Widgets/AboutWindow.vala"
	_tmp35_ = self->priv->translators_label;
#line 308 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp35_, (gfloat) 0);
#line 309 "../lib/Widgets/AboutWindow.vala"
	_tmp36_ = self->priv->translators_label;
#line 309 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp36_, FALSE);
#line 310 "../lib/Widgets/AboutWindow.vala"
	_tmp37_ = self->priv->text_box;
#line 310 "../lib/Widgets/AboutWindow.vala"
	_tmp38_ = self->priv->translators_label;
#line 310 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 312 "../lib/Widgets/AboutWindow.vala"
	_tmp39_ = self->priv->license_label;
#line 312 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp39_, (gfloat) 0);
#line 313 "../lib/Widgets/AboutWindow.vala"
	_tmp40_ = self->priv->license_label;
#line 313 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, TRUE);
#line 314 "../lib/Widgets/AboutWindow.vala"
	_tmp41_ = self->priv->text_box;
#line 314 "../lib/Widgets/AboutWindow.vala"
	_tmp42_ = self->priv->license_label;
#line 314 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp41_, (GtkWidget*) _tmp42_);
#line 316 "../lib/Widgets/AboutWindow.vala"
	_tmp43_ = self->priv->button_box;
#line 316 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp43_, GTK_ALIGN_CENTER);
#line 317 "../lib/Widgets/AboutWindow.vala"
	_tmp44_ = self->priv->button_box;
#line 317 "../lib/Widgets/AboutWindow.vala"
	gtk_box_set_homogeneous (_tmp44_, TRUE);
#line 318 "../lib/Widgets/AboutWindow.vala"
	_tmp45_ = self->priv->button_box;
#line 318 "../lib/Widgets/AboutWindow.vala"
	_tmp46_ = self->priv->translate_app_button;
#line 318 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp45_, (GtkWidget*) _tmp46_);
#line 319 "../lib/Widgets/AboutWindow.vala"
	_tmp47_ = self->priv->button_box;
#line 319 "../lib/Widgets/AboutWindow.vala"
	_tmp48_ = self->priv->report_button;
#line 319 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp47_, (GtkWidget*) _tmp48_);
#line 320 "../lib/Widgets/AboutWindow.vala"
	_tmp49_ = self->priv->button_box;
#line 320 "../lib/Widgets/AboutWindow.vala"
	_tmp50_ = self->priv->more_info_button;
#line 320 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp49_, (GtkWidget*) _tmp50_);
#line 322 "../lib/Widgets/AboutWindow.vala"
	_tmp51_ = self->priv->translate_app_button;
#line 322 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp51_, "clicked", (GCallback) __he_about_window___lambda8__gtk_button_clicked, self, 0);
#line 326 "../lib/Widgets/AboutWindow.vala"
	_tmp52_ = self->priv->report_button;
#line 326 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp52_, "clicked", (GCallback) __he_about_window___lambda9__gtk_button_clicked, self, 0);
#line 330 "../lib/Widgets/AboutWindow.vala"
	_tmp53_ = self->priv->more_info_button;
#line 330 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp53_, "clicked", (GCallback) __he_about_window___lambda10__gtk_button_clicked, self, 0);
#line 334 "../lib/Widgets/AboutWindow.vala"
	_tmp54_ = (GtkWindowHandle*) gtk_window_handle_new ();
#line 334 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp54_);
#line 334 "../lib/Widgets/AboutWindow.vala"
	window_handle = _tmp54_;
#line 335 "../lib/Widgets/AboutWindow.vala"
	_tmp55_ = window_handle;
#line 335 "../lib/Widgets/AboutWindow.vala"
	_tmp56_ = self->priv->window_overlay;
#line 335 "../lib/Widgets/AboutWindow.vala"
	gtk_window_handle_set_child (_tmp55_, (GtkWidget*) _tmp56_);
#line 337 "../lib/Widgets/AboutWindow.vala"
	_tmp57_ = window_handle;
#line 337 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp57_);
#line 338 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "dialog-content");
#line 272 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (window_handle);
#line 272 "../lib/Widgets/AboutWindow.vala"
	return obj;
#line 1957 "AboutWindow.c"
}

static void
he_about_window_class_init (HeAboutWindowClass * klass,
                            gpointer klass_data)
{
#line 23 "../lib/Widgets/AboutWindow.vala"
	he_about_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_type_class_adjust_private_offset (klass, &HeAboutWindow_private_offset);
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_about_window_get_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_about_window_set_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = he_about_window_constructor;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = he_about_window_finalize;
#line 1976 "AboutWindow.c"
	/**
	  * The theme color of the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COLOR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1982 "AboutWindow.c"
	/**
	  * The license shown in the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_LICENSE_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY] = g_param_spec_enum ("license", "license", "license", HE_ABOUT_WINDOW_TYPE_LICENSES, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1988 "AboutWindow.c"
	/**
	  * The version shown in the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_VERSION_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1994 "AboutWindow.c"
	/**
	  * The name of the application shown in the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_NAME_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2000 "AboutWindow.c"
	/**
	  *  The icon shown in the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ICON_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2006 "AboutWindow.c"
	/**
	  * The translators shown in the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY] = g_param_spec_boxed ("translator-names", "translator-names", "translator-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2012 "AboutWindow.c"
	/**
	  * The developers shown in the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY] = g_param_spec_boxed ("developer-names", "developer-names", "developer-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2018 "AboutWindow.c"
	/**
	  * The copyright year shown in the AboutWindow.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY] = g_param_spec_int ("copyright-year", "copyright-year", "copyright-year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2024 "AboutWindow.c"
	/**
	  * Your application's reverse-domain name.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_ID_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2030 "AboutWindow.c"
	/**
	  * A URL where contributors can help translate the application.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY] = g_param_spec_string ("translate-url", "translate-url", "translate-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2036 "AboutWindow.c"
	/**
	  * A URL where users can report a problem with the application.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY] = g_param_spec_string ("issue-url", "issue-url", "issue-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2042 "AboutWindow.c"
	/**
	  * A URL where users can get more information about the application.
	  */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY] = g_param_spec_string ("more-info-url", "more-info-url", "more-info-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2048 "AboutWindow.c"
}

static void
he_about_window_instance_init (HeAboutWindow * self,
                               gpointer klass)
{
	HeAppBar* _tmp0_;
	GtkOverlay* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkImage* _tmp12_;
	HeTextButton* _tmp13_;
	HeTintButton* _tmp14_;
	HeFillButton* _tmp15_;
	HeModifierBadge* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gchar* _tmp19_;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self->priv = he_about_window_get_instance_private (self);
#line 24 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_app_bar_new ();
#line 24 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 24 "../lib/Widgets/AboutWindow.vala"
	self->priv->app_bar = _tmp0_;
#line 26 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 26 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 26 "../lib/Widgets/AboutWindow.vala"
	self->priv->window_overlay = _tmp1_;
#line 28 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 30);
#line 28 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 28 "../lib/Widgets/AboutWindow.vala"
	self->priv->about_box = _tmp2_;
#line 29 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
#line 29 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 29 "../lib/Widgets/AboutWindow.vala"
	self->priv->content_box = _tmp3_;
#line 30 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
#line 30 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 30 "../lib/Widgets/AboutWindow.vala"
	self->priv->button_box = _tmp4_;
#line 31 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 31 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 31 "../lib/Widgets/AboutWindow.vala"
	self->priv->info_box = _tmp5_;
#line 32 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 32 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 32 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_box = _tmp6_;
#line 33 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 33 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 33 "../lib/Widgets/AboutWindow.vala"
	self->priv->text_box = _tmp7_;
#line 35 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (NULL);
#line 35 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp8_);
#line 35 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_label = _tmp8_;
#line 36 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 36 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 36 "../lib/Widgets/AboutWindow.vala"
	self->priv->copyright_label = _tmp9_;
#line 37 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
#line 37 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp10_);
#line 37 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_label = _tmp10_;
#line 38 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (NULL);
#line 38 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 38 "../lib/Widgets/AboutWindow.vala"
	self->priv->license_label = _tmp11_;
#line 40 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = (GtkImage*) gtk_image_new ();
#line 40 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 40 "../lib/Widgets/AboutWindow.vala"
	self->priv->icon_image = _tmp12_;
#line 42 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = he_text_button_new (_ ("Translate App"));
#line 42 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 42 "../lib/Widgets/AboutWindow.vala"
	self->priv->translate_app_button = _tmp13_;
#line 43 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = he_tint_button_new (_ ("Report a Problem"));
#line 43 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp14_);
#line 43 "../lib/Widgets/AboutWindow.vala"
	self->priv->report_button = _tmp14_;
#line 44 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = he_fill_button_new (_ ("More Info…"));
#line 44 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 44 "../lib/Widgets/AboutWindow.vala"
	self->priv->more_info_button = _tmp15_;
#line 46 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = he_modifier_badge_new ("");
#line 46 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp16_);
#line 46 "../lib/Widgets/AboutWindow.vala"
	self->priv->version_badge = _tmp16_;
#line 109 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = HE_COLORS_PURPLE;
#line 128 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = HE_ABOUT_WINDOW_LICENSES_GPLV3;
#line 164 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = g_new0 (gchar*, 0 + 1);
#line 164 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp17_;
#line 164 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = 0;
#line 164 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 197 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 197 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp18_;
#line 197 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = 0;
#line 197 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 228 "../lib/Widgets/AboutWindow.vala"
	_tmp19_ = g_strdup ("");
#line 228 "../lib/Widgets/AboutWindow.vala"
	self->priv->_app_id = _tmp19_;
#line 2203 "AboutWindow.c"
}

static void
he_about_window_finalize (GObject * obj)
{
	HeAboutWindow * self;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 24 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->app_bar);
#line 26 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->window_overlay);
#line 28 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->about_box);
#line 29 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->content_box);
#line 30 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->button_box);
#line 31 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->info_box);
#line 32 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_box);
#line 33 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->text_box);
#line 35 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_label);
#line 36 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->copyright_label);
#line 37 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translators_label);
#line 38 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->license_label);
#line 40 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->icon_image);
#line 42 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translate_app_button);
#line 43 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->report_button);
#line 44 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->more_info_button);
#line 46 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->version_badge);
#line 164 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 197 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 221 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 222 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 223 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 228 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_app_id);
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (he_about_window_parent_class)->finalize (obj);
#line 2260 "AboutWindow.c"
}

/**
* An AboutWindow is a window that displays information about the application.
*/
static GType
he_about_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAboutWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_about_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAboutWindow), 0, (GInstanceInitFunc) he_about_window_instance_init, NULL };
	GType he_about_window_type_id;
	he_about_window_type_id = g_type_register_static (HE_TYPE_WINDOW, "HeAboutWindow", &g_define_type_info, 0);
	HeAboutWindow_private_offset = g_type_add_instance_private (he_about_window_type_id, sizeof (HeAboutWindowPrivate));
	return he_about_window_type_id;
}

GType
he_about_window_get_type (void)
{
	static volatile gsize he_about_window_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_type_id__once)) {
		GType he_about_window_type_id;
		he_about_window_type_id = he_about_window_get_type_once ();
		g_once_init_leave (&he_about_window_type_id__once, he_about_window_type_id);
	}
	return he_about_window_type_id__once;
}

static void
_vala_he_about_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_color (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_license (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_version (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_name (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_icon (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 2330 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_translator_names (self, &length));
#line 2335 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 2341 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_developer_names (self, &length));
#line 2346 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_int (value, he_about_window_get_copyright_year (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_id (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_translate_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_issue_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_more_info_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2380 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2386 "AboutWindow.c"
	}
}

static void
_vala_he_about_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_color (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_license (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_version (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_name (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_icon (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 2432 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_translator_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2439 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 2445 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_developer_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2452 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_copyright_year (self, g_value_get_int (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_id (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_translate_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_issue_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_more_info_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2486 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2492 "AboutWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

