/* SettingsWindow.c generated by valac 0.56.15, the Vala compiler
 * generated from SettingsWindow.vala, do not modify */

/*
* Copyright (c) 2022-2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_SETTINGS_WINDOW_0_PROPERTY,
	HE_SETTINGS_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_settings_window_properties[HE_SETTINGS_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeSettingsWindowPrivate {
	GtkBox* box;
	GtkStack* stack;
	HeAppBar* appbar;
	HeViewSwitcher* switcher;
	GtkLabel* viewtitle;
};

static gint HeSettingsWindow_private_offset;
static gpointer he_settings_window_parent_class = NULL;
static GtkBuildableIface * he_settings_window_gtk_buildable_parent_iface = NULL;

static void he_settings_window_real_add_child (GtkBuildable* base,
                                        GtkBuilder* builder,
                                        GObject* child,
                                        const gchar* type);
static void he_settings_window_on_pages_changed (HeSettingsWindow* self,
                                          guint position,
                                          guint removed,
                                          guint added);
static GObject * he_settings_window_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _he_settings_window_on_pages_changed_g_list_model_items_changed (GListModel* _sender,
                                                                      guint position,
                                                                      guint removed,
                                                                      guint added,
                                                                      gpointer self);
static void he_settings_window_finalize (GObject * obj);
static GType he_settings_window_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_settings_window_get_instance_private (HeSettingsWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeSettingsWindow_private_offset);
}

/**
     * Add SettingsList or SettingsPage children to this window
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 103 "SettingsWindow.c"
}

static void
he_settings_window_real_add_child (GtkBuildable* base,
                                   GtkBuilder* builder,
                                   GObject* child,
                                   const gchar* type)
{
	HeSettingsWindow * self;
#line 33 "../lib/Widgets/SettingsWindow.vala"
	self = (HeSettingsWindow*) base;
#line 33 "../lib/Widgets/SettingsWindow.vala"
	g_return_if_fail (builder != NULL);
#line 33 "../lib/Widgets/SettingsWindow.vala"
	g_return_if_fail (child != NULL);
#line 34 "../lib/Widgets/SettingsWindow.vala"
	if (G_TYPE_FROM_INSTANCE (child) == HE_TYPE_SETTINGS_LIST) {
#line 35 "../lib/Widgets/SettingsWindow.vala"
		he_settings_window_add_list (self, HE_IS_SETTINGS_LIST (child) ? ((HeSettingsList*) child) : NULL);
#line 123 "SettingsWindow.c"
	} else {
#line 36 "../lib/Widgets/SettingsWindow.vala"
		if (G_TYPE_FROM_INSTANCE (child) == HE_TYPE_SETTINGS_PAGE) {
#line 37 "../lib/Widgets/SettingsWindow.vala"
			he_settings_window_add_page (self, HE_IS_SETTINGS_PAGE (child) ? ((HeSettingsPage*) child) : NULL);
#line 129 "SettingsWindow.c"
		} else {
			gchar* _tmp0_;
			gchar* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 39 "../lib/Widgets/SettingsWindow.vala"
			_tmp0_ = g_strdup_printf ("%lu", (gulong) G_TYPE_FROM_INSTANCE (child));
#line 39 "../lib/Widgets/SettingsWindow.vala"
			_tmp1_ = _tmp0_;
#line 39 "../lib/Widgets/SettingsWindow.vala"
			_tmp2_ = string_to_string (_tmp1_);
#line 39 "../lib/Widgets/SettingsWindow.vala"
			_tmp3_ = g_strconcat ("Child of type ", _tmp2_, " is not supported.", NULL);
#line 39 "../lib/Widgets/SettingsWindow.vala"
			_tmp4_ = _tmp3_;
#line 39 "../lib/Widgets/SettingsWindow.vala"
			g_warning ("SettingsWindow.vala:39: %s", _tmp4_);
#line 39 "../lib/Widgets/SettingsWindow.vala"
			_g_free0 (_tmp4_);
#line 39 "../lib/Widgets/SettingsWindow.vala"
			_g_free0 (_tmp1_);
#line 40 "../lib/Widgets/SettingsWindow.vala"
			G_TYPE_INSTANCE_GET_INTERFACE ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_WINDOW, HeWindow), gtk_buildable_get_type (), GtkBuildableIface)->add_child ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_WINDOW, HeWindow), builder, child, type);
#line 154 "SettingsWindow.c"
		}
	}
}

/**
     * Add a Settings Page to this window
     */
void
he_settings_window_add_page (HeSettingsWindow* self,
                             HeSettingsPage* page)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkStack* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
#line 47 "../lib/Widgets/SettingsWindow.vala"
	g_return_if_fail (self != NULL);
#line 47 "../lib/Widgets/SettingsWindow.vala"
	g_return_if_fail (page != NULL);
#line 48 "../lib/Widgets/SettingsWindow.vala"
	_tmp0_ = he_settings_page_get_title (page);
#line 48 "../lib/Widgets/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 48 "../lib/Widgets/SettingsWindow.vala"
	if (_tmp1_ == NULL) {
#line 183 "SettingsWindow.c"
		GtkStack* _tmp2_;
		GtkSelectionModel* _tmp3_;
		GtkSelectionModel* _tmp4_;
		GtkSelectionModel* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp2_ = self->priv->stack;
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp3_ = gtk_stack_get_pages (_tmp2_);
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp4_ = _tmp3_;
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp5_ = _tmp4_;
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp6_ = g_strdup_printf ("%u", g_list_model_get_n_items ((GListModel*) _tmp5_) + 1);
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp7_ = _tmp6_;
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp8_ = g_strconcat ("Page ", _tmp7_, NULL);
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_tmp9_ = _tmp8_;
#line 49 "../lib/Widgets/SettingsWindow.vala"
		he_settings_page_set_title (page, _tmp9_);
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_g_free0 (_tmp9_);
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_g_free0 (_tmp7_);
#line 49 "../lib/Widgets/SettingsWindow.vala"
		_g_object_unref0 (_tmp5_);
#line 216 "SettingsWindow.c"
	}
#line 51 "../lib/Widgets/SettingsWindow.vala"
	_tmp10_ = self->priv->stack;
#line 51 "../lib/Widgets/SettingsWindow.vala"
	_tmp11_ = he_settings_page_get_title (page);
#line 51 "../lib/Widgets/SettingsWindow.vala"
	_tmp12_ = _tmp11_;
#line 51 "../lib/Widgets/SettingsWindow.vala"
	_tmp13_ = he_settings_page_get_title (page);
#line 51 "../lib/Widgets/SettingsWindow.vala"
	_tmp14_ = _tmp13_;
#line 51 "../lib/Widgets/SettingsWindow.vala"
	gtk_stack_add_titled (_tmp10_, G_TYPE_CHECK_INSTANCE_TYPE (page, gtk_widget_get_type ()) ? ((GtkWidget*) page) : NULL, _tmp12_, _tmp14_);
#line 230 "SettingsWindow.c"
}

/**
     * Add a Settings List to this window
     */
void
he_settings_window_add_list (HeSettingsWindow* self,
                             HeSettingsList* list)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	HeSettingsPage* page = NULL;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	HeSettingsPage* _tmp15_;
#line 57 "../lib/Widgets/SettingsWindow.vala"
	g_return_if_fail (self != NULL);
#line 57 "../lib/Widgets/SettingsWindow.vala"
	g_return_if_fail (list != NULL);
#line 58 "../lib/Widgets/SettingsWindow.vala"
	_tmp1_ = he_settings_list_get_title (list);
#line 58 "../lib/Widgets/SettingsWindow.vala"
	_tmp2_ = _tmp1_;
#line 58 "../lib/Widgets/SettingsWindow.vala"
	if (_tmp2_ == NULL) {
#line 58 "../lib/Widgets/SettingsWindow.vala"
		_tmp0_ = TRUE;
#line 259 "SettingsWindow.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 58 "../lib/Widgets/SettingsWindow.vala"
		_tmp3_ = he_settings_list_get_title (list);
#line 58 "../lib/Widgets/SettingsWindow.vala"
		_tmp4_ = _tmp3_;
#line 58 "../lib/Widgets/SettingsWindow.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "") == 0;
#line 269 "SettingsWindow.c"
	}
#line 58 "../lib/Widgets/SettingsWindow.vala"
	if (_tmp0_) {
#line 273 "SettingsWindow.c"
		GtkStack* _tmp5_;
		GtkSelectionModel* _tmp6_;
		GtkSelectionModel* _tmp7_;
		GtkSelectionModel* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp5_ = self->priv->stack;
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp6_ = gtk_stack_get_pages (_tmp5_);
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp7_ = _tmp6_;
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp8_ = _tmp7_;
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp9_ = g_strdup_printf ("%u", g_list_model_get_n_items ((GListModel*) _tmp8_) + 1);
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp10_ = _tmp9_;
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp11_ = g_strconcat ("Page ", _tmp10_, NULL);
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_tmp12_ = _tmp11_;
#line 59 "../lib/Widgets/SettingsWindow.vala"
		he_settings_list_set_title (list, _tmp12_);
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_g_free0 (_tmp12_);
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_g_free0 (_tmp10_);
#line 59 "../lib/Widgets/SettingsWindow.vala"
		_g_object_unref0 (_tmp8_);
#line 306 "SettingsWindow.c"
	}
#line 61 "../lib/Widgets/SettingsWindow.vala"
	_tmp13_ = he_settings_list_get_title (list);
#line 61 "../lib/Widgets/SettingsWindow.vala"
	_tmp14_ = _tmp13_;
#line 61 "../lib/Widgets/SettingsWindow.vala"
	_tmp15_ = he_settings_page_new (_tmp14_);
#line 61 "../lib/Widgets/SettingsWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 61 "../lib/Widgets/SettingsWindow.vala"
	page = _tmp15_;
#line 62 "../lib/Widgets/SettingsWindow.vala"
	he_settings_page_add_list (page, list);
#line 63 "../lib/Widgets/SettingsWindow.vala"
	he_settings_window_add_page (self, page);
#line 57 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (page);
#line 324 "SettingsWindow.c"
}

/**
     * Create a new Settings Window.
     *
     * @since 1.0
     */
HeSettingsWindow*
he_settings_window_construct (GType object_type,
                              GtkWindow* parent)
{
	HeSettingsWindow * self = NULL;
#line 71 "../lib/Widgets/SettingsWindow.vala"
	self = (HeSettingsWindow*) he_window_construct (object_type);
#line 72 "../lib/Widgets/SettingsWindow.vala"
	he_window_set_parent ((HeWindow*) self, parent);
#line 71 "../lib/Widgets/SettingsWindow.vala"
	return self;
#line 343 "SettingsWindow.c"
}

HeSettingsWindow*
he_settings_window_new (GtkWindow* parent)
{
#line 71 "../lib/Widgets/SettingsWindow.vala"
	return he_settings_window_construct (HE_TYPE_SETTINGS_WINDOW, parent);
#line 351 "SettingsWindow.c"
}

static void
he_settings_window_on_pages_changed (HeSettingsWindow* self,
                                     guint position,
                                     guint removed,
                                     guint added)
{
	GtkStack* _tmp0_;
	GtkSelectionModel* _tmp1_;
	GtkSelectionModel* _tmp2_;
	GtkSelectionModel* _tmp3_;
	gboolean _tmp4_;
#line 115 "../lib/Widgets/SettingsWindow.vala"
	g_return_if_fail (self != NULL);
#line 116 "../lib/Widgets/SettingsWindow.vala"
	_tmp0_ = self->priv->stack;
#line 116 "../lib/Widgets/SettingsWindow.vala"
	_tmp1_ = gtk_stack_get_pages (_tmp0_);
#line 116 "../lib/Widgets/SettingsWindow.vala"
	_tmp2_ = _tmp1_;
#line 116 "../lib/Widgets/SettingsWindow.vala"
	_tmp3_ = _tmp2_;
#line 116 "../lib/Widgets/SettingsWindow.vala"
	_tmp4_ = g_list_model_get_n_items ((GListModel*) _tmp3_) <= ((guint) 1);
#line 116 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 116 "../lib/Widgets/SettingsWindow.vala"
	if (_tmp4_) {
#line 381 "SettingsWindow.c"
		gboolean _tmp5_ = FALSE;
		HeViewSwitcher* _tmp6_;
		GtkWidget* _tmp7_;
#line 117 "../lib/Widgets/SettingsWindow.vala"
		_tmp6_ = self->priv->switcher;
#line 117 "../lib/Widgets/SettingsWindow.vala"
		_tmp7_ = gtk_widget_get_parent ((GtkWidget*) _tmp6_);
#line 117 "../lib/Widgets/SettingsWindow.vala"
		if (_tmp7_ != NULL) {
#line 391 "SettingsWindow.c"
			HeViewSwitcher* _tmp8_;
			GtkWidget* _tmp9_;
			GtkBox* _tmp10_;
#line 117 "../lib/Widgets/SettingsWindow.vala"
			_tmp8_ = self->priv->switcher;
#line 117 "../lib/Widgets/SettingsWindow.vala"
			_tmp9_ = gtk_widget_get_parent ((GtkWidget*) _tmp8_);
#line 117 "../lib/Widgets/SettingsWindow.vala"
			_tmp10_ = self->priv->box;
#line 117 "../lib/Widgets/SettingsWindow.vala"
			_tmp5_ = _tmp9_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget);
#line 403 "SettingsWindow.c"
		} else {
#line 117 "../lib/Widgets/SettingsWindow.vala"
			_tmp5_ = FALSE;
#line 407 "SettingsWindow.c"
		}
#line 117 "../lib/Widgets/SettingsWindow.vala"
		if (_tmp5_) {
#line 411 "SettingsWindow.c"
			GtkBox* _tmp11_;
			HeViewSwitcher* _tmp12_;
			GtkBox* _tmp13_;
			GtkLabel* _tmp14_;
			HeAppBar* _tmp15_;
#line 118 "../lib/Widgets/SettingsWindow.vala"
			_tmp11_ = self->priv->box;
#line 118 "../lib/Widgets/SettingsWindow.vala"
			_tmp12_ = self->priv->switcher;
#line 118 "../lib/Widgets/SettingsWindow.vala"
			gtk_box_remove (_tmp11_, (GtkWidget*) _tmp12_);
#line 119 "../lib/Widgets/SettingsWindow.vala"
			_tmp13_ = self->priv->box;
#line 119 "../lib/Widgets/SettingsWindow.vala"
			_tmp14_ = self->priv->viewtitle;
#line 119 "../lib/Widgets/SettingsWindow.vala"
			_tmp15_ = self->priv->appbar;
#line 119 "../lib/Widgets/SettingsWindow.vala"
			gtk_box_insert_child_after (_tmp13_, (GtkWidget*) _tmp14_, (GtkWidget*) _tmp15_);
#line 431 "SettingsWindow.c"
		} else {
			GtkLabel* _tmp16_;
			GtkWidget* _tmp17_;
#line 120 "../lib/Widgets/SettingsWindow.vala"
			_tmp16_ = self->priv->viewtitle;
#line 120 "../lib/Widgets/SettingsWindow.vala"
			_tmp17_ = gtk_widget_get_parent ((GtkWidget*) _tmp16_);
#line 120 "../lib/Widgets/SettingsWindow.vala"
			if (_tmp17_ == NULL) {
#line 441 "SettingsWindow.c"
				GtkBox* _tmp18_;
				GtkLabel* _tmp19_;
				HeAppBar* _tmp20_;
#line 121 "../lib/Widgets/SettingsWindow.vala"
				_tmp18_ = self->priv->box;
#line 121 "../lib/Widgets/SettingsWindow.vala"
				_tmp19_ = self->priv->viewtitle;
#line 121 "../lib/Widgets/SettingsWindow.vala"
				_tmp20_ = self->priv->appbar;
#line 121 "../lib/Widgets/SettingsWindow.vala"
				gtk_box_insert_child_after (_tmp18_, (GtkWidget*) _tmp19_, (GtkWidget*) _tmp20_);
#line 453 "SettingsWindow.c"
			} else {
#line 124 "../lib/Widgets/SettingsWindow.vala"
				return;
#line 457 "SettingsWindow.c"
			}
		}
	} else {
		gboolean _tmp21_ = FALSE;
		GtkLabel* _tmp22_;
		GtkWidget* _tmp23_;
#line 127 "../lib/Widgets/SettingsWindow.vala"
		_tmp22_ = self->priv->viewtitle;
#line 127 "../lib/Widgets/SettingsWindow.vala"
		_tmp23_ = gtk_widget_get_parent ((GtkWidget*) _tmp22_);
#line 127 "../lib/Widgets/SettingsWindow.vala"
		if (_tmp23_ != NULL) {
#line 470 "SettingsWindow.c"
			GtkLabel* _tmp24_;
			GtkWidget* _tmp25_;
			GtkBox* _tmp26_;
#line 127 "../lib/Widgets/SettingsWindow.vala"
			_tmp24_ = self->priv->viewtitle;
#line 127 "../lib/Widgets/SettingsWindow.vala"
			_tmp25_ = gtk_widget_get_parent ((GtkWidget*) _tmp24_);
#line 127 "../lib/Widgets/SettingsWindow.vala"
			_tmp26_ = self->priv->box;
#line 127 "../lib/Widgets/SettingsWindow.vala"
			_tmp21_ = _tmp25_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_widget_get_type (), GtkWidget);
#line 482 "SettingsWindow.c"
		} else {
#line 127 "../lib/Widgets/SettingsWindow.vala"
			_tmp21_ = FALSE;
#line 486 "SettingsWindow.c"
		}
#line 127 "../lib/Widgets/SettingsWindow.vala"
		if (_tmp21_) {
#line 490 "SettingsWindow.c"
			GtkBox* _tmp27_;
			GtkLabel* _tmp28_;
			GtkBox* _tmp29_;
			HeViewSwitcher* _tmp30_;
			HeAppBar* _tmp31_;
#line 128 "../lib/Widgets/SettingsWindow.vala"
			_tmp27_ = self->priv->box;
#line 128 "../lib/Widgets/SettingsWindow.vala"
			_tmp28_ = self->priv->viewtitle;
#line 128 "../lib/Widgets/SettingsWindow.vala"
			gtk_box_remove (_tmp27_, (GtkWidget*) _tmp28_);
#line 129 "../lib/Widgets/SettingsWindow.vala"
			_tmp29_ = self->priv->box;
#line 129 "../lib/Widgets/SettingsWindow.vala"
			_tmp30_ = self->priv->switcher;
#line 129 "../lib/Widgets/SettingsWindow.vala"
			_tmp31_ = self->priv->appbar;
#line 129 "../lib/Widgets/SettingsWindow.vala"
			gtk_box_insert_child_after (_tmp29_, (GtkWidget*) _tmp30_, (GtkWidget*) _tmp31_);
#line 510 "SettingsWindow.c"
		} else {
			HeViewSwitcher* _tmp32_;
			GtkWidget* _tmp33_;
#line 130 "../lib/Widgets/SettingsWindow.vala"
			_tmp32_ = self->priv->switcher;
#line 130 "../lib/Widgets/SettingsWindow.vala"
			_tmp33_ = gtk_widget_get_parent ((GtkWidget*) _tmp32_);
#line 130 "../lib/Widgets/SettingsWindow.vala"
			if (_tmp33_ == NULL) {
#line 520 "SettingsWindow.c"
				GtkBox* _tmp34_;
				HeViewSwitcher* _tmp35_;
				HeAppBar* _tmp36_;
#line 131 "../lib/Widgets/SettingsWindow.vala"
				_tmp34_ = self->priv->box;
#line 131 "../lib/Widgets/SettingsWindow.vala"
				_tmp35_ = self->priv->switcher;
#line 131 "../lib/Widgets/SettingsWindow.vala"
				_tmp36_ = self->priv->appbar;
#line 131 "../lib/Widgets/SettingsWindow.vala"
				gtk_box_insert_child_after (_tmp34_, (GtkWidget*) _tmp35_, (GtkWidget*) _tmp36_);
#line 532 "SettingsWindow.c"
			} else {
#line 134 "../lib/Widgets/SettingsWindow.vala"
				return;
#line 536 "SettingsWindow.c"
			}
		}
	}
}

static void
_he_settings_window_on_pages_changed_g_list_model_items_changed (GListModel* _sender,
                                                                 guint position,
                                                                 guint removed,
                                                                 guint added,
                                                                 gpointer self)
{
#line 76 "../lib/Widgets/SettingsWindow.vala"
	he_settings_window_on_pages_changed ((HeSettingsWindow*) self, position, removed, added);
#line 551 "SettingsWindow.c"
}

static GObject *
he_settings_window_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeSettingsWindow * self;
	GtkStack* _tmp0_;
	GtkSelectionModel* _tmp1_;
	GtkSelectionModel* _tmp2_;
	GtkSelectionModel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	HeAppBar* _tmp12_;
	HeAppBar* _tmp13_;
	HeAppBar* _tmp14_;
	HeViewSwitcher* _tmp15_;
	GtkStack* _tmp16_;
	HeViewSwitcher* _tmp17_;
	HeViewSwitcher* _tmp18_;
	GtkStack* _tmp19_;
	GtkStack* _tmp20_;
	GtkBox* _tmp21_;
	HeAppBar* _tmp22_;
	GtkBox* _tmp23_;
	HeViewSwitcher* _tmp24_;
	GtkBox* _tmp25_;
	GtkStack* _tmp26_;
	GtkBox* _tmp27_;
	GtkStack* _tmp28_;
	GtkSelectionModel* _tmp29_;
	GtkSelectionModel* _tmp30_;
	GtkSelectionModel* _tmp31_;
#line 75 "../lib/Widgets/SettingsWindow.vala"
	parent_class = G_OBJECT_CLASS (he_settings_window_parent_class);
#line 75 "../lib/Widgets/SettingsWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 75 "../lib/Widgets/SettingsWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SETTINGS_WINDOW, HeSettingsWindow);
#line 76 "../lib/Widgets/SettingsWindow.vala"
	_tmp0_ = self->priv->stack;
#line 76 "../lib/Widgets/SettingsWindow.vala"
	_tmp1_ = gtk_stack_get_pages (_tmp0_);
#line 76 "../lib/Widgets/SettingsWindow.vala"
	_tmp2_ = _tmp1_;
#line 76 "../lib/Widgets/SettingsWindow.vala"
	_tmp3_ = _tmp2_;
#line 76 "../lib/Widgets/SettingsWindow.vala"
	g_signal_connect_object ((GListModel*) _tmp3_, "items-changed", (GCallback) _he_settings_window_on_pages_changed_g_list_model_items_changed, self, 0);
#line 76 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 78 "../lib/Widgets/SettingsWindow.vala"
	_tmp4_ = self->priv->viewtitle;
#line 78 "../lib/Widgets/SettingsWindow.vala"
	gtk_label_set_label (_tmp4_, "Settings");
#line 79 "../lib/Widgets/SettingsWindow.vala"
	_tmp5_ = self->priv->viewtitle;
#line 79 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "view-title");
#line 80 "../lib/Widgets/SettingsWindow.vala"
	_tmp6_ = self->priv->viewtitle;
#line 80 "../lib/Widgets/SettingsWindow.vala"
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
#line 81 "../lib/Widgets/SettingsWindow.vala"
	_tmp7_ = self->priv->viewtitle;
#line 81 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 82 "../lib/Widgets/SettingsWindow.vala"
	_tmp8_ = self->priv->viewtitle;
#line 82 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp8_, 6);
#line 83 "../lib/Widgets/SettingsWindow.vala"
	_tmp9_ = self->priv->viewtitle;
#line 83 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp9_, 18);
#line 84 "../lib/Widgets/SettingsWindow.vala"
	_tmp10_ = self->priv->viewtitle;
#line 84 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp10_, 12);
#line 85 "../lib/Widgets/SettingsWindow.vala"
	_tmp11_ = self->priv->viewtitle;
#line 85 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp11_, 6);
#line 87 "../lib/Widgets/SettingsWindow.vala"
	_tmp12_ = self->priv->appbar;
#line 87 "../lib/Widgets/SettingsWindow.vala"
	he_app_bar_set_decoration_layout (_tmp12_, ":close");
#line 88 "../lib/Widgets/SettingsWindow.vala"
	_tmp13_ = self->priv->appbar;
#line 88 "../lib/Widgets/SettingsWindow.vala"
	he_app_bar_set_show_back (_tmp13_, FALSE);
#line 89 "../lib/Widgets/SettingsWindow.vala"
	_tmp14_ = self->priv->appbar;
#line 89 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
#line 91 "../lib/Widgets/SettingsWindow.vala"
	_tmp15_ = self->priv->switcher;
#line 91 "../lib/Widgets/SettingsWindow.vala"
	_tmp16_ = self->priv->stack;
#line 91 "../lib/Widgets/SettingsWindow.vala"
	he_view_switcher_set_stack (_tmp15_, _tmp16_);
#line 92 "../lib/Widgets/SettingsWindow.vala"
	_tmp17_ = self->priv->switcher;
#line 92 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp17_, 18);
#line 93 "../lib/Widgets/SettingsWindow.vala"
	_tmp18_ = self->priv->switcher;
#line 93 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp18_, 18);
#line 94 "../lib/Widgets/SettingsWindow.vala"
	_tmp19_ = self->priv->stack;
#line 94 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp19_, 18);
#line 95 "../lib/Widgets/SettingsWindow.vala"
	_tmp20_ = self->priv->stack;
#line 95 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp20_, 18);
#line 97 "../lib/Widgets/SettingsWindow.vala"
	_tmp21_ = self->priv->box;
#line 97 "../lib/Widgets/SettingsWindow.vala"
	_tmp22_ = self->priv->appbar;
#line 97 "../lib/Widgets/SettingsWindow.vala"
	gtk_box_append (_tmp21_, (GtkWidget*) _tmp22_);
#line 98 "../lib/Widgets/SettingsWindow.vala"
	_tmp23_ = self->priv->box;
#line 98 "../lib/Widgets/SettingsWindow.vala"
	_tmp24_ = self->priv->switcher;
#line 98 "../lib/Widgets/SettingsWindow.vala"
	gtk_box_append (_tmp23_, (GtkWidget*) _tmp24_);
#line 99 "../lib/Widgets/SettingsWindow.vala"
	_tmp25_ = self->priv->box;
#line 99 "../lib/Widgets/SettingsWindow.vala"
	_tmp26_ = self->priv->stack;
#line 99 "../lib/Widgets/SettingsWindow.vala"
	gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 101 "../lib/Widgets/SettingsWindow.vala"
	_tmp27_ = self->priv->box;
#line 101 "../lib/Widgets/SettingsWindow.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp27_);
#line 103 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 360, 400);
#line 104 "../lib/Widgets/SettingsWindow.vala"
	gtk_window_set_default_size ((GtkWindow*) self, 360, 400);
#line 105 "../lib/Widgets/SettingsWindow.vala"
	he_window_set_has_title ((HeWindow*) self, FALSE);
#line 106 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 108 "../lib/Widgets/SettingsWindow.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 109 "../lib/Widgets/SettingsWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 110 "../lib/Widgets/SettingsWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "dialog-content");
#line 112 "../lib/Widgets/SettingsWindow.vala"
	_tmp28_ = self->priv->stack;
#line 112 "../lib/Widgets/SettingsWindow.vala"
	_tmp29_ = gtk_stack_get_pages (_tmp28_);
#line 112 "../lib/Widgets/SettingsWindow.vala"
	_tmp30_ = _tmp29_;
#line 112 "../lib/Widgets/SettingsWindow.vala"
	_tmp31_ = _tmp30_;
#line 112 "../lib/Widgets/SettingsWindow.vala"
	he_settings_window_on_pages_changed (self, (guint) 0, (guint) 0, g_list_model_get_n_items ((GListModel*) _tmp31_));
#line 112 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (_tmp31_);
#line 75 "../lib/Widgets/SettingsWindow.vala"
	return obj;
#line 728 "SettingsWindow.c"
}

static void
he_settings_window_class_init (HeSettingsWindowClass * klass,
                               gpointer klass_data)
{
#line 23 "../lib/Widgets/SettingsWindow.vala"
	he_settings_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/SettingsWindow.vala"
	g_type_class_adjust_private_offset (klass, &HeSettingsWindow_private_offset);
#line 23 "../lib/Widgets/SettingsWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = he_settings_window_constructor;
#line 23 "../lib/Widgets/SettingsWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = he_settings_window_finalize;
#line 743 "SettingsWindow.c"
}

static void
he_settings_window_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                 gpointer iface_data)
{
#line 23 "../lib/Widgets/SettingsWindow.vala"
	he_settings_window_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../lib/Widgets/SettingsWindow.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_settings_window_real_add_child;
#line 754 "SettingsWindow.c"
}

static void
he_settings_window_instance_init (HeSettingsWindow * self,
                                  gpointer klass)
{
	GtkBox* _tmp0_;
	GtkStack* _tmp1_;
	HeAppBar* _tmp2_;
	HeViewSwitcher* _tmp3_;
	GtkLabel* _tmp4_;
#line 23 "../lib/Widgets/SettingsWindow.vala"
	self->priv = he_settings_window_get_instance_private (self);
#line 24 "../lib/Widgets/SettingsWindow.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 24 "../lib/Widgets/SettingsWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 24 "../lib/Widgets/SettingsWindow.vala"
	self->priv->box = _tmp0_;
#line 25 "../lib/Widgets/SettingsWindow.vala"
	_tmp1_ = (GtkStack*) gtk_stack_new ();
#line 25 "../lib/Widgets/SettingsWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 25 "../lib/Widgets/SettingsWindow.vala"
	self->priv->stack = _tmp1_;
#line 26 "../lib/Widgets/SettingsWindow.vala"
	_tmp2_ = he_app_bar_new ();
#line 26 "../lib/Widgets/SettingsWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 26 "../lib/Widgets/SettingsWindow.vala"
	self->priv->appbar = _tmp2_;
#line 27 "../lib/Widgets/SettingsWindow.vala"
	_tmp3_ = he_view_switcher_new ();
#line 27 "../lib/Widgets/SettingsWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 27 "../lib/Widgets/SettingsWindow.vala"
	self->priv->switcher = _tmp3_;
#line 28 "../lib/Widgets/SettingsWindow.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
#line 28 "../lib/Widgets/SettingsWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 28 "../lib/Widgets/SettingsWindow.vala"
	self->priv->viewtitle = _tmp4_;
#line 798 "SettingsWindow.c"
}

static void
he_settings_window_finalize (GObject * obj)
{
	HeSettingsWindow * self;
#line 23 "../lib/Widgets/SettingsWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SETTINGS_WINDOW, HeSettingsWindow);
#line 24 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (self->priv->box);
#line 25 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (self->priv->stack);
#line 26 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (self->priv->appbar);
#line 27 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (self->priv->switcher);
#line 28 "../lib/Widgets/SettingsWindow.vala"
	_g_object_unref0 (self->priv->viewtitle);
#line 23 "../lib/Widgets/SettingsWindow.vala"
	G_OBJECT_CLASS (he_settings_window_parent_class)->finalize (obj);
#line 819 "SettingsWindow.c"
}

/**
 * A modal window that accepts SettingsLists or SettingsPages
 */
static GType
he_settings_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeSettingsWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_settings_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeSettingsWindow), 0, (GInstanceInitFunc) he_settings_window_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_settings_window_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_settings_window_type_id;
	he_settings_window_type_id = g_type_register_static (HE_TYPE_WINDOW, "HeSettingsWindow", &g_define_type_info, 0);
	g_type_add_interface_static (he_settings_window_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeSettingsWindow_private_offset = g_type_add_instance_private (he_settings_window_type_id, sizeof (HeSettingsWindowPrivate));
	return he_settings_window_type_id;
}

GType
he_settings_window_get_type (void)
{
	static volatile gsize he_settings_window_type_id__once = 0;
	if (g_once_init_enter (&he_settings_window_type_id__once)) {
		GType he_settings_window_type_id;
		he_settings_window_type_id = he_settings_window_get_type_once ();
		g_once_init_leave (&he_settings_window_type_id__once, he_settings_window_type_id);
	}
	return he_settings_window_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

