/* TabSwitcher.c generated by valac 0.56.15, the Vala compiler
 * generated from TabSwitcher.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define HE_TAB_SWITCHER_MIN_TAB_WIDTH 80
#define HE_TAB_SWITCHER_MAX_TAB_WIDTH 150
#define HE_TAB_SWITCHER_ACTION_NEW_TAB "action-new-tab"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_TAB_SWITCHER_0_PROPERTY,
	HE_TAB_SWITCHER_N_TABS_PROPERTY,
	HE_TAB_SWITCHER_TABS_PROPERTY,
	HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY,
	HE_TAB_SWITCHER_CURRENT_PROPERTY,
	HE_TAB_SWITCHER_MENU_PROPERTY,
	HE_TAB_SWITCHER_ACTIONS_PROPERTY,
	HE_TAB_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* he_tab_switcher_properties[HE_TAB_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
enum  {
	HE_TAB_SWITCHER_TAB_ADDED_SIGNAL,
	HE_TAB_SWITCHER_TAB_REMOVED_SIGNAL,
	HE_TAB_SWITCHER_TAB_SWITCHED_SIGNAL,
	HE_TAB_SWITCHER_TAB_MOVED_SIGNAL,
	HE_TAB_SWITCHER_TAB_DUPLICATED_SIGNAL,
	HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL,
	HE_TAB_SWITCHER_CLOSE_TAB_REQUESTED_SIGNAL,
	HE_TAB_SWITCHER_NUM_SIGNALS
};
static guint he_tab_switcher_signals[HE_TAB_SWITCHER_NUM_SIGNALS] = {0};

struct _HeTabSwitcherPrivate {
	GList* _tabs;
	HeTabSwitcherTabBarBehavior _tab_bar_behavior;
	gboolean _allow_duplication;
	gboolean _allow_drag;
	gboolean _allow_pin;
	gboolean _allow_close;
	gboolean _allow_window;
	GMenu* _menu;
	GtkPopoverMenu* _popover;
	HeTab* old_tab;
	gint tab_width;
	GSimpleActionGroup* _actions;
};

struct _Block8Data {
	int _ref_count_;
	HeTabSwitcher* self;
	GtkGestureClick* click;
};

struct _Block9Data {
	int _ref_count_;
	HeTabSwitcher* self;
	HeTab* clicked_tab;
};

struct _Block10Data {
	int _ref_count_;
	HeTabSwitcher* self;
	gboolean is_to_the_right;
	HeTab* clicked_tab;
};

static gint HeTabSwitcher_private_offset;
static gpointer he_tab_switcher_parent_class = NULL;
static GtkBuildableIface * he_tab_switcher_gtk_buildable_parent_iface = NULL;

static void he_tab_switcher_action_new_tab (HeTabSwitcher* self);
static void _he_tab_switcher_action_new_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void he_tab_switcher_update_tabs_visibility (HeTabSwitcher* self);
static void he_tab_switcher_recalc_order (HeTabSwitcher* self);
static void he_tab_switcher_set_menu (HeTabSwitcher* self,
                               GMenu* value);
static GtkPopoverMenu* he_tab_switcher_get_popover (HeTabSwitcher* self);
static void he_tab_switcher_set_popover (HeTabSwitcher* self,
                                  GtkPopoverMenu* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void he_tab_switcher_handle_events (HeTabSwitcher* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda32_ (Block8Data* _data8_,
                  gint n_press,
                  gdouble x,
                  gdouble y);
static void ___lambda32__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void he_tab_switcher_on_switch_page (HeTabSwitcher* self,
                                     GtkWidget* page,
                                     guint pagenum);
VALA_EXTERN void he_tab_set_is_current_tab (HeTab* self,
                                gboolean value);
static void he_tab_switcher_on_page_added (HeTabSwitcher* self,
                                    GtkWidget* page,
                                    guint pagenum);
static void he_tab_switcher_insert_callbacks (HeTabSwitcher* self,
                                       HeTab* tab);
static void he_tab_switcher_on_page_removed (HeTabSwitcher* self,
                                      GtkWidget* page,
                                      guint pagenum);
static void he_tab_switcher_remove_callbacks (HeTabSwitcher* self,
                                       HeTab* tab);
static GtkNotebook* he_tab_switcher_on_create_window (HeTabSwitcher* self,
                                               GtkWidget* page);
static void he_tab_switcher_on_tab_closed (HeTabSwitcher* self,
                                    HeTab* tab);
static void _he_tab_switcher_on_tab_closed_he_tab_closed (HeTab* _sender,
                                                   gpointer self);
static void he_tab_switcher_on_close_others (HeTabSwitcher* self,
                                      HeTab* clicked_tab);
static void _he_tab_switcher_on_close_others_he_tab_close_others (HeTab* _sender,
                                                           gpointer self);
static void he_tab_switcher_on_close_others_right (HeTabSwitcher* self,
                                            HeTab* clicked_tab);
static void _he_tab_switcher_on_close_others_right_he_tab_close_others_right (HeTab* _sender,
                                                                       gpointer self);
static void he_tab_switcher_on_duplicate (HeTabSwitcher* self,
                                   HeTab* tab);
static void _he_tab_switcher_on_duplicate_he_tab_duplicate (HeTab* _sender,
                                                     gpointer self);
static void he_tab_switcher_on_pin (HeTabSwitcher* self,
                             HeTab* tab);
static void _he_tab_switcher_on_pin_he_tab_pin (HeTab* _sender,
                                         gpointer self);
static void he_tab_switcher_on_new_window (HeTabSwitcher* self,
                                    HeTab* tab);
static void _he_tab_switcher_on_new_window_he_tab_new_window (HeTab* _sender,
                                                       gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda33_ (Block9Data* _data9_,
                  HeTab* tab);
static void ___lambda33__gfunc (gconstpointer data,
                         gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda34_ (Block10Data* _data10_,
                  HeTab* tab);
static void ___lambda34__gfunc (gconstpointer data,
                         gpointer self);
static GObject * he_tab_switcher_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _he_tab_switcher___lambda35_ (HeTabSwitcher* self);
static void __he_tab_switcher___lambda35__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _he_tab_switcher___lambda36_ (HeTabSwitcher* self);
static void _he_tab_switcher_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                               GtkWidget* page,
                                                               guint page_num,
                                                               gpointer self);
static void _he_tab_switcher_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                             GtkWidget* child,
                                                             guint page_num,
                                                             gpointer self);
static void _he_tab_switcher_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                                 GtkWidget* child,
                                                                 guint page_num,
                                                                 gpointer self);
static GtkNotebook* _he_tab_switcher_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                                           GtkWidget* page,
                                                                           gpointer self);
static void __he_tab_switcher___lambda36__gtk_widget_destroy (GtkWidget* _sender,
                                                       gpointer self);
static void he_tab_switcher_finalize (GObject * obj);
static GType he_tab_switcher_get_type_once (void);
static void _vala_he_tab_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_tab_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry HE_TAB_SWITCHER_ENTRIES[1] = {{HE_TAB_SWITCHER_ACTION_NEW_TAB, _he_tab_switcher_action_new_tab_gsimple_action_activate_callback}};

static inline gpointer
he_tab_switcher_get_instance_private (HeTabSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, HeTabSwitcher_private_offset);
}

/**
     * How the tab bar should behave
     */
static GType
he_tab_switcher_tab_bar_behavior_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS, "HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS", "always"}, {HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_SINGLE, "HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_SINGLE", "single"}, {HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_NEVER, "HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_NEVER", "never"}, {0, NULL, NULL}};
	GType he_tab_switcher_tab_bar_behavior_type_id;
	he_tab_switcher_tab_bar_behavior_type_id = g_enum_register_static ("HeTabSwitcherTabBarBehavior", values);
	return he_tab_switcher_tab_bar_behavior_type_id;
}

GType
he_tab_switcher_tab_bar_behavior_get_type (void)
{
	static volatile gsize he_tab_switcher_tab_bar_behavior_type_id__once = 0;
	if (g_once_init_enter (&he_tab_switcher_tab_bar_behavior_type_id__once)) {
		GType he_tab_switcher_tab_bar_behavior_type_id;
		he_tab_switcher_tab_bar_behavior_type_id = he_tab_switcher_tab_bar_behavior_get_type_once ();
		g_once_init_leave (&he_tab_switcher_tab_bar_behavior_type_id__once, he_tab_switcher_tab_bar_behavior_type_id);
	}
	return he_tab_switcher_tab_bar_behavior_type_id__once;
}

static void
_he_tab_switcher_action_new_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 211 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_action_new_tab ((HeTabSwitcher*) self);
#line 284 "TabSwitcher.c"
}

gint
he_tab_switcher_get_n_tabs (HeTabSwitcher* self)
{
	gint result;
	GtkNotebook* _tmp0_;
#line 33 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->notebook;
#line 33 "../lib/Widgets/TabSwitcher.vala"
	result = gtk_notebook_get_n_pages (_tmp0_);
#line 33 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 300 "TabSwitcher.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 41 "../lib/Widgets/TabSwitcher.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 308 "TabSwitcher.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 41 "../lib/Widgets/TabSwitcher.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 316 "TabSwitcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../lib/Widgets/TabSwitcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 324 "TabSwitcher.c"
}

GList*
he_tab_switcher_get_tabs (HeTabSwitcher* self)
{
	GList* result;
	GList* _tmp9_;
#line 40 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../lib/Widgets/TabSwitcher.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 41 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_tabs = NULL;
#line 338 "TabSwitcher.c"
	{
		gint i = 0;
#line 42 "../lib/Widgets/TabSwitcher.vala"
		i = 0;
#line 343 "TabSwitcher.c"
		{
			gboolean _tmp0_ = FALSE;
#line 42 "../lib/Widgets/TabSwitcher.vala"
			_tmp0_ = TRUE;
#line 42 "../lib/Widgets/TabSwitcher.vala"
			while (TRUE) {
#line 350 "TabSwitcher.c"
				gint _tmp2_;
				gint _tmp3_;
				GtkNotebook* _tmp4_;
				GtkNotebook* _tmp5_;
				GtkWidget* _tmp6_;
				GtkWidget* _tmp7_;
				HeTab* _tmp8_;
#line 42 "../lib/Widgets/TabSwitcher.vala"
				if (!_tmp0_) {
#line 360 "TabSwitcher.c"
					gint _tmp1_;
#line 42 "../lib/Widgets/TabSwitcher.vala"
					_tmp1_ = i;
#line 42 "../lib/Widgets/TabSwitcher.vala"
					i = _tmp1_ + 1;
#line 366 "TabSwitcher.c"
				}
#line 42 "../lib/Widgets/TabSwitcher.vala"
				_tmp0_ = FALSE;
#line 42 "../lib/Widgets/TabSwitcher.vala"
				_tmp2_ = he_tab_switcher_get_n_tabs (self);
#line 42 "../lib/Widgets/TabSwitcher.vala"
				_tmp3_ = _tmp2_;
#line 42 "../lib/Widgets/TabSwitcher.vala"
				if (!(i < _tmp3_)) {
#line 42 "../lib/Widgets/TabSwitcher.vala"
					break;
#line 378 "TabSwitcher.c"
				}
#line 43 "../lib/Widgets/TabSwitcher.vala"
				_tmp4_ = self->notebook;
#line 43 "../lib/Widgets/TabSwitcher.vala"
				_tmp5_ = self->notebook;
#line 43 "../lib/Widgets/TabSwitcher.vala"
				_tmp6_ = gtk_notebook_get_nth_page (_tmp5_, i);
#line 43 "../lib/Widgets/TabSwitcher.vala"
				_tmp7_ = gtk_notebook_get_tab_label (_tmp4_, _tmp6_);
#line 43 "../lib/Widgets/TabSwitcher.vala"
				_tmp8_ = _g_object_ref0 (HE_IS_TAB (_tmp7_) ? ((HeTab*) _tmp7_) : NULL);
#line 43 "../lib/Widgets/TabSwitcher.vala"
				self->priv->_tabs = g_list_append (self->priv->_tabs, _tmp8_);
#line 392 "TabSwitcher.c"
			}
		}
	}
#line 45 "../lib/Widgets/TabSwitcher.vala"
	_tmp9_ = self->priv->_tabs;
#line 45 "../lib/Widgets/TabSwitcher.vala"
	result = _tmp9_;
#line 45 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 402 "TabSwitcher.c"
}

HeTabSwitcherTabBarBehavior
he_tab_switcher_get_tab_bar_behavior (HeTabSwitcher* self)
{
	HeTabSwitcherTabBarBehavior result;
#line 68 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../lib/Widgets/TabSwitcher.vala"
	result = self->priv->_tab_bar_behavior;
#line 68 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 415 "TabSwitcher.c"
}

void
he_tab_switcher_set_tab_bar_behavior (HeTabSwitcher* self,
                                      HeTabSwitcherTabBarBehavior value)
{
#line 63 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 64 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_tab_bar_behavior = value;
#line 65 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_update_tabs_visibility (self);
#line 63 "../lib/Widgets/TabSwitcher.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY]);
#line 430 "TabSwitcher.c"
}

/**
     * The position in the switcher of the tab
     */
gint
he_tab_switcher_get_tab_position (HeTabSwitcher* self,
                                  HeTab* tab)
{
	GtkNotebook* _tmp0_;
	HeTabPage* _tmp1_;
	gint result;
#line 75 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (tab != NULL, 0);
#line 76 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->notebook;
#line 76 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = tab->page_container;
#line 76 "../lib/Widgets/TabSwitcher.vala"
	result = gtk_notebook_page_num (_tmp0_, (GtkWidget*) _tmp1_);
#line 76 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 455 "TabSwitcher.c"
}

gboolean
he_tab_switcher_get_allow_duplicate_tabs (HeTabSwitcher* self)
{
	gboolean result;
#line 84 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../lib/Widgets/TabSwitcher.vala"
	result = self->priv->_allow_duplication;
#line 84 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 468 "TabSwitcher.c"
}

void
he_tab_switcher_set_allow_duplicate_tabs (HeTabSwitcher* self,
                                          gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 85 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 86 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_duplication = value;
#line 88 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_tabs (self);
#line 88 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 485 "TabSwitcher.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 88 "../lib/Widgets/TabSwitcher.vala"
		tab_collection = _tmp1_;
#line 88 "../lib/Widgets/TabSwitcher.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 493 "TabSwitcher.c"
			HeTab* _tmp2_;
			HeTab* tab = NULL;
#line 88 "../lib/Widgets/TabSwitcher.vala"
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
#line 88 "../lib/Widgets/TabSwitcher.vala"
			tab = _tmp2_;
#line 500 "TabSwitcher.c"
			{
#line 88 "../lib/Widgets/TabSwitcher.vala"
				_g_object_unref0 (tab);
#line 504 "TabSwitcher.c"
			}
		}
	}
#line 85 "../lib/Widgets/TabSwitcher.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY]);
#line 510 "TabSwitcher.c"
}

gboolean
he_tab_switcher_get_allow_drag (HeTabSwitcher* self)
{
	gboolean result;
#line 100 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../lib/Widgets/TabSwitcher.vala"
	result = self->priv->_allow_drag;
#line 100 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 523 "TabSwitcher.c"
}

void
he_tab_switcher_set_allow_drag (HeTabSwitcher* self,
                                gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 101 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 102 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_drag = value;
#line 103 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_tabs (self);
#line 103 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 540 "TabSwitcher.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 103 "../lib/Widgets/TabSwitcher.vala"
		tab_collection = _tmp1_;
#line 103 "../lib/Widgets/TabSwitcher.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 548 "TabSwitcher.c"
			HeTab* _tmp2_;
			HeTab* tab = NULL;
#line 103 "../lib/Widgets/TabSwitcher.vala"
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
#line 103 "../lib/Widgets/TabSwitcher.vala"
			tab = _tmp2_;
#line 555 "TabSwitcher.c"
			{
				GtkNotebook* _tmp3_;
				HeTab* _tmp4_;
				HeTabPage* _tmp5_;
#line 104 "../lib/Widgets/TabSwitcher.vala"
				_tmp3_ = self->notebook;
#line 104 "../lib/Widgets/TabSwitcher.vala"
				_tmp4_ = tab;
#line 104 "../lib/Widgets/TabSwitcher.vala"
				_tmp5_ = _tmp4_->page_container;
#line 104 "../lib/Widgets/TabSwitcher.vala"
				gtk_notebook_set_tab_reorderable (_tmp3_, (GtkWidget*) _tmp5_, value);
#line 103 "../lib/Widgets/TabSwitcher.vala"
				_g_object_unref0 (tab);
#line 570 "TabSwitcher.c"
			}
		}
	}
#line 101 "../lib/Widgets/TabSwitcher.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY]);
#line 576 "TabSwitcher.c"
}

gboolean
he_tab_switcher_get_allow_pinning (HeTabSwitcher* self)
{
	gboolean result;
#line 114 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "../lib/Widgets/TabSwitcher.vala"
	result = self->priv->_allow_pin;
#line 114 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 589 "TabSwitcher.c"
}

void
he_tab_switcher_set_allow_pinning (HeTabSwitcher* self,
                                   gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 115 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 116 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_pin = value;
#line 117 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_tabs (self);
#line 117 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 606 "TabSwitcher.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 117 "../lib/Widgets/TabSwitcher.vala"
		tab_collection = _tmp1_;
#line 117 "../lib/Widgets/TabSwitcher.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 614 "TabSwitcher.c"
			HeTab* _tmp2_;
			HeTab* tab = NULL;
#line 117 "../lib/Widgets/TabSwitcher.vala"
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
#line 117 "../lib/Widgets/TabSwitcher.vala"
			tab = _tmp2_;
#line 621 "TabSwitcher.c"
			{
				HeTab* _tmp3_;
#line 118 "../lib/Widgets/TabSwitcher.vala"
				_tmp3_ = tab;
#line 118 "../lib/Widgets/TabSwitcher.vala"
				he_tab_set_can_pin (_tmp3_, value);
#line 117 "../lib/Widgets/TabSwitcher.vala"
				_g_object_unref0 (tab);
#line 630 "TabSwitcher.c"
			}
		}
	}
#line 115 "../lib/Widgets/TabSwitcher.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY]);
#line 636 "TabSwitcher.c"
}

gboolean
he_tab_switcher_get_allow_closing (HeTabSwitcher* self)
{
	gboolean result;
#line 128 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../lib/Widgets/TabSwitcher.vala"
	result = self->priv->_allow_close;
#line 128 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 649 "TabSwitcher.c"
}

void
he_tab_switcher_set_allow_closing (HeTabSwitcher* self,
                                   gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 129 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 130 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_close = value;
#line 131 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_tabs (self);
#line 131 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 666 "TabSwitcher.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 131 "../lib/Widgets/TabSwitcher.vala"
		tab_collection = _tmp1_;
#line 131 "../lib/Widgets/TabSwitcher.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 674 "TabSwitcher.c"
			HeTab* _tmp2_;
			HeTab* tab = NULL;
#line 131 "../lib/Widgets/TabSwitcher.vala"
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
#line 131 "../lib/Widgets/TabSwitcher.vala"
			tab = _tmp2_;
#line 681 "TabSwitcher.c"
			{
				HeTab* _tmp3_;
#line 132 "../lib/Widgets/TabSwitcher.vala"
				_tmp3_ = tab;
#line 132 "../lib/Widgets/TabSwitcher.vala"
				he_tab_set_can_close (_tmp3_, value);
#line 131 "../lib/Widgets/TabSwitcher.vala"
				_g_object_unref0 (tab);
#line 690 "TabSwitcher.c"
			}
		}
	}
#line 129 "../lib/Widgets/TabSwitcher.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY]);
#line 696 "TabSwitcher.c"
}

gboolean
he_tab_switcher_get_allow_new_window (HeTabSwitcher* self)
{
	gboolean result;
#line 142 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../lib/Widgets/TabSwitcher.vala"
	result = self->priv->_allow_window;
#line 142 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 709 "TabSwitcher.c"
}

void
he_tab_switcher_set_allow_new_window (HeTabSwitcher* self,
                                      gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 143 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 144 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_close = value;
#line 145 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_tabs (self);
#line 145 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 726 "TabSwitcher.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 145 "../lib/Widgets/TabSwitcher.vala"
		tab_collection = _tmp1_;
#line 145 "../lib/Widgets/TabSwitcher.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 734 "TabSwitcher.c"
			HeTab* _tmp2_;
			HeTab* tab = NULL;
#line 145 "../lib/Widgets/TabSwitcher.vala"
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
#line 145 "../lib/Widgets/TabSwitcher.vala"
			tab = _tmp2_;
#line 741 "TabSwitcher.c"
			{
				GtkNotebook* _tmp3_;
				HeTab* _tmp4_;
				HeTabPage* _tmp5_;
#line 146 "../lib/Widgets/TabSwitcher.vala"
				_tmp3_ = self->notebook;
#line 146 "../lib/Widgets/TabSwitcher.vala"
				_tmp4_ = tab;
#line 146 "../lib/Widgets/TabSwitcher.vala"
				_tmp5_ = _tmp4_->page_container;
#line 146 "../lib/Widgets/TabSwitcher.vala"
				gtk_notebook_set_tab_detachable (_tmp3_, (GtkWidget*) _tmp5_, value);
#line 145 "../lib/Widgets/TabSwitcher.vala"
				_g_object_unref0 (tab);
#line 756 "TabSwitcher.c"
			}
		}
	}
#line 143 "../lib/Widgets/TabSwitcher.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY]);
#line 762 "TabSwitcher.c"
}

HeTab*
he_tab_switcher_get_current (HeTabSwitcher* self)
{
	HeTab* result;
	GList* _tmp0_;
	GList* _tmp1_;
	GtkNotebook* _tmp2_;
	gconstpointer _tmp3_;
#line 155 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 155 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_tabs (self);
#line 155 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 155 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = self->notebook;
#line 155 "../lib/Widgets/TabSwitcher.vala"
	_tmp3_ = g_list_nth_data (_tmp1_, (guint) gtk_notebook_get_current_page (_tmp2_));
#line 155 "../lib/Widgets/TabSwitcher.vala"
	result = (HeTab*) _tmp3_;
#line 155 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 787 "TabSwitcher.c"
}

void
he_tab_switcher_set_current (HeTabSwitcher* self,
                             HeTab* value)
{
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 156 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 156 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->notebook;
#line 156 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = he_tab_switcher_get_tabs (self);
#line 156 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 156 "../lib/Widgets/TabSwitcher.vala"
	gtk_notebook_set_current_page (_tmp0_, g_list_index (_tmp2_, value));
#line 156 "../lib/Widgets/TabSwitcher.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_CURRENT_PROPERTY]);
#line 809 "TabSwitcher.c"
}

/**
     * Insert a new tab into the TabSwitcher.
     *
     * To append a tab, you may use -1 as the index.
     */
guint
he_tab_switcher_insert_tab (HeTabSwitcher* self,
                            HeTab* tab,
                            gint index)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp3_;
	HeTabPage* _tmp4_;
	GtkNotebook* _tmp5_;
	HeTabPage* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GtkNotebook* _tmp9_;
	HeTabPage* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkWidget* _tmp15_;
	guint result;
#line 164 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 164 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (tab != NULL, 0U);
#line 165 "../lib/Widgets/TabSwitcher.vala"
	if (index <= -1) {
#line 843 "TabSwitcher.c"
		gint _tmp1_;
		gint _tmp2_;
#line 165 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = he_tab_switcher_get_n_tabs (self);
#line 165 "../lib/Widgets/TabSwitcher.vala"
		_tmp2_ = _tmp1_;
#line 165 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_ = _tmp2_;
#line 852 "TabSwitcher.c"
	} else {
#line 165 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_ = index;
#line 856 "TabSwitcher.c"
	}
#line 165 "../lib/Widgets/TabSwitcher.vala"
	_tmp3_ = self->notebook;
#line 165 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = tab->page_container;
#line 165 "../lib/Widgets/TabSwitcher.vala"
	index = gtk_notebook_insert_page (_tmp3_, (GtkWidget*) _tmp4_, (GtkWidget*) tab, _tmp0_);
#line 166 "../lib/Widgets/TabSwitcher.vala"
	_tmp5_ = self->notebook;
#line 166 "../lib/Widgets/TabSwitcher.vala"
	_tmp6_ = tab->page_container;
#line 166 "../lib/Widgets/TabSwitcher.vala"
	_tmp7_ = he_tab_switcher_get_allow_drag (self);
#line 166 "../lib/Widgets/TabSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 166 "../lib/Widgets/TabSwitcher.vala"
	gtk_notebook_set_tab_reorderable (_tmp5_, (GtkWidget*) _tmp6_, _tmp8_);
#line 167 "../lib/Widgets/TabSwitcher.vala"
	_tmp9_ = self->notebook;
#line 167 "../lib/Widgets/TabSwitcher.vala"
	_tmp10_ = tab->page_container;
#line 167 "../lib/Widgets/TabSwitcher.vala"
	_tmp11_ = he_tab_switcher_get_allow_new_window (self);
#line 167 "../lib/Widgets/TabSwitcher.vala"
	_tmp12_ = _tmp11_;
#line 167 "../lib/Widgets/TabSwitcher.vala"
	gtk_notebook_set_tab_detachable (_tmp9_, (GtkWidget*) _tmp10_, _tmp12_);
#line 169 "../lib/Widgets/TabSwitcher.vala"
	_tmp13_ = he_tab_switcher_get_allow_pinning (self);
#line 169 "../lib/Widgets/TabSwitcher.vala"
	_tmp14_ = _tmp13_;
#line 169 "../lib/Widgets/TabSwitcher.vala"
	he_tab_set_can_pin (tab, _tmp14_);
#line 170 "../lib/Widgets/TabSwitcher.vala"
	he_tab_set_pinned (tab, FALSE);
#line 172 "../lib/Widgets/TabSwitcher.vala"
	_tmp15_ = gtk_widget_get_parent ((GtkWidget*) tab);
#line 172 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_add_css_class (_tmp15_, "tab");
#line 173 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_set_size_request ((GtkWidget*) tab, self->priv->tab_width, -1);
#line 175 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_recalc_order (self);
#line 177 "../lib/Widgets/TabSwitcher.vala"
	result = (guint) index;
#line 177 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 904 "TabSwitcher.c"
}

/**
     * Removes a tab from the TabSwitcher.
     */
void
he_tab_switcher_remove_tab (HeTabSwitcher* self,
                            HeTab* tab)
{
	gint pos = 0;
#line 183 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 183 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 184 "../lib/Widgets/TabSwitcher.vala"
	pos = he_tab_switcher_get_tab_position (self, tab);
#line 186 "../lib/Widgets/TabSwitcher.vala"
	if (pos != -1) {
#line 923 "TabSwitcher.c"
		GtkNotebook* _tmp0_;
#line 187 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_ = self->notebook;
#line 187 "../lib/Widgets/TabSwitcher.vala"
		gtk_notebook_remove_page (_tmp0_, pos);
#line 929 "TabSwitcher.c"
	}
}

GMenu*
he_tab_switcher_get_menu (HeTabSwitcher* self)
{
	GMenu* result;
	GMenu* _tmp0_;
#line 193 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 193 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->priv->_menu;
#line 193 "../lib/Widgets/TabSwitcher.vala"
	result = _tmp0_;
#line 193 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 946 "TabSwitcher.c"
}

static void
he_tab_switcher_set_menu (HeTabSwitcher* self,
                          GMenu* value)
{
	GMenu* old_value;
#line 193 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 193 "../lib/Widgets/TabSwitcher.vala"
	old_value = he_tab_switcher_get_menu (self);
#line 193 "../lib/Widgets/TabSwitcher.vala"
	if (old_value != value) {
#line 960 "TabSwitcher.c"
		GMenu* _tmp0_;
#line 193 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 193 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (self->priv->_menu);
#line 193 "../lib/Widgets/TabSwitcher.vala"
		self->priv->_menu = _tmp0_;
#line 193 "../lib/Widgets/TabSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_MENU_PROPERTY]);
#line 970 "TabSwitcher.c"
	}
}

static GtkPopoverMenu*
he_tab_switcher_get_popover (HeTabSwitcher* self)
{
	GtkPopoverMenu* result;
	GtkPopoverMenu* _tmp0_;
#line 195 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 195 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->priv->_popover;
#line 195 "../lib/Widgets/TabSwitcher.vala"
	result = _tmp0_;
#line 195 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 987 "TabSwitcher.c"
}

static void
he_tab_switcher_set_popover (HeTabSwitcher* self,
                             GtkPopoverMenu* value)
{
	GtkPopoverMenu* _tmp0_;
#line 195 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 195 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 195 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->priv->_popover);
#line 195 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_popover = _tmp0_;
#line 1003 "TabSwitcher.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data1 = closure->data;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data2 = param_values->data[0].v_pointer;
#line 1028 "TabSwitcher.c"
	} else {
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data2 = closure->data;
#line 1034 "TabSwitcher.c"
	}
#line 23 "../lib/Widgets/TabSwitcher.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1040 "TabSwitcher.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (return_value != NULL);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (n_param_values == 2);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data1 = closure->data;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data2 = param_values->data[0].v_pointer;
#line 1068 "TabSwitcher.c"
	} else {
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		data2 = closure->data;
#line 1074 "TabSwitcher.c"
	}
#line 23 "../lib/Widgets/TabSwitcher.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_value_set_boolean (return_value, v_return);
#line 1082 "TabSwitcher.c"
}

GSimpleActionGroup*
he_tab_switcher_get_actions (HeTabSwitcher* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
#line 209 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 209 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->priv->_actions;
#line 209 "../lib/Widgets/TabSwitcher.vala"
	result = _tmp0_;
#line 209 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 1098 "TabSwitcher.c"
}

static void
he_tab_switcher_set_actions (HeTabSwitcher* self,
                             GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
#line 209 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 209 "../lib/Widgets/TabSwitcher.vala"
	old_value = he_tab_switcher_get_actions (self);
#line 209 "../lib/Widgets/TabSwitcher.vala"
	if (old_value != value) {
#line 1112 "TabSwitcher.c"
		GSimpleActionGroup* _tmp0_;
#line 209 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 209 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (self->priv->_actions);
#line 209 "../lib/Widgets/TabSwitcher.vala"
		self->priv->_actions = _tmp0_;
#line 209 "../lib/Widgets/TabSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ACTIONS_PROPERTY]);
#line 1122 "TabSwitcher.c"
	}
}

static void
he_tab_switcher_action_new_tab (HeTabSwitcher* self)
{
#line 215 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 216 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 1133 "TabSwitcher.c"
}

/**
     * Create a new TabSwitcher
     *
     * @since 1.0
     */
HeTabSwitcher*
he_tab_switcher_construct (GType object_type)
{
	HeTabSwitcher * self = NULL;
#line 225 "../lib/Widgets/TabSwitcher.vala"
	self = (HeTabSwitcher*) he_bin_construct (object_type);
#line 226 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_handle_events (self);
#line 224 "../lib/Widgets/TabSwitcher.vala"
	return self;
#line 1151 "TabSwitcher.c"
}

HeTabSwitcher*
he_tab_switcher_new (void)
{
#line 224 "../lib/Widgets/TabSwitcher.vala"
	return he_tab_switcher_construct (HE_TYPE_TAB_SWITCHER);
#line 1159 "TabSwitcher.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 282 "../lib/Widgets/TabSwitcher.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 282 "../lib/Widgets/TabSwitcher.vala"
	return _data8_;
#line 1169 "TabSwitcher.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 282 "../lib/Widgets/TabSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1179 "TabSwitcher.c"
		HeTabSwitcher* self;
#line 282 "../lib/Widgets/TabSwitcher.vala"
		self = _data8_->self;
#line 282 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (_data8_->click);
#line 282 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (self);
#line 282 "../lib/Widgets/TabSwitcher.vala"
		g_slice_free (Block8Data, _data8_);
#line 1189 "TabSwitcher.c"
	}
}

static void
__lambda32_ (Block8Data* _data8_,
             gint n_press,
             gdouble x,
             gdouble y)
{
	HeTabSwitcher* self;
#line 289 "../lib/Widgets/TabSwitcher.vala"
	self = _data8_->self;
#line 290 "../lib/Widgets/TabSwitcher.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) _data8_->click) == ((guint) GDK_BUTTON_SECONDARY)) {
#line 1204 "TabSwitcher.c"
		GdkRectangle rect = {0};
		GdkRectangle _tmp0_ = {0};
		GtkPopoverMenu* _tmp1_;
		GdkRectangle _tmp2_;
		GtkPopoverMenu* _tmp3_;
#line 291 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_.x = (gint) x;
#line 291 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_.y = (gint) y;
#line 291 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_.width = 0;
#line 291 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_.height = 0;
#line 291 "../lib/Widgets/TabSwitcher.vala"
		rect = _tmp0_;
#line 295 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = self->priv->_popover;
#line 295 "../lib/Widgets/TabSwitcher.vala"
		_tmp2_ = rect;
#line 295 "../lib/Widgets/TabSwitcher.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp1_, &_tmp2_);
#line 296 "../lib/Widgets/TabSwitcher.vala"
		_tmp3_ = self->priv->_popover;
#line 296 "../lib/Widgets/TabSwitcher.vala"
		gtk_popover_popup ((GtkPopover*) _tmp3_);
#line 1230 "TabSwitcher.c"
	}
}

static void
___lambda32__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
#line 289 "../lib/Widgets/TabSwitcher.vala"
	__lambda32_ (self, n_press, x, y);
#line 1243 "TabSwitcher.c"
}

static void
he_tab_switcher_handle_events (HeTabSwitcher* self)
{
	Block8Data* _data8_;
	GtkGestureClick* _tmp0_ = NULL;
	GtkEventController* _tmp1_;
	GtkPopoverMenu* _tmp2_;
#line 282 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 282 "../lib/Widgets/TabSwitcher.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 282 "../lib/Widgets/TabSwitcher.vala"
	_data8_->_ref_count_ = 1;
#line 282 "../lib/Widgets/TabSwitcher.vala"
	_data8_->self = g_object_ref (self);
#line 283 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 283 "../lib/Widgets/TabSwitcher.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp0_, (guint) 0);
#line 283 "../lib/Widgets/TabSwitcher.vala"
	_data8_->click = _tmp0_;
#line 286 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _g_object_ref0 ((GtkEventController*) _data8_->click);
#line 286 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
#line 287 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = self->priv->_popover;
#line 287 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp2_, (GtkWidget*) self);
#line 289 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_data (_data8_->click, "pressed", (GCallback) ___lambda32__gtk_gesture_click_pressed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 282 "../lib/Widgets/TabSwitcher.vala"
	block8_data_unref (_data8_);
#line 282 "../lib/Widgets/TabSwitcher.vala"
	_data8_ = NULL;
#line 1281 "TabSwitcher.c"
}

static void
he_tab_switcher_on_switch_page (HeTabSwitcher* self,
                                GtkWidget* page,
                                guint pagenum)
{
	HeTabPage* _tmp0_ = NULL;
	HeTab* _tmp1_ = NULL;
	HeTab* new_tab = NULL;
	HeTab* _tmp4_;
	HeTab* _tmp5_;
	HeTab* _tmp7_;
	HeTab* _tmp8_;
	HeTab* _tmp9_;
	HeTab* _tmp10_;
	HeTab* _tmp11_;
#line 301 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 301 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (page != NULL);
#line 302 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = HE_IS_TAB_PAGE (page) ? ((HeTabPage*) page) : NULL;
#line 302 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = NULL;
#line 302 "../lib/Widgets/TabSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 1309 "TabSwitcher.c"
		HeTab* _tmp2_;
		HeTab* _tmp3_;
#line 302 "../lib/Widgets/TabSwitcher.vala"
		_tmp2_ = he_tab_page_get_tab (_tmp0_);
#line 302 "../lib/Widgets/TabSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 302 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = _tmp3_;
#line 1318 "TabSwitcher.c"
	}
#line 302 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 302 "../lib/Widgets/TabSwitcher.vala"
	new_tab = _tmp4_;
#line 305 "../lib/Widgets/TabSwitcher.vala"
	_tmp5_ = self->priv->old_tab;
#line 305 "../lib/Widgets/TabSwitcher.vala"
	if (_tmp5_ != NULL) {
#line 1328 "TabSwitcher.c"
		HeTab* _tmp6_;
#line 306 "../lib/Widgets/TabSwitcher.vala"
		_tmp6_ = self->priv->old_tab;
#line 306 "../lib/Widgets/TabSwitcher.vala"
		he_tab_set_is_current_tab (_tmp6_, FALSE);
#line 1334 "TabSwitcher.c"
	}
#line 309 "../lib/Widgets/TabSwitcher.vala"
	_tmp7_ = new_tab;
#line 309 "../lib/Widgets/TabSwitcher.vala"
	he_tab_set_is_current_tab (_tmp7_, TRUE);
#line 311 "../lib/Widgets/TabSwitcher.vala"
	_tmp8_ = self->priv->old_tab;
#line 311 "../lib/Widgets/TabSwitcher.vala"
	_tmp9_ = new_tab;
#line 311 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_SWITCHED_SIGNAL], 0, _tmp8_, _tmp9_);
#line 313 "../lib/Widgets/TabSwitcher.vala"
	_tmp10_ = new_tab;
#line 313 "../lib/Widgets/TabSwitcher.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 313 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 313 "../lib/Widgets/TabSwitcher.vala"
	self->priv->old_tab = _tmp11_;
#line 301 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (new_tab);
#line 1356 "TabSwitcher.c"
}

static void
he_tab_switcher_on_page_added (HeTabSwitcher* self,
                               GtkWidget* page,
                               guint pagenum)
{
	HeTabPage* _tmp0_ = NULL;
	HeTab* _tmp1_ = NULL;
	HeTab* t = NULL;
	HeTab* _tmp4_;
#line 316 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 316 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (page != NULL);
#line 317 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = HE_IS_TAB_PAGE (page) ? ((HeTabPage*) page) : NULL;
#line 317 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = NULL;
#line 317 "../lib/Widgets/TabSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 1378 "TabSwitcher.c"
		HeTab* _tmp2_;
		HeTab* _tmp3_;
#line 317 "../lib/Widgets/TabSwitcher.vala"
		_tmp2_ = he_tab_page_get_tab (_tmp0_);
#line 317 "../lib/Widgets/TabSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 317 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = _tmp3_;
#line 1387 "TabSwitcher.c"
	}
#line 317 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 317 "../lib/Widgets/TabSwitcher.vala"
	t = _tmp4_;
#line 319 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_insert_callbacks (self, t);
#line 320 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_ADDED_SIGNAL], 0, t);
#line 321 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_update_tabs_visibility (self);
#line 316 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (t);
#line 1401 "TabSwitcher.c"
}

static void
he_tab_switcher_on_page_removed (HeTabSwitcher* self,
                                 GtkWidget* page,
                                 guint pagenum)
{
	HeTabPage* _tmp0_ = NULL;
	HeTab* _tmp1_ = NULL;
	HeTab* t = NULL;
	HeTab* _tmp4_;
#line 324 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 324 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (page != NULL);
#line 325 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = HE_IS_TAB_PAGE (page) ? ((HeTabPage*) page) : NULL;
#line 325 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = NULL;
#line 325 "../lib/Widgets/TabSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 1423 "TabSwitcher.c"
		HeTab* _tmp2_;
		HeTab* _tmp3_;
#line 325 "../lib/Widgets/TabSwitcher.vala"
		_tmp2_ = he_tab_page_get_tab (_tmp0_);
#line 325 "../lib/Widgets/TabSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 325 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = _tmp3_;
#line 1432 "TabSwitcher.c"
	}
#line 325 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 325 "../lib/Widgets/TabSwitcher.vala"
	t = _tmp4_;
#line 327 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_remove_callbacks (self, t);
#line 328 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_REMOVED_SIGNAL], 0, t);
#line 329 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_update_tabs_visibility (self);
#line 324 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (t);
#line 1446 "TabSwitcher.c"
}

static GtkNotebook*
he_tab_switcher_on_create_window (HeTabSwitcher* self,
                                  GtkWidget* page)
{
	HeTab* tab = NULL;
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	HeTab* _tmp2_;
	GtkNotebook* result;
#line 332 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../lib/Widgets/TabSwitcher.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 333 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->notebook;
#line 333 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = gtk_notebook_get_tab_label (_tmp0_, page);
#line 333 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = _g_object_ref0 (HE_IS_TAB (_tmp1_) ? ((HeTab*) _tmp1_) : NULL);
#line 333 "../lib/Widgets/TabSwitcher.vala"
	tab = _tmp2_;
#line 334 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_MOVED_SIGNAL], 0, tab);
#line 335 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_recalc_order (self);
#line 336 "../lib/Widgets/TabSwitcher.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (NULL, gtk_notebook_get_type (), GtkNotebook);
#line 336 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (tab);
#line 336 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 1480 "TabSwitcher.c"
}

static void
he_tab_switcher_recalc_order (HeTabSwitcher* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint pinned_tabs = 0;
#line 339 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 340 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_n_tabs (self);
#line 340 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 340 "../lib/Widgets/TabSwitcher.vala"
	if (_tmp1_ == 0) {
#line 341 "../lib/Widgets/TabSwitcher.vala"
		return;
#line 1499 "TabSwitcher.c"
	}
#line 343 "../lib/Widgets/TabSwitcher.vala"
	pinned_tabs = 0;
#line 1503 "TabSwitcher.c"
	{
		gint i = 0;
#line 344 "../lib/Widgets/TabSwitcher.vala"
		i = 0;
#line 1508 "TabSwitcher.c"
		{
			gboolean _tmp2_ = FALSE;
#line 344 "../lib/Widgets/TabSwitcher.vala"
			_tmp2_ = TRUE;
#line 344 "../lib/Widgets/TabSwitcher.vala"
			while (TRUE) {
#line 1515 "TabSwitcher.c"
				GtkNotebook* _tmp4_;
				HeTabPage* _tmp5_ = NULL;
				GtkNotebook* _tmp6_;
				GtkWidget* _tmp7_;
				HeTab* _tmp8_ = NULL;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 344 "../lib/Widgets/TabSwitcher.vala"
				if (!_tmp2_) {
#line 1525 "TabSwitcher.c"
					gint _tmp3_;
#line 344 "../lib/Widgets/TabSwitcher.vala"
					_tmp3_ = i;
#line 344 "../lib/Widgets/TabSwitcher.vala"
					i = _tmp3_ + 1;
#line 1531 "TabSwitcher.c"
				}
#line 344 "../lib/Widgets/TabSwitcher.vala"
				_tmp2_ = FALSE;
#line 344 "../lib/Widgets/TabSwitcher.vala"
				_tmp4_ = self->notebook;
#line 344 "../lib/Widgets/TabSwitcher.vala"
				if (!(i < gtk_notebook_get_n_pages (_tmp4_))) {
#line 344 "../lib/Widgets/TabSwitcher.vala"
					break;
#line 1541 "TabSwitcher.c"
				}
#line 345 "../lib/Widgets/TabSwitcher.vala"
				_tmp6_ = self->notebook;
#line 345 "../lib/Widgets/TabSwitcher.vala"
				_tmp7_ = gtk_notebook_get_nth_page (_tmp6_, i);
#line 345 "../lib/Widgets/TabSwitcher.vala"
				_tmp5_ = HE_IS_TAB_PAGE (_tmp7_) ? ((HeTabPage*) _tmp7_) : NULL;
#line 345 "../lib/Widgets/TabSwitcher.vala"
				_tmp8_ = NULL;
#line 345 "../lib/Widgets/TabSwitcher.vala"
				if (_tmp5_ != NULL) {
#line 1553 "TabSwitcher.c"
					HeTab* _tmp9_;
					HeTab* _tmp10_;
#line 345 "../lib/Widgets/TabSwitcher.vala"
					_tmp9_ = he_tab_page_get_tab (_tmp5_);
#line 345 "../lib/Widgets/TabSwitcher.vala"
					_tmp10_ = _tmp9_;
#line 345 "../lib/Widgets/TabSwitcher.vala"
					_tmp8_ = _tmp10_;
#line 1562 "TabSwitcher.c"
				}
#line 345 "../lib/Widgets/TabSwitcher.vala"
				_tmp11_ = he_tab_get_pinned (_tmp8_);
#line 345 "../lib/Widgets/TabSwitcher.vala"
				_tmp12_ = _tmp11_;
#line 345 "../lib/Widgets/TabSwitcher.vala"
				if (_tmp12_) {
#line 1570 "TabSwitcher.c"
					gint _tmp13_;
#line 346 "../lib/Widgets/TabSwitcher.vala"
					_tmp13_ = pinned_tabs;
#line 346 "../lib/Widgets/TabSwitcher.vala"
					pinned_tabs = _tmp13_ + 1;
#line 1576 "TabSwitcher.c"
				}
			}
		}
	}
	{
		gint p = 0;
#line 350 "../lib/Widgets/TabSwitcher.vala"
		p = 0;
#line 1585 "TabSwitcher.c"
		{
			gboolean _tmp14_ = FALSE;
#line 350 "../lib/Widgets/TabSwitcher.vala"
			_tmp14_ = TRUE;
#line 350 "../lib/Widgets/TabSwitcher.vala"
			while (TRUE) {
#line 1592 "TabSwitcher.c"
				gint sel = 0;
#line 350 "../lib/Widgets/TabSwitcher.vala"
				if (!_tmp14_) {
#line 1596 "TabSwitcher.c"
					gint _tmp15_;
#line 350 "../lib/Widgets/TabSwitcher.vala"
					_tmp15_ = p;
#line 350 "../lib/Widgets/TabSwitcher.vala"
					p = _tmp15_ + 1;
#line 1602 "TabSwitcher.c"
				}
#line 350 "../lib/Widgets/TabSwitcher.vala"
				_tmp14_ = FALSE;
#line 350 "../lib/Widgets/TabSwitcher.vala"
				if (!(p < pinned_tabs)) {
#line 350 "../lib/Widgets/TabSwitcher.vala"
					break;
#line 1610 "TabSwitcher.c"
				}
#line 351 "../lib/Widgets/TabSwitcher.vala"
				sel = p;
#line 1614 "TabSwitcher.c"
				{
					gint i = 0;
#line 352 "../lib/Widgets/TabSwitcher.vala"
					i = p;
#line 1619 "TabSwitcher.c"
					{
						gboolean _tmp16_ = FALSE;
#line 352 "../lib/Widgets/TabSwitcher.vala"
						_tmp16_ = TRUE;
#line 352 "../lib/Widgets/TabSwitcher.vala"
						while (TRUE) {
#line 1626 "TabSwitcher.c"
							GtkNotebook* _tmp18_;
							HeTabPage* _tmp19_ = NULL;
							GtkNotebook* _tmp20_;
							GtkWidget* _tmp21_;
							HeTab* _tmp22_ = NULL;
							gboolean _tmp25_;
							gboolean _tmp26_;
#line 352 "../lib/Widgets/TabSwitcher.vala"
							if (!_tmp16_) {
#line 1636 "TabSwitcher.c"
								gint _tmp17_;
#line 352 "../lib/Widgets/TabSwitcher.vala"
								_tmp17_ = i;
#line 352 "../lib/Widgets/TabSwitcher.vala"
								i = _tmp17_ + 1;
#line 1642 "TabSwitcher.c"
							}
#line 352 "../lib/Widgets/TabSwitcher.vala"
							_tmp16_ = FALSE;
#line 352 "../lib/Widgets/TabSwitcher.vala"
							_tmp18_ = self->notebook;
#line 352 "../lib/Widgets/TabSwitcher.vala"
							if (!(i < gtk_notebook_get_n_pages (_tmp18_))) {
#line 352 "../lib/Widgets/TabSwitcher.vala"
								break;
#line 1652 "TabSwitcher.c"
							}
#line 353 "../lib/Widgets/TabSwitcher.vala"
							_tmp20_ = self->notebook;
#line 353 "../lib/Widgets/TabSwitcher.vala"
							_tmp21_ = gtk_notebook_get_nth_page (_tmp20_, i);
#line 353 "../lib/Widgets/TabSwitcher.vala"
							_tmp19_ = HE_IS_TAB_PAGE (_tmp21_) ? ((HeTabPage*) _tmp21_) : NULL;
#line 353 "../lib/Widgets/TabSwitcher.vala"
							_tmp22_ = NULL;
#line 353 "../lib/Widgets/TabSwitcher.vala"
							if (_tmp19_ != NULL) {
#line 1664 "TabSwitcher.c"
								HeTab* _tmp23_;
								HeTab* _tmp24_;
#line 353 "../lib/Widgets/TabSwitcher.vala"
								_tmp23_ = he_tab_page_get_tab (_tmp19_);
#line 353 "../lib/Widgets/TabSwitcher.vala"
								_tmp24_ = _tmp23_;
#line 353 "../lib/Widgets/TabSwitcher.vala"
								_tmp22_ = _tmp24_;
#line 1673 "TabSwitcher.c"
							}
#line 353 "../lib/Widgets/TabSwitcher.vala"
							_tmp25_ = he_tab_get_pinned (_tmp22_);
#line 353 "../lib/Widgets/TabSwitcher.vala"
							_tmp26_ = _tmp25_;
#line 353 "../lib/Widgets/TabSwitcher.vala"
							if (_tmp26_) {
#line 354 "../lib/Widgets/TabSwitcher.vala"
								sel = i;
#line 355 "../lib/Widgets/TabSwitcher.vala"
								break;
#line 1685 "TabSwitcher.c"
							}
						}
					}
				}
#line 359 "../lib/Widgets/TabSwitcher.vala"
				if (sel != p) {
#line 1692 "TabSwitcher.c"
					GtkNotebook* _tmp27_;
					GtkNotebook* _tmp28_;
					GtkWidget* _tmp29_;
#line 360 "../lib/Widgets/TabSwitcher.vala"
					_tmp27_ = self->notebook;
#line 360 "../lib/Widgets/TabSwitcher.vala"
					_tmp28_ = self->notebook;
#line 360 "../lib/Widgets/TabSwitcher.vala"
					_tmp29_ = gtk_notebook_get_nth_page (_tmp28_, sel);
#line 360 "../lib/Widgets/TabSwitcher.vala"
					gtk_notebook_reorder_child (_tmp27_, _tmp29_, p);
#line 1704 "TabSwitcher.c"
				}
			}
		}
	}
}

static void
_he_tab_switcher_on_tab_closed_he_tab_closed (HeTab* _sender,
                                              gpointer self)
{
#line 366 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_tab_closed ((HeTabSwitcher*) self, _sender);
#line 1717 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_close_others_he_tab_close_others (HeTab* _sender,
                                                      gpointer self)
{
#line 367 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_close_others ((HeTabSwitcher*) self, _sender);
#line 1726 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_close_others_right_he_tab_close_others_right (HeTab* _sender,
                                                                  gpointer self)
{
#line 368 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_close_others_right ((HeTabSwitcher*) self, _sender);
#line 1735 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_duplicate_he_tab_duplicate (HeTab* _sender,
                                                gpointer self)
{
#line 369 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_duplicate ((HeTabSwitcher*) self, _sender);
#line 1744 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_pin_he_tab_pin (HeTab* _sender,
                                    gpointer self)
{
#line 370 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_pin ((HeTabSwitcher*) self, _sender);
#line 1753 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_new_window_he_tab_new_window (HeTab* _sender,
                                                  gpointer self)
{
#line 371 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_new_window ((HeTabSwitcher*) self, _sender);
#line 1762 "TabSwitcher.c"
}

static void
he_tab_switcher_insert_callbacks (HeTabSwitcher* self,
                                  HeTab* tab)
{
#line 365 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 365 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 366 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (tab, "closed", (GCallback) _he_tab_switcher_on_tab_closed_he_tab_closed, self, 0);
#line 367 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (tab, "close-others", (GCallback) _he_tab_switcher_on_close_others_he_tab_close_others, self, 0);
#line 368 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (tab, "close-others-right", (GCallback) _he_tab_switcher_on_close_others_right_he_tab_close_others_right, self, 0);
#line 369 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (tab, "duplicate", (GCallback) _he_tab_switcher_on_duplicate_he_tab_duplicate, self, 0);
#line 370 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (tab, "pin", (GCallback) _he_tab_switcher_on_pin_he_tab_pin, self, 0);
#line 371 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (tab, "new-window", (GCallback) _he_tab_switcher_on_new_window_he_tab_new_window, self, 0);
#line 1785 "TabSwitcher.c"
}

static void
he_tab_switcher_remove_callbacks (HeTabSwitcher* self,
                                  HeTab* tab)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
#line 374 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 374 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 375 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("closed", HE_TYPE_TAB, &_tmp0_, NULL, FALSE);
#line 375 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _he_tab_switcher_on_tab_closed_he_tab_closed, self);
#line 376 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("close-others", HE_TYPE_TAB, &_tmp1_, NULL, FALSE);
#line 376 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _he_tab_switcher_on_close_others_he_tab_close_others, self);
#line 377 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("close-others-right", HE_TYPE_TAB, &_tmp2_, NULL, FALSE);
#line 377 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _he_tab_switcher_on_close_others_right_he_tab_close_others_right, self);
#line 378 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("duplicate", HE_TYPE_TAB, &_tmp3_, NULL, FALSE);
#line 378 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _he_tab_switcher_on_duplicate_he_tab_duplicate, self);
#line 379 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("pin", HE_TYPE_TAB, &_tmp4_, NULL, FALSE);
#line 379 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _he_tab_switcher_on_pin_he_tab_pin, self);
#line 380 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("new-window", HE_TYPE_TAB, &_tmp5_, NULL, FALSE);
#line 380 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _he_tab_switcher_on_new_window_he_tab_new_window, self);
#line 1826 "TabSwitcher.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 383 "../lib/Widgets/TabSwitcher.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	return _data9_;
#line 1836 "TabSwitcher.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 383 "../lib/Widgets/TabSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 1846 "TabSwitcher.c"
		HeTabSwitcher* self;
#line 383 "../lib/Widgets/TabSwitcher.vala"
		self = _data9_->self;
#line 383 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (_data9_->clicked_tab);
#line 383 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (self);
#line 383 "../lib/Widgets/TabSwitcher.vala"
		g_slice_free (Block9Data, _data9_);
#line 1856 "TabSwitcher.c"
	}
}

static void
__lambda33_ (Block9Data* _data9_,
             HeTab* tab)
{
	HeTabSwitcher* self;
#line 384 "../lib/Widgets/TabSwitcher.vala"
	self = _data9_->self;
#line 384 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 385 "../lib/Widgets/TabSwitcher.vala"
	if (tab != _data9_->clicked_tab) {
#line 386 "../lib/Widgets/TabSwitcher.vala"
		g_signal_emit_by_name (tab, "closed");
#line 1873 "TabSwitcher.c"
	}
}

static void
___lambda33__gfunc (gconstpointer data,
                    gpointer self)
{
#line 384 "../lib/Widgets/TabSwitcher.vala"
	__lambda33_ (self, (HeTab*) data);
#line 1883 "TabSwitcher.c"
}

static void
he_tab_switcher_on_close_others (HeTabSwitcher* self,
                                 HeTab* clicked_tab)
{
	Block9Data* _data9_;
	HeTab* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 383 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (clicked_tab != NULL);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	_data9_->_ref_count_ = 1;
#line 383 "../lib/Widgets/TabSwitcher.vala"
	_data9_->self = g_object_ref (self);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = _g_object_ref0 (clicked_tab);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (_data9_->clicked_tab);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	_data9_->clicked_tab = _tmp0_;
#line 384 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = he_tab_switcher_get_tabs (self);
#line 384 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 384 "../lib/Widgets/TabSwitcher.vala"
	_tmp3_ = g_list_copy (_tmp2_);
#line 384 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 384 "../lib/Widgets/TabSwitcher.vala"
	g_list_foreach (_tmp4_, ___lambda33__gfunc, _data9_);
#line 384 "../lib/Widgets/TabSwitcher.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 383 "../lib/Widgets/TabSwitcher.vala"
	block9_data_unref (_data9_);
#line 383 "../lib/Widgets/TabSwitcher.vala"
	_data9_ = NULL;
#line 1928 "TabSwitcher.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 391 "../lib/Widgets/TabSwitcher.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	return _data10_;
#line 1938 "TabSwitcher.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 391 "../lib/Widgets/TabSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1948 "TabSwitcher.c"
		HeTabSwitcher* self;
#line 391 "../lib/Widgets/TabSwitcher.vala"
		self = _data10_->self;
#line 391 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (_data10_->clicked_tab);
#line 391 "../lib/Widgets/TabSwitcher.vala"
		_g_object_unref0 (self);
#line 391 "../lib/Widgets/TabSwitcher.vala"
		g_slice_free (Block10Data, _data10_);
#line 1958 "TabSwitcher.c"
	}
}

static void
__lambda34_ (Block10Data* _data10_,
             HeTab* tab)
{
	HeTabSwitcher* self;
#line 394 "../lib/Widgets/TabSwitcher.vala"
	self = _data10_->self;
#line 394 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 395 "../lib/Widgets/TabSwitcher.vala"
	if (_data10_->is_to_the_right) {
#line 396 "../lib/Widgets/TabSwitcher.vala"
		g_signal_emit_by_name (tab, "closed");
#line 1975 "TabSwitcher.c"
	}
#line 398 "../lib/Widgets/TabSwitcher.vala"
	if (tab == _data10_->clicked_tab) {
#line 399 "../lib/Widgets/TabSwitcher.vala"
		_data10_->is_to_the_right = TRUE;
#line 1981 "TabSwitcher.c"
	}
}

static void
___lambda34__gfunc (gconstpointer data,
                    gpointer self)
{
#line 394 "../lib/Widgets/TabSwitcher.vala"
	__lambda34_ (self, (HeTab*) data);
#line 1991 "TabSwitcher.c"
}

static void
he_tab_switcher_on_close_others_right (HeTabSwitcher* self,
                                       HeTab* clicked_tab)
{
	Block10Data* _data10_;
	HeTab* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 391 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (clicked_tab != NULL);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	_data10_->_ref_count_ = 1;
#line 391 "../lib/Widgets/TabSwitcher.vala"
	_data10_->self = g_object_ref (self);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = _g_object_ref0 (clicked_tab);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (_data10_->clicked_tab);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	_data10_->clicked_tab = _tmp0_;
#line 392 "../lib/Widgets/TabSwitcher.vala"
	_data10_->is_to_the_right = FALSE;
#line 394 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = he_tab_switcher_get_tabs (self);
#line 394 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 394 "../lib/Widgets/TabSwitcher.vala"
	_tmp3_ = g_list_copy (_tmp2_);
#line 394 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 394 "../lib/Widgets/TabSwitcher.vala"
	g_list_foreach (_tmp4_, ___lambda34__gfunc, _data10_);
#line 394 "../lib/Widgets/TabSwitcher.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 391 "../lib/Widgets/TabSwitcher.vala"
	block10_data_unref (_data10_);
#line 391 "../lib/Widgets/TabSwitcher.vala"
	_data10_ = NULL;
#line 2038 "TabSwitcher.c"
}

static void
he_tab_switcher_on_tab_closed (HeTabSwitcher* self,
                               HeTab* tab)
{
	gboolean _tmp0_ = FALSE;
	gint pos = 0;
	gboolean _tmp1_ = FALSE;
#line 404 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 404 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 405 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_CLOSE_TAB_REQUESTED_SIGNAL], 0, tab, &_tmp0_);
#line 405 "../lib/Widgets/TabSwitcher.vala"
	if (!_tmp0_) {
#line 406 "../lib/Widgets/TabSwitcher.vala"
		return;
#line 2058 "TabSwitcher.c"
	}
#line 409 "../lib/Widgets/TabSwitcher.vala"
	pos = he_tab_switcher_get_tab_position (self, tab);
#line 411 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_remove_tab (self, tab);
#line 413 "../lib/Widgets/TabSwitcher.vala"
	if (pos != -1) {
#line 2066 "TabSwitcher.c"
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 413 "../lib/Widgets/TabSwitcher.vala"
		_tmp2_ = he_tab_get_page (tab);
#line 413 "../lib/Widgets/TabSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 413 "../lib/Widgets/TabSwitcher.vala"
		_tmp4_ = gtk_widget_get_parent (_tmp3_);
#line 413 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 2078 "TabSwitcher.c"
	} else {
#line 413 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = FALSE;
#line 2082 "TabSwitcher.c"
	}
#line 413 "../lib/Widgets/TabSwitcher.vala"
	if (_tmp1_) {
#line 2086 "TabSwitcher.c"
		GtkWidget* _tmp5_;
		GtkWidget* _tmp6_;
#line 414 "../lib/Widgets/TabSwitcher.vala"
		_tmp5_ = he_tab_get_page (tab);
#line 414 "../lib/Widgets/TabSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 414 "../lib/Widgets/TabSwitcher.vala"
		gtk_widget_unparent (_tmp6_);
#line 2095 "TabSwitcher.c"
	}
}

static void
he_tab_switcher_on_duplicate (HeTabSwitcher* self,
                              HeTab* tab)
{
#line 417 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 417 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 418 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_DUPLICATED_SIGNAL], 0, tab);
#line 2109 "TabSwitcher.c"
}

static void
he_tab_switcher_on_pin (HeTabSwitcher* self,
                        HeTab* tab)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 421 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 421 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 422 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = he_tab_switcher_get_allow_pinning (self);
#line 422 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 422 "../lib/Widgets/TabSwitcher.vala"
	if (!_tmp1_) {
#line 423 "../lib/Widgets/TabSwitcher.vala"
		return;
#line 2130 "TabSwitcher.c"
	}
#line 425 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_recalc_order (self);
#line 2134 "TabSwitcher.c"
}

static void
he_tab_switcher_on_new_window (HeTabSwitcher* self,
                               HeTab* tab)
{
	GtkNotebook* _tmp0_;
	HeTabPage* _tmp1_;
	GtkNotebook* _tmp2_ = NULL;
#line 428 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 428 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (tab != NULL);
#line 429 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->notebook;
#line 429 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = tab->page_container;
#line 429 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit_by_name (_tmp0_, "create-window", (GtkWidget*) _tmp1_, &_tmp2_);
#line 2154 "TabSwitcher.c"
}

static void
he_tab_switcher_update_tabs_visibility (HeTabSwitcher* self)
{
#line 432 "../lib/Widgets/TabSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 433 "../lib/Widgets/TabSwitcher.vala"
	if (self->priv->_tab_bar_behavior == HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_SINGLE) {
#line 2164 "TabSwitcher.c"
		GtkNotebook* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 434 "../lib/Widgets/TabSwitcher.vala"
		_tmp0_ = self->notebook;
#line 434 "../lib/Widgets/TabSwitcher.vala"
		_tmp1_ = he_tab_switcher_get_n_tabs (self);
#line 434 "../lib/Widgets/TabSwitcher.vala"
		_tmp2_ = _tmp1_;
#line 434 "../lib/Widgets/TabSwitcher.vala"
		gtk_notebook_set_show_tabs (_tmp0_, _tmp2_ > 1);
#line 2176 "TabSwitcher.c"
	} else {
#line 435 "../lib/Widgets/TabSwitcher.vala"
		if (self->priv->_tab_bar_behavior == HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_NEVER) {
#line 2180 "TabSwitcher.c"
			GtkNotebook* _tmp3_;
#line 436 "../lib/Widgets/TabSwitcher.vala"
			_tmp3_ = self->notebook;
#line 436 "../lib/Widgets/TabSwitcher.vala"
			gtk_notebook_set_show_tabs (_tmp3_, FALSE);
#line 2186 "TabSwitcher.c"
		} else {
#line 437 "../lib/Widgets/TabSwitcher.vala"
			if (self->priv->_tab_bar_behavior == HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS) {
#line 2190 "TabSwitcher.c"
				GtkNotebook* _tmp4_;
#line 438 "../lib/Widgets/TabSwitcher.vala"
				_tmp4_ = self->notebook;
#line 438 "../lib/Widgets/TabSwitcher.vala"
				gtk_notebook_set_show_tabs (_tmp4_, TRUE);
#line 2196 "TabSwitcher.c"
			}
		}
	}
}

static void
_he_tab_switcher___lambda35_ (HeTabSwitcher* self)
{
#line 253 "../lib/Widgets/TabSwitcher.vala"
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 2207 "TabSwitcher.c"
}

static void
__he_tab_switcher___lambda35__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 252 "../lib/Widgets/TabSwitcher.vala"
	_he_tab_switcher___lambda35_ ((HeTabSwitcher*) self);
#line 2216 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                          GtkWidget* page,
                                                          guint page_num,
                                                          gpointer self)
{
#line 257 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_switch_page ((HeTabSwitcher*) self, page, page_num);
#line 2227 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                        GtkWidget* child,
                                                        guint page_num,
                                                        gpointer self)
{
#line 258 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_page_added ((HeTabSwitcher*) self, child, page_num);
#line 2238 "TabSwitcher.c"
}

static void
_he_tab_switcher_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                            GtkWidget* child,
                                                            guint page_num,
                                                            gpointer self)
{
#line 259 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_on_page_removed ((HeTabSwitcher*) self, child, page_num);
#line 2249 "TabSwitcher.c"
}

static GtkNotebook*
_he_tab_switcher_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                              GtkWidget* page,
                                                              gpointer self)
{
	GtkNotebook* result;
	result = he_tab_switcher_on_create_window ((HeTabSwitcher*) self, page);
#line 260 "../lib/Widgets/TabSwitcher.vala"
	return result;
#line 2261 "TabSwitcher.c"
}

static void
_he_tab_switcher___lambda36_ (HeTabSwitcher* self)
{
	GtkNotebook* _tmp0_;
	guint _tmp1_;
	GtkNotebook* _tmp2_;
	guint _tmp3_;
	GtkNotebook* _tmp4_;
	guint _tmp5_;
	GtkNotebook* _tmp6_;
	guint _tmp7_;
#line 257 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->notebook;
#line 257 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("switch-page", gtk_notebook_get_type (), &_tmp1_, NULL, FALSE);
#line 257 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _he_tab_switcher_on_switch_page_gtk_notebook_switch_page, self);
#line 258 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = self->notebook;
#line 258 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("page-added", gtk_notebook_get_type (), &_tmp3_, NULL, FALSE);
#line 258 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _he_tab_switcher_on_page_added_gtk_notebook_page_added, self);
#line 259 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = self->notebook;
#line 259 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("page-removed", gtk_notebook_get_type (), &_tmp5_, NULL, FALSE);
#line 259 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _he_tab_switcher_on_page_removed_gtk_notebook_page_removed, self);
#line 260 "../lib/Widgets/TabSwitcher.vala"
	_tmp6_ = self->notebook;
#line 260 "../lib/Widgets/TabSwitcher.vala"
	g_signal_parse_name ("create-window", gtk_notebook_get_type (), &_tmp7_, NULL, FALSE);
#line 260 "../lib/Widgets/TabSwitcher.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _he_tab_switcher_on_create_window_gtk_notebook_create_window, self);
#line 2299 "TabSwitcher.c"
}

static void
__he_tab_switcher___lambda36__gtk_widget_destroy (GtkWidget* _sender,
                                                  gpointer self)
{
#line 256 "../lib/Widgets/TabSwitcher.vala"
	_he_tab_switcher___lambda36_ ((HeTabSwitcher*) self);
#line 2308 "TabSwitcher.c"
}

static GObject *
he_tab_switcher_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTabSwitcher * self;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkNotebook* _tmp2_;
	GtkNotebook* _tmp3_;
	HeDisclosureButton* add_button = NULL;
	HeDisclosureButton* _tmp4_;
	HeDisclosureButton* _tmp5_;
	GtkNotebook* _tmp6_;
	HeDisclosureButton* _tmp7_;
	GMenu* _tmp8_;
	GMenu* _tmp9_;
	GMenu* _tmp10_;
	GtkPopoverMenu* _tmp11_;
	GtkPopoverMenu* _tmp12_;
	GSimpleActionGroup* _tmp13_;
	GSimpleActionGroup* _tmp14_;
	GSimpleActionGroup* _tmp15_;
	GSimpleActionGroup* _tmp16_;
	GMenu* _tmp17_;
	GtkPopoverMenu* _tmp18_;
	GMenu* _tmp19_;
	HeDisclosureButton* _tmp20_;
	GtkNotebook* _tmp21_;
	GtkNotebook* _tmp22_;
	GtkNotebook* _tmp23_;
	GtkNotebook* _tmp24_;
	GtkNotebook* _tmp25_;
	GtkNotebook* _tmp26_;
	GtkNotebook* _tmp27_;
#line 229 "../lib/Widgets/TabSwitcher.vala"
	parent_class = G_OBJECT_CLASS (he_tab_switcher_parent_class);
#line 229 "../lib/Widgets/TabSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 229 "../lib/Widgets/TabSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
#line 230 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = (GtkNotebook*) gtk_notebook_new ();
#line 230 "../lib/Widgets/TabSwitcher.vala"
	g_object_ref_sink (_tmp0_);
#line 230 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->notebook);
#line 230 "../lib/Widgets/TabSwitcher.vala"
	self->notebook = _tmp0_;
#line 231 "../lib/Widgets/TabSwitcher.vala"
	_tmp1_ = self->notebook;
#line 231 "../lib/Widgets/TabSwitcher.vala"
	gtk_notebook_set_scrollable (_tmp1_, TRUE);
#line 232 "../lib/Widgets/TabSwitcher.vala"
	_tmp2_ = self->notebook;
#line 232 "../lib/Widgets/TabSwitcher.vala"
	gtk_notebook_set_show_border (_tmp2_, FALSE);
#line 233 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_tab_bar_behavior = HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS;
#line 234 "../lib/Widgets/TabSwitcher.vala"
	_tmp3_ = self->notebook;
#line 234 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp3_, "tab-holder");
#line 236 "../lib/Widgets/TabSwitcher.vala"
	_tmp4_ = he_disclosure_button_new_from_icon ("list-add-symbolic");
#line 236 "../lib/Widgets/TabSwitcher.vala"
	g_object_ref_sink (_tmp4_);
#line 236 "../lib/Widgets/TabSwitcher.vala"
	add_button = _tmp4_;
#line 237 "../lib/Widgets/TabSwitcher.vala"
	_tmp5_ = add_button;
#line 237 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _ ("New Tab"));
#line 239 "../lib/Widgets/TabSwitcher.vala"
	_tmp6_ = self->notebook;
#line 239 "../lib/Widgets/TabSwitcher.vala"
	_tmp7_ = add_button;
#line 239 "../lib/Widgets/TabSwitcher.vala"
	gtk_notebook_set_action_widget (_tmp6_, (GtkWidget*) _tmp7_, GTK_PACK_END);
#line 241 "../lib/Widgets/TabSwitcher.vala"
	_tmp8_ = g_menu_new ();
#line 241 "../lib/Widgets/TabSwitcher.vala"
	_tmp9_ = _tmp8_;
#line 241 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_set_menu (self, _tmp9_);
#line 241 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (_tmp9_);
#line 243 "../lib/Widgets/TabSwitcher.vala"
	_tmp10_ = self->priv->_menu;
#line 243 "../lib/Widgets/TabSwitcher.vala"
	_tmp11_ = (GtkPopoverMenu*) gtk_popover_menu_new_from_model ((GMenuModel*) _tmp10_);
#line 243 "../lib/Widgets/TabSwitcher.vala"
	g_object_ref_sink (_tmp11_);
#line 243 "../lib/Widgets/TabSwitcher.vala"
	_tmp12_ = _tmp11_;
#line 243 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_set_popover (self, _tmp12_);
#line 243 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (_tmp12_);
#line 244 "../lib/Widgets/TabSwitcher.vala"
	_tmp13_ = g_simple_action_group_new ();
#line 244 "../lib/Widgets/TabSwitcher.vala"
	_tmp14_ = _tmp13_;
#line 244 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_set_actions (self, _tmp14_);
#line 244 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (_tmp14_);
#line 245 "../lib/Widgets/TabSwitcher.vala"
	_tmp15_ = self->priv->_actions;
#line 245 "../lib/Widgets/TabSwitcher.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp15_, HE_TAB_SWITCHER_ENTRIES, (gint) G_N_ELEMENTS (HE_TAB_SWITCHER_ENTRIES), self);
#line 246 "../lib/Widgets/TabSwitcher.vala"
	_tmp16_ = self->priv->_actions;
#line 246 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "hetabswitcher", (GActionGroup*) _tmp16_);
#line 248 "../lib/Widgets/TabSwitcher.vala"
	_tmp17_ = self->priv->_menu;
#line 248 "../lib/Widgets/TabSwitcher.vala"
	g_menu_append (_tmp17_, "New Tab", "hetabswitcher.action-new-tab");
#line 250 "../lib/Widgets/TabSwitcher.vala"
	_tmp18_ = self->priv->_popover;
#line 250 "../lib/Widgets/TabSwitcher.vala"
	_tmp19_ = self->priv->_menu;
#line 250 "../lib/Widgets/TabSwitcher.vala"
	gtk_popover_menu_set_menu_model (_tmp18_, (GMenuModel*) _tmp19_);
#line 252 "../lib/Widgets/TabSwitcher.vala"
	_tmp20_ = add_button;
#line 252 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object ((GtkButton*) _tmp20_, "clicked", (GCallback) __he_tab_switcher___lambda35__gtk_button_clicked, self, 0);
#line 256 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) __he_tab_switcher___lambda36__gtk_widget_destroy, self, 0);
#line 263 "../lib/Widgets/TabSwitcher.vala"
	_tmp21_ = self->notebook;
#line 263 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (_tmp21_, "switch-page", (GCallback) _he_tab_switcher_on_switch_page_gtk_notebook_switch_page, self, 0);
#line 264 "../lib/Widgets/TabSwitcher.vala"
	_tmp22_ = self->notebook;
#line 264 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (_tmp22_, "page-added", (GCallback) _he_tab_switcher_on_page_added_gtk_notebook_page_added, self, 0);
#line 265 "../lib/Widgets/TabSwitcher.vala"
	_tmp23_ = self->notebook;
#line 265 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (_tmp23_, "page-removed", (GCallback) _he_tab_switcher_on_page_removed_gtk_notebook_page_removed, self, 0);
#line 266 "../lib/Widgets/TabSwitcher.vala"
	_tmp24_ = self->notebook;
#line 266 "../lib/Widgets/TabSwitcher.vala"
	g_signal_connect_object (_tmp24_, "create-window", (GCallback) _he_tab_switcher_on_create_window_gtk_notebook_create_window, self, 0);
#line 268 "../lib/Widgets/TabSwitcher.vala"
	_tmp25_ = self->notebook;
#line 268 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp25_, (GtkWidget*) self);
#line 270 "../lib/Widgets/TabSwitcher.vala"
	_tmp26_ = self->notebook;
#line 270 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp26_, TRUE);
#line 271 "../lib/Widgets/TabSwitcher.vala"
	_tmp27_ = self->notebook;
#line 271 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp27_, TRUE);
#line 229 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (add_button);
#line 229 "../lib/Widgets/TabSwitcher.vala"
	return obj;
#line 2476 "TabSwitcher.c"
}

static void
he_tab_switcher_class_init (HeTabSwitcherClass * klass,
                            gpointer klass_data)
{
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_type_class_adjust_private_offset (klass, &HeTabSwitcher_private_offset);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_tab_switcher_get_property;
#line 23 "../lib/Widgets/TabSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_tab_switcher_set_property;
#line 23 "../lib/Widgets/TabSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = he_tab_switcher_constructor;
#line 23 "../lib/Widgets/TabSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = he_tab_switcher_finalize;
#line 2495 "TabSwitcher.c"
	/**
	     * The number of tabs in the TabSwitcher
	     */
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_N_TABS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_N_TABS_PROPERTY] = g_param_spec_int ("n-tabs", "n-tabs", "n-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2501 "TabSwitcher.c"
	/**
	     * The list of tabs in the TabSwitcher
	     */
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_TABS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_TABS_PROPERTY] = g_param_spec_pointer ("tabs", "tabs", "tabs", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2507 "TabSwitcher.c"
	/**
	     * The behavior of the tab bar and its visibility
	     */
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY] = g_param_spec_enum ("tab-bar-behavior", "tab-bar-behavior", "tab-bar-behavior", HE_TAB_SWITCHER_TYPE_TAB_BAR_BEHAVIOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY] = g_param_spec_boolean ("allow-duplicate-tabs", "allow-duplicate-tabs", "allow-duplicate-tabs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY] = g_param_spec_boolean ("allow-drag", "allow-drag", "allow-drag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY] = g_param_spec_boolean ("allow-pinning", "allow-pinning", "allow-pinning", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY] = g_param_spec_boolean ("allow-closing", "allow-closing", "allow-closing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY] = g_param_spec_boolean ("allow-new-window", "allow-new-window", "allow-new-window", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2523 "TabSwitcher.c"
	/**
	     * The current visible tab
	     */
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_CURRENT_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_CURRENT_PROPERTY] = g_param_spec_object ("current", "current", "current", HE_TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2529 "TabSwitcher.c"
	/**
	     * The menu appearing when the tab bar is clicked on a blank space
	     */
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_MENU_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", g_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../lib/Widgets/TabSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ACTIONS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_ADDED_SIGNAL] = g_signal_new ("tab-added", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_REMOVED_SIGNAL] = g_signal_new ("tab-removed", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_SWITCHED_SIGNAL] = g_signal_new ("tab-switched", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, HE_TYPE_TAB, HE_TYPE_TAB);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_MOVED_SIGNAL] = g_signal_new ("tab-moved", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_DUPLICATED_SIGNAL] = g_signal_new ("tab-duplicated", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_signals[HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL] = g_signal_new ("new-tab-requested", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_signals[HE_TAB_SWITCHER_CLOSE_TAB_REQUESTED_SIGNAL] = g_signal_new ("close-tab-requested", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, HE_TYPE_TAB);
#line 275 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 2553 "TabSwitcher.c"
}

static void
he_tab_switcher_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                              gpointer iface_data)
{
#line 23 "../lib/Widgets/TabSwitcher.vala"
	he_tab_switcher_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 2562 "TabSwitcher.c"
}

static void
he_tab_switcher_instance_init (HeTabSwitcher * self,
                               gpointer klass)
{
#line 23 "../lib/Widgets/TabSwitcher.vala"
	self->priv = he_tab_switcher_get_instance_private (self);
#line 82 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_duplication = FALSE;
#line 98 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_drag = TRUE;
#line 112 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_pin = TRUE;
#line 126 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_close = TRUE;
#line 140 "../lib/Widgets/TabSwitcher.vala"
	self->priv->_allow_window = FALSE;
#line 199 "../lib/Widgets/TabSwitcher.vala"
	self->priv->tab_width = HE_TAB_SWITCHER_MAX_TAB_WIDTH;
#line 2583 "TabSwitcher.c"
}

static void
he_tab_switcher_finalize (GObject * obj)
{
	HeTabSwitcher * self;
	GtkNotebook* _tmp0_;
#line 23 "../lib/Widgets/TabSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
#line 279 "../lib/Widgets/TabSwitcher.vala"
	_tmp0_ = self->notebook;
#line 279 "../lib/Widgets/TabSwitcher.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 27 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->notebook);
#line 48 "../lib/Widgets/TabSwitcher.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 193 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->priv->_menu);
#line 195 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->priv->_popover);
#line 196 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 209 "../lib/Widgets/TabSwitcher.vala"
	_g_object_unref0 (self->priv->_actions);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	G_OBJECT_CLASS (he_tab_switcher_parent_class)->finalize (obj);
#line 2611 "TabSwitcher.c"
}

/**
 * TabBar widget designed for a variable number of tabs.
 */
static GType
he_tab_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTabSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_tab_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTabSwitcher), 0, (GInstanceInitFunc) he_tab_switcher_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_tab_switcher_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_tab_switcher_type_id;
	he_tab_switcher_type_id = g_type_register_static (HE_TYPE_BIN, "HeTabSwitcher", &g_define_type_info, 0);
	g_type_add_interface_static (he_tab_switcher_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeTabSwitcher_private_offset = g_type_add_instance_private (he_tab_switcher_type_id, sizeof (HeTabSwitcherPrivate));
	return he_tab_switcher_type_id;
}

GType
he_tab_switcher_get_type (void)
{
	static volatile gsize he_tab_switcher_type_id__once = 0;
	if (g_once_init_enter (&he_tab_switcher_type_id__once)) {
		GType he_tab_switcher_type_id;
		he_tab_switcher_type_id = he_tab_switcher_get_type_once ();
		g_once_init_leave (&he_tab_switcher_type_id__once, he_tab_switcher_type_id);
	}
	return he_tab_switcher_type_id__once;
}

static void
_vala_he_tab_switcher_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeTabSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_N_TABS_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_int (value, he_tab_switcher_get_n_tabs (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_TABS_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_pointer (value, he_tab_switcher_get_tabs (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_enum (value, he_tab_switcher_get_tab_bar_behavior (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_boolean (value, he_tab_switcher_get_allow_duplicate_tabs (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_boolean (value, he_tab_switcher_get_allow_drag (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_boolean (value, he_tab_switcher_get_allow_pinning (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_boolean (value, he_tab_switcher_get_allow_closing (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_boolean (value, he_tab_switcher_get_allow_new_window (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_CURRENT_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_object (value, he_tab_switcher_get_current (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_MENU_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_object (value, he_tab_switcher_get_menu (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ACTIONS_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		g_value_set_object (value, he_tab_switcher_get_actions (self));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 2717 "TabSwitcher.c"
		default:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 2723 "TabSwitcher.c"
	}
}

static void
_vala_he_tab_switcher_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeTabSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
#line 23 "../lib/Widgets/TabSwitcher.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_tab_bar_behavior (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_allow_duplicate_tabs (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_allow_drag (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_allow_pinning (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_allow_closing (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_allow_new_window (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_CURRENT_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_current (self, g_value_get_object (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_MENU_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_menu (self, g_value_get_object (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 23 "../lib/Widgets/TabSwitcher.vala"
		case HE_TAB_SWITCHER_ACTIONS_PROPERTY:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		he_tab_switcher_set_actions (self, g_value_get_object (value));
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 2791 "TabSwitcher.c"
		default:
#line 23 "../lib/Widgets/TabSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/TabSwitcher.vala"
		break;
#line 2797 "TabSwitcher.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

