/* TintButton.c generated by valac 0.56.15, the Vala compiler
 * generated from TintButton.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_TINT_BUTTON_0_PROPERTY,
	HE_TINT_BUTTON_COLOR_PROPERTY,
	HE_TINT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* he_tint_button_properties[HE_TINT_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeTintButtonPrivate {
	HeColors _color;
};

static gint HeTintButton_private_offset;
static gpointer he_tint_button_parent_class = NULL;

static GObject * he_tint_button_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void he_tint_button_finalize (GObject * obj);
static GType he_tint_button_get_type_once (void);
static void _vala_he_tint_button_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_tint_button_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_tint_button_get_instance_private (HeTintButton* self)
{
	return G_STRUCT_MEMBER_P (self, HeTintButton_private_offset);
}

static HeColors
he_tint_button_real_get_color (HeButton* base)
{
	HeColors result;
	HeTintButton* self;
#line 37 "../lib/Widgets/TintButton.vala"
	self = (HeTintButton*) base;
#line 38 "../lib/Widgets/TintButton.vala"
	result = self->priv->_color;
#line 38 "../lib/Widgets/TintButton.vala"
	return result;
#line 88 "TintButton.c"
}

static void
he_tint_button_real_set_color (HeButton* base,
                               HeColors value)
{
	HeTintButton* self;
#line 30 "../lib/Widgets/TintButton.vala"
	self = (HeTintButton*) base;
#line 31 "../lib/Widgets/TintButton.vala"
	if (self->priv->_color != HE_COLORS_NONE) {
#line 100 "TintButton.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 31 "../lib/Widgets/TintButton.vala"
		_tmp0_ = he_colors_to_css_class (self->priv->_color);
#line 31 "../lib/Widgets/TintButton.vala"
		_tmp1_ = _tmp0_;
#line 31 "../lib/Widgets/TintButton.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, _tmp1_);
#line 31 "../lib/Widgets/TintButton.vala"
		_g_free0 (_tmp1_);
#line 111 "TintButton.c"
	}
#line 32 "../lib/Widgets/TintButton.vala"
	if (value != HE_COLORS_NONE) {
#line 115 "TintButton.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 32 "../lib/Widgets/TintButton.vala"
		_tmp2_ = he_colors_to_css_class (value);
#line 32 "../lib/Widgets/TintButton.vala"
		_tmp3_ = _tmp2_;
#line 32 "../lib/Widgets/TintButton.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, _tmp3_);
#line 32 "../lib/Widgets/TintButton.vala"
		_g_free0 (_tmp3_);
#line 126 "TintButton.c"
	}
#line 34 "../lib/Widgets/TintButton.vala"
	self->priv->_color = value;
#line 30 "../lib/Widgets/TintButton.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tint_button_properties[HE_TINT_BUTTON_COLOR_PROPERTY]);
#line 132 "TintButton.c"
}

/**
    * Create a new TintButton.
    * @param label The text to display on the button.
    */
HeTintButton*
he_tint_button_construct (GType object_type,
                          const gchar* label)
{
	HeTintButton * self = NULL;
#line 46 "../lib/Widgets/TintButton.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 46 "../lib/Widgets/TintButton.vala"
	self = (HeTintButton*) he_button_construct (object_type);
#line 47 "../lib/Widgets/TintButton.vala"
	gtk_button_set_label ((GtkButton*) self, label);
#line 46 "../lib/Widgets/TintButton.vala"
	return self;
#line 152 "TintButton.c"
}

HeTintButton*
he_tint_button_new (const gchar* label)
{
#line 46 "../lib/Widgets/TintButton.vala"
	return he_tint_button_construct (HE_TYPE_TINT_BUTTON, label);
#line 160 "TintButton.c"
}

/**
    * Create a new TintButton from an icon.
    * @param icon The icon to display on the button.
    *
     * @since 1.0
     */
HeTintButton*
he_tint_button_construct_from_icon (GType object_type,
                                    const gchar* icon)
{
	HeTintButton * self = NULL;
#line 56 "../lib/Widgets/TintButton.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 56 "../lib/Widgets/TintButton.vala"
	self = (HeTintButton*) he_button_construct (object_type);
#line 57 "../lib/Widgets/TintButton.vala"
	he_button_set_icon ((HeButton*) self, icon);
#line 56 "../lib/Widgets/TintButton.vala"
	return self;
#line 182 "TintButton.c"
}

HeTintButton*
he_tint_button_new_from_icon (const gchar* icon)
{
#line 56 "../lib/Widgets/TintButton.vala"
	return he_tint_button_construct_from_icon (HE_TYPE_TINT_BUTTON, icon);
#line 190 "TintButton.c"
}

static GObject *
he_tint_button_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTintButton * self;
#line 60 "../lib/Widgets/TintButton.vala"
	parent_class = G_OBJECT_CLASS (he_tint_button_parent_class);
#line 60 "../lib/Widgets/TintButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../lib/Widgets/TintButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TINT_BUTTON, HeTintButton);
#line 61 "../lib/Widgets/TintButton.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "tint-button");
#line 60 "../lib/Widgets/TintButton.vala"
	return obj;
#line 211 "TintButton.c"
}

static void
he_tint_button_class_init (HeTintButtonClass * klass,
                           gpointer klass_data)
{
#line 23 "../lib/Widgets/TintButton.vala"
	he_tint_button_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/TintButton.vala"
	g_type_class_adjust_private_offset (klass, &HeTintButton_private_offset);
#line 23 "../lib/Widgets/TintButton.vala"
	HE_BUTTON_CLASS (klass)->get_color = (HeColors (*) (HeButton*)) he_tint_button_real_get_color;
#line 23 "../lib/Widgets/TintButton.vala"
	HE_BUTTON_CLASS (klass)->set_color = (void (*) (HeButton*, HeColors)) he_tint_button_real_set_color;
#line 23 "../lib/Widgets/TintButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_tint_button_get_property;
#line 23 "../lib/Widgets/TintButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_tint_button_set_property;
#line 23 "../lib/Widgets/TintButton.vala"
	G_OBJECT_CLASS (klass)->constructor = he_tint_button_constructor;
#line 23 "../lib/Widgets/TintButton.vala"
	G_OBJECT_CLASS (klass)->finalize = he_tint_button_finalize;
#line 234 "TintButton.c"
	/**
	     * The color of the button.
	     */
#line 23 "../lib/Widgets/TintButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TINT_BUTTON_COLOR_PROPERTY, he_tint_button_properties[HE_TINT_BUTTON_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 240 "TintButton.c"
}

static void
he_tint_button_instance_init (HeTintButton * self,
                              gpointer klass)
{
#line 23 "../lib/Widgets/TintButton.vala"
	self->priv = he_tint_button_get_instance_private (self);
#line 249 "TintButton.c"
}

static void
he_tint_button_finalize (GObject * obj)
{
	HeTintButton * self;
#line 23 "../lib/Widgets/TintButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TINT_BUTTON, HeTintButton);
#line 23 "../lib/Widgets/TintButton.vala"
	G_OBJECT_CLASS (he_tint_button_parent_class)->finalize (obj);
#line 260 "TintButton.c"
}

/**
* A TintButton is similar to a FillButton, except that the color of the button has a tinted appearance. In addition, the TintButton also support icons.
*/
static GType
he_tint_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTintButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_tint_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTintButton), 0, (GInstanceInitFunc) he_tint_button_instance_init, NULL };
	GType he_tint_button_type_id;
	he_tint_button_type_id = g_type_register_static (HE_TYPE_BUTTON, "HeTintButton", &g_define_type_info, 0);
	HeTintButton_private_offset = g_type_add_instance_private (he_tint_button_type_id, sizeof (HeTintButtonPrivate));
	return he_tint_button_type_id;
}

GType
he_tint_button_get_type (void)
{
	static volatile gsize he_tint_button_type_id__once = 0;
	if (g_once_init_enter (&he_tint_button_type_id__once)) {
		GType he_tint_button_type_id;
		he_tint_button_type_id = he_tint_button_get_type_once ();
		g_once_init_leave (&he_tint_button_type_id__once, he_tint_button_type_id);
	}
	return he_tint_button_type_id__once;
}

static void
_vala_he_tint_button_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeTintButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TINT_BUTTON, HeTintButton);
#line 23 "../lib/Widgets/TintButton.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/TintButton.vala"
		case HE_TINT_BUTTON_COLOR_PROPERTY:
#line 23 "../lib/Widgets/TintButton.vala"
		g_value_set_enum (value, he_button_get_color ((HeButton*) self));
#line 23 "../lib/Widgets/TintButton.vala"
		break;
#line 304 "TintButton.c"
		default:
#line 23 "../lib/Widgets/TintButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/TintButton.vala"
		break;
#line 310 "TintButton.c"
	}
}

static void
_vala_he_tint_button_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeTintButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TINT_BUTTON, HeTintButton);
#line 23 "../lib/Widgets/TintButton.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/TintButton.vala"
		case HE_TINT_BUTTON_COLOR_PROPERTY:
#line 23 "../lib/Widgets/TintButton.vala"
		he_button_set_color ((HeButton*) self, g_value_get_enum (value));
#line 23 "../lib/Widgets/TintButton.vala"
		break;
#line 330 "TintButton.c"
		default:
#line 23 "../lib/Widgets/TintButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/TintButton.vala"
		break;
#line 336 "TintButton.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

